 UNIT UnConTyp ;
 INTERFACE
 Const
   JD2000   = 2451545.0 ;
   JulianC  =   36525.0 ;
   DifEpoch = 2400000.5 ;
 Const
   GaussConst       = 0.0172020989500000e0 ;
                   { in AstrUnit**3/((Ephemer.Day**2)*MassOfSun if in Sqr }
   CavendishConst   = 6.672e-20 ;     { in km**3/(kg*s**2) }
   AstrUnit         = 1.49597870691e8 ;  { in km }
   VelOfLight       = 299792.4580 ;   { in km/s }
 Const
   GeoFM    = 3.98600448e5 ; { km**3/s**2 }
   GeoR0    = 6.37814000e3 ; { km }
   ParmA    = 1.0/298.257 ; // oblateness of the Earth
   VelOfRot = 0.7292115e-4 ; // radian per second Earth rotation velosity
 Const
   PiTwo    = Pi / 2 ;
   HalfPi   = PiTwo ;
   Pi22     = 2 * Pi ;
   TwoPi    = Pi22 ;
   GraRad   = Pi / 180 ;
   RadGra   = 180 / Pi ;
   SecRad   = GraRad / 3600 ;
   RadSec   = 3600 / GraRad ;
 Type
   TVect3    = Array [1..3] of Extended ;
   TMatr33   = Array [1..3] of TVect3 ;
   TFundArg  = Array [1..14] of Extended ;
   TypeDim3  = TVect3 ;
   TypeDim33 = TMatr33 ;
 Const
   StrDayWeek  : Array [1..7] of ShortString =          // to UnForTim
               ( '' , '' , '' ,
                 '' , '' , '' ,
                 '' ) ;
   StrMonth    : Array [1..12] of ShortString =
               ( ''  ,  '' ,  '' ,
                 ''  ,  ''     ,  '' ,
                 ''    ,  ''  ,  '' ,
                 '' ,  ''  ,  '' ) ;
 IMPLEMENTATION
 END.
