unit UnCoTVar ; // some types with constants and variables

interface

 Const
   MaxStarInHeap     = 23777 ;
   MaxObjectInHeap   = 23777 ;
   MaxSatElemInHeap  = 23777 ;

 Type
   RecStarCatType  =  Record
                        id           : LongInt ;
                        ra   , sd    : LongInt ; { alpha southdelta in mas }
                        cea  , ced   : Word ;    { difference in epoch 0.01JY }
                        sea  , sed   : Word ;    { units 0.1 mas error }
                        pma  , pmd   : SmallInt ; { 0.1 mas/Year }
                        sema , semd  : Word ;    { 0.1 mas/Year error }
                        bt           : SmallInt ; { B photometry 0.001 m }
                        sbt          : Word ;    { SE B photometry 0.001 m }
                        vt           : SmallInt ; { V photometry 0.001 m }
                        svt          : Word ;    { SE V photometry 0.001 m }
                        flags        : LongInt ;
                      End;

   { for only bright stars catalogue }
   RecStarAddType  =  Record
                        id           : LongInt ;
                        FK5num       : Word ;
                        ra   , sd    : LongInt ; { alpha southdelta in mas }
                        pma  , pmd   : LongInt ; { proper motion 0.01 mas/Year }
                        bt   , vt    : SmallInt ; { B V photometry 0.001 m }
                      End;

 Type
   // for the stars catalogue positions
   TStarOneRec   = Record
                     TycNumber    : LongInt ;
                     TrcNumber    : LongInt ;
                     HipNumber    : LongInt ;
                     FK5Number    : Word ;
                     Alpha        : Extended ;
                     Delta        : Extended ;
                     AlphaMotion  : Extended ;
                     DeltaMotion  : Extended ;
                     Bt , Vt      : Single ;
                   End;
   // for all objects positions in the screen
   TObjectTopRec = Record
                     nall            : LongInt ;
                     chps            : Char ; // * P or S
                     name            : String[16] ;
                     Azt , Alt , Rot : Extended ; // degree degree km
                     Mag , phase     : Single ;
                     IndexShadow     : Byte ;
                     boovis          : Boolean ;
                     booscreen       : Boolean ;
                     xpos , ypos     : Integer ;
                   End;
   // for the Earth satellites indentification and middle elements
   TElemRec        = Record
                        satnord  : LongInt ;  // number from NORAD
                        satnuml  : LongInt ;  // number launch date
                        satname  : String[16] ;
                        stdmag   : Single ;   // standard magnitude
                        t , ao , au , ai , ae , am , an , dn  : Extended ;
                     End ;

 Type
   TStarAllHeap      = Array [1..MaxStarInHeap] of TStarOneRec ;
   TStarAllHeapPtr   = ^TStarAllHeap ;
   TObjectTopHeap    = Array [1..MaxObjectInHeap] of TObjectTopRec ;
   TObjectTopHeapPtr = ^TObjectTopHeap ;
   TSatElemHeap      = Array [1..MaxSatElemInHeap] of TElemRec ;
   TSatElemHeapPtr   = ^TSatElemHeap ;
   TObjectSort       = Array [1..MaxObjectInHeap] of LongInt ;
   TObjectSortPtr    = ^TObjectSort ;

 Var { heap for number , position , proper motion and magnutude }
   StarOneCur       : TStarOneRec ; // current record
   StarOneFix       : TStarOneRec ; // record for star that chosen to fix
   StarAllHeap      : TStarAllHeapPtr ;
   ObjectTopCur     : TObjectTopRec ;
   ObjectTopHeap    : TObjectTopHeapPtr ;
   ObjectSort       : TObjectSortPtr ;   // to UnitSort and UnSelSat
   IntDimForOrder   : TObjectSortPtr ;   // to UnitSort and UnSelSat
   PlanetNumFix     : LongInt ;   // number of planet that chosen to fix
   SatElemCur       : TElemRec ; // current record for satellite
   SatElemFix       : TElemRec ; // record for satellite that chosen to fix
   SatElemLook      : TElemRec ; // record for satellite for looking 'L'
   SatElemHeap      : TSatElemHeapPtr ; // heap for satellites elements
   NumObjectInHeap  : LongInt ;
   NumFirstSatHeap  : LongInt ;
   NumSatElemInHeap : LongInt ;
   NumBrStarsInHeap : LongInt ;
   StrNameTychoCat  : ShortString ;

implementation

end.