unit UnFigDat;

interface

uses
  SysUtils ; // for DateToStr

procedure ForInitDateTime ( var  sab , sah , sbb , sbh  : ShortString ) ;

procedure JulianDateToStr ( JulianDate  : Extended ;
                            var  sab , sah , sbb , sbh  : ShortString ) ;

implementation

uses
  UnForDat , // for TransDateToJD procedure
  UnForTim , // for ToGetGrMSTime function
  UnForFun , // for PrHourAngle
  UnForStr ; // for simple operations Integer or Float ToFixString

function ForJulianDate ( sd , st  : ShortString ) : Extended ;
var
  d  : Integer ;
  m  : Integer ;
  y  : Integer ;
  h  : Integer ;
  s  : Integer ;
  e  : Integer ;
  z  : Extended ;
begin
  Val(Copy(sd,1,2),d,e); // for day
  Val(Copy(sd,4,2),m,e); // for month
  Val(Copy(sd,7,4),y,e); // for year
  TransDateToJD(d,m,y,z); // from UnForDat unit
  Val(Copy(st,1,2),h,e); // for hour
  Val(Copy(st,4,2),m,e); // for minute
  Val(Copy(st,7,2),s,e); // for second of time
  ForJulianDate:=z+(h+(m+s/60.0)/60.0)/24.0;
end;

procedure ForInitDateTime ( var  sab , sah , sbb , sbh  : ShortString ) ;
var
  sd,st  : ShortString ;
  dc,dt  : Extended ;
  ih,im  : Integer ;
  asec   : Extended ;
begin
  sd:=DateToStr(Now);
  sab:=sd+' ';
  st:=TimeToStr(Now);
  sbb:=st+'.00 ';
  dc:=ForJulianDate(sd,st);
  dt:=ToGetGrMSTime(dc); // from unit UnForTim
  Str(dc:10:2,sd);
  sah:='  '+sd+' '+ToGetWeekJulianDay(dc); // from UnForTim
  PrHourAngle(dt,sd,ih,im,asec);
  sd:=FloatToStr(asec);
  sd:=Copy(sd,1,6);
  sbh:='  '+IntToStr(ih)+'h'+IntToStr(im)+'m'+sd+'s';
end;

procedure JulianDateToStr ( JulianDate  : Extended ;
                            var  sab , sah , sbb , sbh  : ShortString ) ;
var
  sd,st  : ShortString ;
  dc,dt  : Extended ;
  ih,im  : Integer ;
  asec   : Extended ;
  nd,nm,ny  : Integer ;
  kh,km  : Integer ;
  sec,secp  : Extended ;
begin
  dc:=JulianDate;
  TransJDtoDate(dc,nd,nm,ny,secp); // from unit UnForDat
  FromSecPartToHourMinSec(secp,kh,km,sec); // from unit UnForDat
  sd:=IntegerToFixStr(nd,2)+'.' // function from UnForStr
     +IntegerToFixStr(nm,2)+'.'+IntegerToFixStr(ny,4); // civil date
  st:=IntegerToFixStr(kh,2)+'h' // function from UnForStr
     +IntegerToFixStr(km,2)+'m'+FloatToFixStr(sec,5,2); // civil time
  sab:=sd+' '; // civil date
  sbb:=st+'s'; // civil time
  dt:=ToGetGrMSTime(dc); // from unit UnForTim
  Str(dc:10:2,sd);
  sah:='  '+sd+' '+ToGetWeekJulianDay(dc); // from UnForTim
  PrHourAngle(dt,sd,ih,im,asec);
  sd:=FloatToFixStr(asec,6,3);
  sd:=Copy(sd,1,6);
  sbh:='  '+IntegerToFixStr(ih,2)+'h'
      +IntegerToFixStr(im,2)+'m'+sd+'s';
end;

end.
