unit UnFigIni; // initial actions to figure sky

interface

procedure FiguSize ; // for current size of Form

procedure FiguPlac ; // for top bottom and middle

procedure FiguInfo ; // info for top bottom color for middle

implementation

uses
  Forms ,    //
  Graphics , // Canvas and others
  UnitMain , // Form Canvas and others
  UnGloVar , // for variable X Y inDegC current scale for X Y axis
  UnFigMou , // for bmMouse
  UnButIni , // for type TRectBut procedure Top Bot PanelButtons
  UnPlaceA ; // for Function ToGetSkyColor

procedure ToGetWidthForPanel ( var  mw , mh  : Integer ) ;
var
  w  : Integer ;
begin
  fmPuz.Canvas.Font.Size:=8;
  w:=fmPuz.Canvas.TextWidth('W');
  mw:=78*w;
  mh:=3*(mw div 4);
end;

procedure FiguSizeFont ;
var
  ww,mw  : Integer ;
begin
  fmPuz.Canvas.Font.Size:=12;
  ww:=fmPuz.Canvas.TextWidth('W');
  mw:=78*ww;
  with  fmPuz  do
    begin
      if  Width < mw
        then
          begin
            fmPuz.Canvas.Font.Size:=8;
            SmallStarSize:=0; // UnGloVar
          end
        else
          begin
            fmPuz.Canvas.Font.Size:=12;
            SmallStarSize:=1; // UnGloVar
          end;
    end;
end;

procedure FiguSize ; // for current size of Form
Var
  rh  : Integer ; // half of ScreenHeight
  rw  : Integer ; // half of ScreenWidth
  mh  : Integer ; // minimum for height
  mw  : Integer ; // minimum for width
begin
  rh:=Screen.Height;
  rw:=Screen.Width;
  ToGetWidthForPanel(mw,mh);
  with  fmPuz  do
    begin
      if  Height < mh
        then
          begin
            Height:=mh;
            Top:=rh-mh-30;
          end;
      if  Width  < mw
        then
          begin
            Width :=mw;
            Left:=rw-mw-20;
          end;
    end;
  FiguSizeFont ;
end;

procedure ClearSky ;
begin
  fmPuz.Canvas.Pen.Color:=clLime;
  with  fmPuz  Do
    begin
      Canvas.Brush.Color:=clGreen;
      Canvas.Rectangle(0,0,Width,Height);
    end;
end;

procedure ThreePanelCoor ;  // left right top bottom
var
  hf,ah,aw  : Integer ; // for top and bottom strip height and width
begin // records UpperR BottomR SkyRect from unit UnButIni
  hf:=fmPuz.Canvas.TextHeight('X'); // for one symbol height
  ah:=hf+4; // small strip height
  aw:=fmPuz.ClientWidth-4; // small strip width
  UpperR.x1:=2; // left or top strip
  UpperR.y1:=2; // top for top strip
  UpperR.x2:=UpperR.x1+aw;
  UpperR.y2:=UpperR.y1+ah;
  BottomR.x1:=UpperR.x1; // for bottom strip
  BottomR.y1:=fmPuz.ClientHeight-2-ah;
  BottomR.x2:=BottomR.x1+aw;
  BottomR.y2:=BottomR.y1+ah;
  SkyRect.x1:=UpperR.x1+2; // for centre panel
  SkyRect.y1:=UpperR.y1+ah+4;
  SkyRect.x2:=SkyRect.x1+aw-4;
  SkyRect.y2:=BottomR.y1-4;  // rectangles from UnButIni
end;

procedure ForSkyFiguParm ; // some integers for figure position in SkyRect
begin // variables SkyParm SkyRect are declared in unit UnButIni
  SkyParm.xh:=SkyRect.x1+((SkyRect.x2-SkyRect.x1) div 2); // x pos half
  SkyParm.yh:=SkyRect.y1+((SkyRect.y2-SkyRect.y1) div 2); // y pos half
  SkyParm.xa:=SkyRect.x1+fmPuz.Canvas.TextWidth('W'); // x pos left
  SkyParm.dx:=SkyParm.xh-SkyParm.xa; // maximum half distance in x
  SkyParm.xb:=SkyParm.xh+SkyParm.dx; // x pos right
  SkyParm.ya:=SkyRect.y1+fmPuz.Canvas.TextHeight('W'); // y pos top
  SkyParm.dy:=SkyParm.yh-SkyParm.ya; // maximum half distance in y
  SkyParm.yb:=SkyParm.yh+SkyParm.dy; // y pos bottom
  SkyParm.rx:=-1; // for azimuth  x axes is reversed
  SkyParm.ry:=+1; // for altitude y axes is not reversed
  YinDegC:=RinDegC; // RinDegC general half size YinDegC scale for Y axes
  XinDegC:=SkyParm.dx*(YinDegC/SkyParm.dy); // X Y inDegC from UnGloVar
  ForHintOfSize ; // in unit UnButIni when X Y inDegC are known
end;

procedure ThreePanelColor ;  // brush and pen for rectangles
begin
  with  fmPuz.Canvas  do
    begin
      Brush.Color:=clNavy;
      Pen.Color:=clLime;
      with  UpperR  do
        Rectangle(x1,y1,x2,y2); // for top strip
      with  BottomR  do
        Rectangle(x1,y1,x2,y2); // for bottom strip
      case  CharForView  of
        'S' : Brush.Color:=ToGetSkyColor ; // function from UnPlaceA
        'L' : Brush.Color:=ToGetSkyColoo ; // function from UnPlaceA
        'W' : Brush.Color:=clBlue;
      end;
      Pen.Color:=clWhite;
      with  SkyRect  do
        Rectangle(x1,y1,x2,y2); // for centre panel
    end;
end;

procedure TwoPanelButtons ; // to place buttons to fix position
begin
  TopPanelButtons ; // from unit UnButIni
  BotPanelButtons ; // from unit UnButIni
end;

procedure FiguPlac ; // for top bottom and middle
begin
  ClearSky ;  // to new clear small screen
  ThreePanelCoor ;  // left right top bottom
  ForSkyFiguParm ;  // some integers in SkyRect
  ThreePanelColor ;  // brush and pen for each simple rectangle
  TwoPanelButtons ;  // to place buttons and to fix its position
end;

procedure FiguInfo ; // info for top bottom color for middle
begin
  ThreePanelColor ;  // brush and pen for each simple rectangle
  TwoPanelButtons ;  // to place buttons and to fix its position
end;

end.
