
unit UnFilElm ; // to define what is format of elements in the file

interface

function ToGetElemFormat ( sf  : ShortString ) : Char ; // N I K R Z

implementation

uses
  UnrfIrvs , // function ToFindNumString to check IRVS data
  UnrfKodr ; // function BooKDrFormat

function  BooNoradFormat ( sf  : ShortString ) : Boolean ;
var
  ft  : TextFile ;
  st  : ShortString ;
  bt  : Boolean ;
begin               // to check NORAD format may be
  bt:=False;        // by using two strings with 1.. and 2..
  AssignFile(ft,sf);
  ReSet(ft);
  while  ( not EOF(ft) ) and ( not bt )  do
    begin
      ReadLn(ft,st); // current string from file
      if  Pos('1',st) = 1 // the first position in some NORAD format is 1
        then
          begin
            ReadLn(ft,st); // the next string from file
            if  Pos('2',st) = 1 // the string with 2 after string with 1
              then // it is NORAD format in file
                bt:=True; // elements with NORAD format
          end;
    end;
  CloseFile(ft);
  BooNoradFormat:=bt;
end;

function  BooIRVSFormat ( sf  : ShortString ) : Boolean ;
var
  ft  : TextFile ;
  st  : ShortString ;
  bt  : Boolean ;
  bf  : Boolean ;
begin               // to check IRVS format may be
  bt:=False;        // by using strings with substring 'IRVS'
  AssignFile(ft,sf);
  ReSet(ft);
  while  ( not EOF(ft) ) and ( not bt )  do
    begin
      ReadLn(ft,st); // current string from file
      if  Pos('IRVS',st) > 0 // substring 'IRVS' may be for IRVS format
        then
          bt:=True; // elements with IRVS format may be now
    end;
  if  bt
    then
      begin // to check IRVS date
        bt:=False;
        ReSet(ft);
        while  ( not EOF(ft) ) and ( not bt )  Do
          begin
            ReadLn(ft,st);
            bf:=ToFindNumString(1,st); // function from InrfIrvs
            if  bf
              then { there is the first string }
                begin
                  ReadLn(ft,st); { a try for the second string }
                  bt:=ToFindNumString(2,st);
                end; // bt true if there are two strings with IRVs data
          end;
      end;
  CloseFile(ft);
  BooIRVSFormat:=bt;
end;

function  BooPosVelFormat ( sf  : ShortString ) : Boolean ;
var
  ft  : TextFile ;
  st  : ShortString ;
  bt  : Boolean ;
begin               // to check may be relative
  bt:=False;        // position and velosity refer to the Earth
  AssignFile(ft,sf);
  ReSet(ft);
  while  ( not EOF(ft) ) and ( not bt )  do
    begin
      ReadLn(ft,st); // current string from file
      bt:= ( Pos('Relative',st) > 0 ) ;// the first position
    end;
  CloseFile(ft);
  BooPosVelFormat:=bt;
end;

function ToGetElemFormat ( sf  : ShortString ) : Char ; // sf file name
begin
  if  BooNoradFormat(sf)
    then
      ToGetElemFormat:='N' // elements with NORAD format
    else
      if  BooIRVSFormat(sf)
        then
          ToGetElemFormat:='I' // elements with IRVS format
        else
          if  BooPosVelFormat(sf) // pos vel Relative to the Earth
            then
              ToGetElemFormat:='R'
            else
              if  BooKDrFormat(sf) // function from UnrfKodr
                then
                  ToGetElemFormat:='K' // elements with Kosmos Dr format
                else
                  ToGetElemFormat:='Z'; // no elements in the file
end;

end.
