
 { the actions in process of creating and closing Form }

 UNIT UnFilIni ; { to assign and to open star catalogues files }

 INTERFACE

 Procedure ToUseSomePath ( sn       : String ;
                           Var  sf  : String ;
                           Var  bf  : Boolean ) ;

 Function ForOpenFiles : Boolean ;

 procedure AllBrightStars ;

 Procedure ForCloseFiles ;

 function ToOpenOtherFile : Boolean ;

 IMPLEMENTATION

 Uses
   SysUtils , // boolean function FileExists
   PUnCRead , // boolean var Exist.. longint function ToGetBrightStars
   UnCoTVar , // var NumBrStarsInHeap StrNameTychoCat
   UnGloVar ; // for shortstring stPathCat path to folder initial with TRC1

 { to find if it is possible file with the name sn
   by using text file AstroPuz.ini with the pathes }

 Procedure ToUseSomePath ( sn       : String ;
                           Var  sf  : String ;
                           Var  bf  : Boolean ) ;
 Var
   fp  : TextFile ;
   ff  : File ;
   sp  : String ;
   sa  : String ;
   sb  : String ;
   np  : Byte ;
   ls  : Byte ;
   bs  : Boolean ;
 Begin
   filemode:=0;
   sf:=sn; { simple name of file }
   bf:=FALSE; { no file default }
   bs:=FALSE;
   AssignFile(ff,sf);
 {$I-}
   ReSet(ff);
 {$I+}
   if  IOResult = 0
     then // there is our file
       begin
         CloseFile(ff);
         bf:=True;
         Exit ;
       end;
   AssignFile(fp,'AstroPuz.ini'); { text file for list of path }
 {$I-}
   ReSet(fp);
 {$I+}
   If  IOResult <> 0  Then  Exit ; { no *.ini file }
   ReadLn(fp,sp);
   CloseFile(fp);
   np:=Pos('=',sp); // information after '='
   If  np > 0  Then  Delete(sp,1,np);
   ls:=Length(sp);
   If  ls < 2  Then  Exit; { string is too short }
   Repeat
     np:=Pos(';',sp);
     If  np > 0
       Then // information before ';'
         Begin
           sa:=Copy(sp,1,np-1);
           Delete(sp,1,np);
         End
       Else
         Begin
           sa:=sp;
           bs:=TRUE; { the end of the path string }
         End;
     np:=Pos(' ',sa);
     While  np > 0  Do
       Begin { without blanks }
         Delete(sa,np,1);
         np:=Pos(' ',sa);
       End;
     ls:=Length(sa);
     If  ls > 0
       Then
         Begin
           If  sa[ls] <> '\'  Then  sa:=sa+'\'; // to insert '\'
           sb:=sa+sn; // for full name with the path
           AssignFile(ff,sb); // simple check to open file
 {$I-}
           ReSet(ff);
 {$I+}
           If  IOResult = 0
             Then { path and file are found }
               Begin
                 bf:=TRUE; // file exists
                 sf:=sb;
                 CloseFile(ff);
               End;
         End;
   Until  ( bf OR bs ) ; // may be any folders as path
 End;

 Function StarCatFiles : Boolean ;
 Var
   strd  : ShortString ;
   stri  : ShortString ;
   boof  : Boolean ;
 Begin
   ExistBrFile:=FALSE;
   ExistTRCFile:=FALSE;
   filemode:=0;
   ToUseSomePath('onlybrs.dat',strd,boof); // FK5+ catalogue
   If  boof
     Then
       Begin
         AssignFile(BrStarFile,strd); // BrStarFile PUnCRead
         ReSet(BrStarFile); // files  catalogue data and adress
         ExistBrFile:=TRUE; // there are files
        End
     Else
       begin
         NumBrStarsInHeap:=0; // var is declared in UnCoTVar
         ExistBrFile:=False; // no files
       end;
   ToUseSomePath(StrNameTychoCat+'bin.dat',strd,boof); // TRC1 or Tycho2
   If  boof // var StrNameTychoCat is declared UnCoTVar
     Then   // is assigned initial as 'TRC1' by function ForOpenFiles
       ToUseSomePath(StrNameTychoCat+'bin.idr',stri,boof); // adress
   If  boof
     Then
       Begin
         stPathCat:=Copy(strd,1,Length(strd)-12);
         stCatalogFile:=strd; // stCatalogFile stPathCat from UnGloVar
         AssignFile(RFile,strd);
         ReSet(RFile);
         AssignFile(WFile,stri);
         ReSet(WFile);
         ExistTRCFile:=TRUE;
       End
     Else
       ExistTRCFile:=FALSE;
   FileMode:=2; { files are opened now }
   StarCatFiles:= ExistBrFile or ExistTRCFile ;
 End;

 { the actions in process of creating Form }

 Function ForOpenFiles : Boolean ;
 Begin
   stPathCat:=''; // unkown default
   StrNameTychoCat:='TRC1'; // initial value may be TYC2 for Tycho2
   ForOpenFiles:=StarCatFiles ; { to open binary files }
 End;

 procedure AllBrightStars ; // just to memory
 begin // after get memory  BrStarFile is opened
   if  not ExistBrFile  then  Exit ; // no file that need
   NumBrStarsInHeap:=ToGetBrightStars; // UnCoTVar function PUnCRead
   CloseFile(BrStarFile); // all bright stars are in memeory
 end;

 Procedure ForCloseFiles ;
 Begin
   If  ExistTRCFile
     Then
       Begin
         CloseFile(RFile); { catalog data file }
         CloseFile(WFile); { file with the number of stars in regions }
         ExistTRCFile:= not ExistTRCFile;
       End;
 End;

 function ToOpenOtherFile : Boolean ;
 var
   lr  : Byte ;
   sr  : ShortString ;
   sw  : ShortString ;
   st  : ShortString ;
   bo  : Boolean ;
   br  : Boolean ;
   bw  : Boolean ;
 begin
   sr:=stCatalogFile; // full name of catalogue  stCatalogFile UnGloVar
   lr:=Length(sr);    // for idr instead of dat
   sw:=Copy(sr,1,lr-3)+'idr'; // full name of file with indexes
   st:=UpperCase(Copy(sr,lr-10,4)); // to define a choice TRC1 or TYC2
   filemode:=0;
   br:=FileExists(sr); // SysUtils
   bw:=FileExists(sw); // SysUtils
   bo:= br and bw ;
   if  bo
     then // catalogue with index exists
       begin
         ForCloseFiles ; // to close the next catalogue if it is opened
         AssignFile(RFile,sr); // RFile from PUnCRead
         ReSet(RFile); // catalogue
         AssignFile(WFile,sw); // WFile from PUnCRead
         ReSet(WFile);
         ExistTRCFile:=True; // files to read catalogue are opened
         StrNameTychoCat:=st; // 'TRC1' or 'TYC2'  UnCoTVar
       end;
   filemode:=2;
   ToOpenOtherFile:=bo;
 end;

 END.