unit UnForBut; // what to do when one button is choiced

interface

procedure ForButtonChoice ( cb  : Char ) ; // called in UnMouSky

implementation

uses
  Forms ,    // for Close for OpenDialog
  Dialogs  , // for ShowMessage
  Classes  , // for TMemoryStream
  SysUtils , // for function IntToStr
  UnSelFel , // for fmSelFel form to select file with elements
  UnSelFol , // for fmSelFol form
  UnSelSat , // for fmSelSat form to select satellite
  UnSelHol , // for fmSelHol form to select some points
  UnPrtPos , // for fmPrtPos ShowModal by ForButtonY
  UnSelDat , // for fmSelDat ShowModal by ForButton1
  UnSelEph , // for fmSelEph ShowModal by ForButtonW ephemeris
  UnSatEph , // for fmSatEph ShowModal by ForButtonW ephemeris
  UnSatMap , // for fmSatMap ShowModal by ForButtonA ForButtonV
  UnSatMas , // for fmSatMas procedure PassForPoint
  UnHelPuz , // for fmHelPuz Show help information
  UnConTyp , // JD2000
  UnitMain , // for fmPuz
  UnButIni , // var SkyRect for the size field of view
  UnFilIni , // for ToOpenOtherFile
  UnGetIni , // procedure ForIniC
  UnCoTVar , // for var ObjectTopHeap NumObjectInHeap
  UnGloVar , // for some simple global variables BooFixObject
  UnitStat , // for procedure ToSelectOneStation
  UnitSelH , // to fill array NameValue to select some things
  UnForCoo , // ClcThreeRotMatr
  UnForDat , // for procedure DateFromString if there is mask for date
  UnForRed , // ToObtainAberrationParm
  UnForSat , // SatelliteToMapWorld
  UnForZem , // procedure CentreToLimbuP
  PUnCRead , // for global variables boolean BrightStarsOnly ExistTRCFile
  PUnDE200 , // for boolean BooExistEph
  UnPlaceA , // procedure FiguViewPlac
  UnPlaceO , // for var OBoxInform current number in ObjectTopHeap^[]
  UnMuDraw , // AfterLookKey procedure
  UnPopCap , // for procedure ToChangePopupMenuS
  UnitFixO , // for proc ToDefineFixObject
  UnFilElm , // for ToGetElemFormat function
  UnFilesO , // proc ToSelect OneCatalogue OneSetOfElem
  UnrfNord , // for proc ToReadNoradFormat
  UnrfIrvs , // for proc ToWorkWithIRVSfmt
  UnrfKodr ; // for proc ToWorkWithKodrfmt

procedure ForButtonF ; // to select from two catalogues TRC1 or TYC2
begin
  if  not ( CharForView in [ 'S' , 'L' ] )  then  Exit ;
  ToSelectOneCatalogue ; // procedure from UnFilesO
  if  fmSelFel.BooSelFel
    then
      begin // stCatalogFile is declared in UnGloVar
        stCatalogFile:=fmSelFel.StrSelFel; // name of catalogue file
        if  not ToOpenOtherFile // boolean function from UnFilIni
          then            // by using stCatalogFile
            Exit ; // a try is unsuccessful
        if  BrightStarsOnly // global variables are declared in unit PUnCRead
          then
            begin
              BrightStarsOnly:= not BrightStarsOnly;
              RinDegC:=1.5;
            end;
        FiguViewPlac; // unit UnPlaceA
      end;
end;

procedure ForButtonDate ; // to change date with time
begin
  fmSelDat:=TfmSelDat.Create(Application);
try
  fmSelDat.ShowModal;
  if  fmSelDat.BooSelDat
    then  // but may be error
      JulianDate:=fmSelDat.JulSelDat;
finally
  fmSelDat.Free;
end;
  ClcThreeRotMatr(JD2000,JulianDate, // UnConTyp UnGloVar
                  PlaceCoor,RotMatr,RosMatr,TopMatr); // UnForCoo
  ToObtainAberrationParm(JulianDate); // UnForRed
  case  CharForView  of
    'S' , 'L' : FiguViewInfo; // from UnPlaceA
    'W' : FiguViewMap;  // from UnPlaceA
  end;
end;

procedure ForButtonP;
begin
  if  CharForView <> 'S'  then  Exit ;
  ToSelectOneStation ; // UnitStat
  if  fmSelHol.BooSelHol
    then // the new station is selected
      begin // word NumStatValue from UnGloVar
        NumStatValue:=fmSelHol.NumSelHol; // current station number in list
        PlaceCoor:=StationList[NumStatValue]; // to change station to view
        StationForView ; // UnitStat  PlaceCoor from UnGloVar
        FiguViewInfo;    // UnPlaceA
      end;
end;

procedure NoVisibilityMessage ;
begin  // ShowMessage from unit Dialogs
  ShowMessage(fmSelSat.StrSelSat+'   ');
  InitForFixCase; // UnitFixO no visibility no fix object
end;

procedure ForButtonC ; // to choose object from the list
begin                  // for sky and look options not for map
  if  not ( CharForView in [ 'S' , 'L' ] )  then  Exit ;
  fmSelSat.CapSelSat:=' .';
  fmSelSat.ShowModal;
  if  fmSelSat.BooSelSat
    then // object is selected from the list
      begin
        BooFixObject:=True; // var from UnGloVar  OBoxInform from UnPlaceO
        OBoxInform:=fmSelSat.NumSelTop;  // number in ObjectTopHeap^[]
        ToDefineFixObject ; // UnitFixO for ObjectTopHeap^[OBoxInform]
        if  ( not ToGetCentrePos ) // UnitFixO for AzimutC AltitudeC
          then
            NoVisibilityMessage
          else
            if  chFixObject = 'S' // character is assigned in UnitFixO
              then  StepValueForFixSat ; // UnitSelH small step
        FiguViewPlac ; // UnPlaceA sky look options
      end
    else
      BooFixObject:=False;
end;

procedure ForButtonE ; // to choice set of elements for the satellite
begin
  if  not ( CharForView in [ 'S' , 'L' ] )  then  Exit ;
  ToSelectOneSetOfElem ; // procedure from UnFilesO
  if  fmSelFel.BooSelFel // from UnSelFel
    then
      begin // stElementFile is declared in UnGloVar
        stElementFile:=fmSelFel.StrSelFel; // name of file with elements
        case  ToGetElemFormat(stElementFile)  of  // function from UnFilElm
          'N' : ToReadNoradFormat(stElementFile); // UnrfNord
          'I' : ToWorkWithIRVSfmt(stElementFile); // UnrfIrvs
          'K' : ToWorkWithKodrfmt(stElementFile); // UnrfKodr
          'R' : ToReadPosVelForma(stElementFile); // UnrfIrvs
          'Z' : ShowMessage(stElementFile+'   ');
        end;
        FiguViewPlac; // unit UnPlaceA
      end;
end;

procedure ForButtonT ; // to change catalogue ;
begin // for star '*'  chFixObject:=' ';  BooFixObject:=False;
  if  not ( CharForView in [ 'S' , 'L' ] )  then  Exit ;
  if  chFixObject = '*'  then  InitForFixCase; // UnitFixO only for star
  if  BrightStarsOnly // global variables are declared in unit PUnCRead
    then
      if  ExistTRCFile
        then
          begin
            BrightStarsOnly:= not BrightStarsOnly;
            RinDegC:=1.5;
            FiguViewPlac; // unit UnPlaceA
          end
        else
          ForButtonF
    else
      if ExistBRFile
        then
          begin
            BrightStarsOnly:= not BrightStarsOnly;
            RinDegC:=15;
            FiguViewPlac; // unit UnPlaceA
          end;
  NumSizeValue:=1; // for number in size area list
end;

procedure ForPlusT ;   // forward with time
begin
  JulianDate:=JulianDate+StepWithTime; // global var from unit UnGloVar
  if  ( JulianDate > (TlastEph-1.0) )  // too big moment
    then                        // to compare with the ephemeris
      JulianDate:=TlastEph-1.0; // ephemeris maximum moment
  ClcThreeRotMatr(JD2000,JulianDate, // UnConTyp UnGloVar
                  PlaceCoor,RotMatr,RosMatr,TopMatr); // UnForCoo
  ToObtainAberrationParm(JulianDate); // UnForRed
  case  CharForView  of
    'S' , 'L' : FiguViewInfo; // from UnPlaceA
    'W' : FiguViewMap;  // from UnPlaceA
  end;
end;

procedure ForMinusT ;  // backward with time
begin
  JulianDate:=JulianDate-StepWithTime; // global var from unit UnGloVar
  if  ( JulianDate < (TinitEph+1.0) )  // too small moment
    then                        // to compare with the ephemeris
      JulianDate:=TinitEph+1.0; // ephemeris minimum moment
  ClcThreeRotMatr(JD2000,JulianDate, // UnConTyp UnGloVar
                  PlaceCoor,RotMatr,RosMatr,TopMatr); // UnForCoo
  ToObtainAberrationParm(JulianDate); // UnForRed
  case  CharForView  of
    'S' : FiguViewInfo; // from UnPlaceA
    'L' : begin         // look from the satelite
            if  JulianDate < 2436117.0
              then      // 5 october 1957 year
                JulianDate:=2436117.0; // to limit date
            FiguViewInfo ; // form UnPlaceA
          end;
    'W' : FiguViewMap;  // from UnPlaceA
  end;
end;

procedure ForButtonS ; // to choose step to change time
var
  n  : Word ;
begin
  ToGetValueAllStepInDay ; // from UnitSelH
  fmSelHol.CapSelHol:='  .'; // form from UnSelHol
  fmSelHol.AddSelHol:=0;
  fmSelHol.ListBox.Clear; // pure list now
  for n:=1 to NumNameValue do // var from UnGloVar is assigned in UnitSelH
    fmSelHol.ListBox.Items.Add('   '+NameValue[n].strname); // UnSelHol
  fmSelHol.ListBox.ItemIndex:=NumStepValue-1; // to select value in ListBox
  fmSelHol.ListBox.Columns:=3; // to select from list fmSelHol.LisBox
  fmSelHol.ShowModal; // to select one things from the list
  if  fmSelHol.BooSelHol
    then // a new value is selected
      begin // var StepWithTime from UnGloVar
        NumStepValue:=fmSelHol.NumSelHol; // from UnSelHol  StepWithTime
        StepWithTime:=NameValue[NumStepValue].valname; // to change step
      end;
end;

procedure ForButtonMap ; // to figure world map
begin
  if  not BooExistEph  then  Exit ; // no planets information PUnDE200
  case  CharForView  of
    'S' :
       begin                  // from "sky" to "map"
        fmHelPuz.HelPuzI:=21; // initial number for help map
        fmHelPuz.HelPuzN:=fmHelPuz.HelPuzI;
        BooMapPoint:=False;  // UnGloVar
        CharForView:='W';    // from UnGloVar for world map
        ToGetFixSatellites;  // procedure from UnitFixO
        FiguViewMap ;        // UnPlaceA
        BooFixObject:=False; // UnGloVar
        fmSatEph.BinStream:=TMemoryStream.Create; // UnSatEph Classes
        fmSatMas.NulloNumbers;  // count for number of ephemeris case
      end;
    'W'  :
      begin                    // from "map" to "sky"
        fmHelPuz.HelPuzI:=11;  // initial number for help sky
        fmHelPuz.HelPuzN:=fmHelPuz.HelPuzI; // to use help files
        BooMapPoint:=False;  // UnGloVar
        CharForView:='S';  // from UnGloVar for sky
        VMagMax:=25;       // to limit stars with magnitude
        InitForFixCase;    // procedure from UnitFixO
        FiguViewPlac ;  // after changing some parameters UnPlaceA
        fmSatMas.Close;
        fmSatEph.BinStream.Free; // UnSatEph
      end;
    'L'  :
      begin                    // from "look" to "sky"
        ForIniC(2);    // UnGetIni CharForView 'S' sky option
        fmHelPuz.HelPuzI:=11;  // initial number for help sky
        fmHelPuz.HelPuzN:=fmHelPuz.HelPuzI; // to use help files
        BooMapPoint:=False;  // UnGloVar
        CharForView:='S';  // from UnGloVar for sky
        VMagMax:=25;       // to limit stars with magnitude
        InitForFixCase;    // procedure from UnitFixO
        FiguViewPlac ;  // after changing some parameters UnPlaceA
      end;
  end; // case
  ToChangePopupMenuS ; // with information in CharForView UnPopCap
end;

procedure ForButtonY ; // centre objects position small rectangle
begin                  // to print objects positions
case  CharForView  of
  'S' : AfterSkyKey ; // UnMuDraw 'Y' key  "sky" case information
  'L' : AfterLooKey ; // UnMuDraw 'Y' key "look" case information
  'W' : Exit ; // no operation for "map" case
end; // case CharForView
end;

procedure ForButtonI ; // I ICRS information objects position
begin // to print objects positions all screen 'S' option only
  if  CharForView  <> 'S'  then  Exit ; // "sky" case information
  fmPrtPos:=TfmPrtPos.Create(Application); // form UnPrtPos
  try                   // equator ecliptic galactic positions
    fmPrtPos.charact:='I'; // objects positions ICRS
    fmPrtPos.ShowModal; // form from UnPrtPos
  finally
    fmPrtPos.Free;
  end;
end;

procedure ForButEphSat ; // satellite ephemeris
begin
repeat
  fmSelEph.ShowModal; // UnSelEph
  if  fmSelEph.BooSelEph
    then
      begin
        fmSatEph.PassToMemo;  // UnSatEph
        fmSatEph.ShowModal; // UnSatEph fmSatEph form for ephemeris
      end
    else
      fmSatEph.BooOther:=False;
until  not fmSatEph.BooOther ;
  ClcThreeRotMatr(JD2000,JulianDate, // UnConTyp UnGloVar
                  PlaceCoor,RotMatr,RosMatr,TopMatr); // UnForCoo
end;

procedure ForMapEphSat ;
begin
  if  not BooMapPoint // BooMapPoint UnGloVar assigned by MouseLeftClickSky
    then  Exit ;      // from UnMouSky no fixed point at the map
  if  fmSatMas.NumEph < 4      // UnSatMas NumEph count
    then                       // for ephemeris diagrams
      begin
        fmSatMas.PassForPoint ;    // results to fmSatEph.BinStream
        if  fmSatMas.NumPnt < 1
          then    // no visibility in this case
            ShowMessage('  ');
      end
    else
      ShowMessage('    '
                  +IntToStr(fmSatMas.NumEph)); // SysUtils
  if  fmSatMas.NumEph > 0  // there are some ephemeris
    then                   // for diagram
      fmSatMas.Show;       // form from UnSatMas
  ClcThreeRotMatr(JD2000,JulianDate, // UnConTyp UnGloVar
                  PlaceCoor,RotMatr,RosMatr,TopMatr); // UnForCoo
end;

procedure ForButEphes ; // ephemeris button "
begin                   // object from the satellite
  if  CharForView = 'W'
    then  Exit ; // no action for map
  CharForEphem:='O'; // 'P' for point 'O' for object
  fmSelEph.BeforeShow ; // UnSelEph
repeat
  fmSelEph.ShowModal; // UnSelEph
  if  fmSelEph.BooSelEph
    then
      begin
        fmSatEph.PassToMemo;  // UnSatEph
        fmSatEph.ShowModal; // UnSatEph fmSatEph form for ephemeris
      end
    else
      fmSatEph.BooOther:=False;
until  not fmSatEph.BooOther ;
  ClcThreeRotMatr(JD2000,JulianDate, // UnConTyp UnGloVar
                  PlaceCoor,RotMatr,RosMatr,TopMatr); // UnForCoo
end;

procedure ForButEphem ; // ephemeris button '
begin                // CharForEphem from UnGloVar
  CharForEphem:='P'; // 'P' for point 'O' for object
  fmSelEph.BeforeShow ; // with CharForEphem char UnSelEph
case  CharForView  of
  'S' : ForButEphSat ;  // satellite ephemeris
  'W' : ForMapEphSat ;  // ephemeris among the map
  'L' : ForButEphes  ;  // object from the satellite
end;                    // satellite from the station
end;

procedure ForSatLook ; // to view from the satellite
begin
  if  not ( BooFixObject and ( chFixObject = 'S' ) )
    then  // no satellite is fixed record in SatElemFix
      if  fmSatMap.BooChangeSatl
        then  // a satellite may be choosen from the list
          SatElemFix:=fmSatMap.SatMel // record TElemRec UnCotVar
        else    // Exit for no action no satellite to look
          Exit; // it is satellite to look SatElemFix of TElemRec
  if  CharForView = 'W'          // to go from world map option
    then                         // to 'L' look from sat option
      begin                      // it may be among world map
        fmSatMas.Close;          // this form was opened
        fmSatEph.BinStream.Free; // UnSatEph was create
      end;                       // to come away from 'W'
  CharForView:='L'; // to look from the satellite
  fmHelPuz.HelPuzI:=31;    // initial number for help look option
  fmHelPuz.HelPuzN:=fmHelPuz.HelPuzI; // to use help files
  SatElemLook:=SatElemFix; // UnCoTVar a look from this satellite
  VMagMax:=25;      // to limit stars with magnitude
  CentreToLimbuP(JulianDate, // 'L' option centre to limb point
                 SatElemLook,AzimutC,AltitudeC); // UnForZem
  InitForFixCase ;  // UnitFixO
  StepValueForFixSat ; // UnitSelH small step 10 second
  FiguViewPlac ;    // UnPlaceA
  ToChangePopupMenuS ; // with information in CharForView UnPopCap
end;

procedure ForAreaSize ; // button % to change size of area
var
  n  : Word ;
begin
  if  not ( CharForView in [ 'S' , 'L' ] )  then  Exit ;
  ToGetValueAreaSize ; // from UnitSelH to record array NameValue
  fmSelHol.CapSelHol:='  .'; // form from UnSelHol
  fmSelHol.AddSelHol:=0;
  fmSelHol.ListBox.Clear; // pure list now
  for n:=1 to NumNameValue do // var from UnGloVar is assigned in UnitSelH
    fmSelHol.ListBox.Items.Add('   '+NameValue[n].strname); // UnSelHol
  fmSelHol.ListBox.ItemIndex:=NumSizeValue-1; // to select value in ListBox
  fmSelHol.ListBox.Columns:=3; // to select from list fmSelHol.LisBox
  fmSelHol.ShowModal; // to select one things from the list
  if  fmSelHol.BooSelHol
    then // the new station is selected
      begin // var SizeForArea  NumSizeValue from UnGloVar
        NumSizeValue:=fmSelHol.NumSelHol; // form from UnSelHol
        SizeForArea:=NameValue[NumSizeValue].valname; // to change size
        RinDegC:=SizeForArea; // half of size on y axes in degree
        FiguViewPlac; // unit UnPlaceA
      end;
end;

procedure ForMapButA ;
begin
  if  CharForView <> 'W'  then  Exit ; // only for map world
  fmSatMap.SatMapC:='A'; // form class from UnSatMap
  fmSatMap.ShowModal;
end;

procedure ForSkyButV ; // to obtain initial parameters cond. vector
begin // the first action to find satellite for parameters
  if  not ( BooFixObject and ( chFixObject = 'S' ) )
    then  // no satellite is fixed record in SatElemFix
      if  fmSatMap.BooChangeSatl // to use fmSatMel modal form
        then  // a satellite may be choosen from the list
          SatElemFix:=fmSatMap.SatMel // record TElemRec UnCoTVar
        else    // Exit for no action no satellite to look
          Exit; // it is satellite for parameters SatElemFix
  fmPrtPos:=TfmPrtPos.Create(Application); // form UnPrtPos
  try // different format for vector condition
    fmPrtPos.charact:='P'; // for initial parameters
    fmPrtPos.starpom:=JulianDate; // moment to start
    fmPrtPos.elmSatl:=SatElemFix; // record with elements
    fmPrtPos.ShowModal; // form from UnPrtPos
  finally
    fmPrtPos.Free;
  end;
end;

procedure ForMapButV ;
begin
  if  CharForView <> 'W'  then  Exit ; // only for map world
  fmSatMap.SatMapC:='V'; // form class from UnSatMap
  fmSatMap.ShowModal;
  FiguViewMap ;          // UnPlaceA
end;

procedure ToLookLimb ; // 'L' look option for limb point
begin
  CharForEphem:='L';    // 'L' limb for look option
  fmSelEph.BeforeShow ; // UnSelEph
repeat
  fmSelEph.ShowModal; // UnSelEph
  if  fmSelEph.BooSelEph
    then
      begin
        fmSatEph.PassToMemo;  // UnSatEph
        fmSatEph.ShowModal; // UnSatEph fmSatEph form for ephemeris
      end
    else
      fmSatEph.BooOther:=False;
until  not fmSatEph.BooOther ;
  ClcThreeRotMatr(JD2000,JulianDate, // UnConTyp UnGloVar
                  PlaceCoor,RotMatr,RosMatr,TopMatr); // UnForCoo
end;

procedure ForButtonV ;
begin
  case  CharForView  of
    'S' : ForSkyButV ; // to print condition vector init parameter
    'W' : ForMapButV ; // to change objects among map
    'L' : ToLookLimb ; // look from the sat option for limb ephem
  end; // case
end;

procedure ForButtonH ;
begin
  fmHelPuz.Show;
end;

procedure ForButtonQ ;
begin
  ForIniC(2); // from unit UnGetIni CharForView 'S' sky option
  fmHelPuz.HelPuzI:=11;  // initial number for help sky
  fmHelPuz.HelPuzN:=fmHelPuz.HelPuzI; // to use help files
  FiguViewPlac ;  // after changing some parameters unit UnPlaceA
  ToChangePopupMenuS ; // UnPopCap
end;

procedure ForButtonX ;
begin
  fmPuz.Close ;
end;

procedure ForButtonChoice ( cb  : Char ) ; // called in UnMouSky
var
  ch  : Char ;
begin
  ch:=UpCase(cb);
  if  ch = #27  then  ch:='Q'; // Esc
  case  ch  of
   'F' : ForButtonF ; // to select from two catalogues TRC1 or TYC2
   'P' : ForButtonP ; // to choose station ToSelectOneStation from UnitStat
   'C' : ForButtonC ; // to choose object
   'E' : ForButtonE ; // to choose set of elements for the satellite
   'T' : ForButtonT ; // to change catalogue: Bright or Tycho
   '+' : ForPlusT ;   // forward with time
   '-' : ForMinusT ;  // backward with time
   'S' : ForButtonS ; // to choose step to change time
   'M' : ForButtonMap ; // satellite projection : map or sky
   '1' : ForButtonDate ; // to change date with time
   '2' : Exit ;
   'U' : Exit ;
   'Y' : ForButtonY ;  // centre objects position small rectangle
  '''' : ForButEphem ; // for ephemeris satellite from station
   '"' : ForButEphes ; // for ephemeris object from satellite
   '&' , 'L' : ForSatLook ;  // to view from satellite option 'L'
   '%' : ForAreaSize ; // to change size of area
   '#' : Exit ;
   'I' : ForButtonI ; // ICRS objects position all screen
   'A' : ForMapButA ; // information about object that are above horizon
   'V' : ForButtonV ; // 'S' vector condition 'W' objects among map 'L' limb
   'H' : ForButtonH ; // for simple help
   'Q' : ForButtonQ ; // to return to the initial point
   'X' : ForButtonX ; // to exit program
  end; { case char ch }
end;

end.
