
 { for the simple procedure for calculating }

 UNIT UnForFun ;

 INTERFACE

 Uses
   UnConTyp ;

 Function DATAN2 ( SinAngle , CosAngle  : Extended ) : Extended ;

 Function ATanDegree ( s , c  : Extended ) : Extended ;

 procedure ArcTanTwoArg(SinAngle , CosAngle : Extended;
                        Var Angle : Extended);

 procedure PrDegrAngle(Angle : Extended;
                       Var AngleSign : ShortString;
                       Var IntDegree,IntMin : integer;
                       Var AngleSec : Extended);

 procedure PrHourAngle(Angle : Extended;
                       Var AngleSign : ShortString;
                       Var IntHour,IntMin : integer;
                       Var AngleSec : Extended);

 Function  Log10 ( x   : Extended ) : Extended ;

 Function VectorModul ( a  : TVect3 ) : Extended ;

 Function ScalarMult ( a , b  : TVect3 ) : Extended ;

 Function ScalarMunt ( a , b  : TVect3 ) : Extended ;

 Procedure MatrMultVector ( p       : TMatr33 ;
                            a       : TVect3 ;
                            Var  b  : TVect3 ) ;

 Procedure UMatrMultVect ( p       : TMatr33 ;
                           a       : TVect3 ;
                           Var  b  : TVect3 ) ;

 Procedure MatrMultMatr ( p , q   : TMatr33 ;
                          Var  r  : TMatr33 ) ;

 Procedure SimpleRotMatr ( m  : Byte ;  a  : Extended ;
                           Var  r  : TMatr33 ) ;

 Procedure RotMatrFromPole ( a , d  : Extended ;  Var  r  :  TMatr33 ) ;

 Procedure RotoBodyMatr ( a , d , w  : Extended ;  Var  v  : TMatr33 ) ;

 function SquareInterPol ( x1 , x0 , x2  : Extended ;
                           y1 , y0 , y2  : Extended ) : Extended ;

 IMPLEMENTATION

 { DATAN2 is a function
   to obtain Arctan for the Angle in interval
      from  -(1/2)*Pi  to  +(3/2)*Pi  in rad }

 Function DATAN2 ( SinAngle , CosAngle  : Extended ) : Extended ;
 Var
   a,c,s,p : Extended;
 Begin
   c:=CosAngle; s:=SinAngle;
   if  c <> 0 then  Begin
      p:=s/c;  a:=ArcTan(p);
      if  c < 0  then  a:=a+Pi;  End
              else  if  s > 0  then  a:=PiTwo  else  a:=-PiTwo;
   DATAN2:=a;
 End;

 { ATanDegree is a function  to obtain
   Arctan for the Angle in interval from  0  to  360  in degree }

 Function ATanDegree ( s , c  : Extended ) : Extended ;
 Var
   a,p  : Extended;
 Begin
   If  c <> 0
     Then
       Begin
         p:=s/c;
         a:=RadGra*ArcTan(p);
         If  c < 0  Then  a:=a+180;
       End
     Else
       If  s > 0  Then  a:=90  Else  a:=270;
   If  a < 0  Then  a:=360+a;
   ATanDegree:=a;
 End;

 { ArcTanTwoArg is procedure
   to obtain Arctan for the Angle in interval
      from  -(1/2)*Pi  to  +(3/2)*Pi  in rad }

 procedure ArcTanTwoArg(SinAngle , CosAngle : Extended;
                        Var Angle : Extended);
 Var
   a,c,s,p : Extended;
 Begin
   c:=CosAngle; s:=SinAngle;
   if  c <> 0 then  Begin
      p:=s/c;  a:=ArcTan(p);
      if  c < 0  then  a:=a+Pi;  End
              else  if  s > 0  then  a:=PiTwo  else  a:=-PiTwo;
   Angle:=a;
 End;

 { PrDegrAngle is quite simple procedure
   to change a value for  Angle  in radians
      to the civil form : Sign Degree Minute Second . }

 procedure PrDegrAngle(Angle : Extended;
                       Var AngleSign : ShortString;
                       Var IntDegree,IntMin : integer;
                       Var AngleSec : Extended);
 Var r : Extended;
 Begin
    if  Angle < 0  then AngleSign:='-' else AngleSign:='+';
    r:=RadGra*Abs(Angle); IntDegree:=Trunc(r);
    r:=60*Frac(r); IntMin:=Trunc(r); AngleSec:=60*Frac(r);
    if  AngleSec > 59.999 then begin AngleSec:=0; IntMin:=IntMin+1; end;
    if  IntMin > 59 then
      begin IntMin:=IntMin-60; IntDegree:=IntDegree+1; end;
 End;

 { PrHourAngle is quite simple procedure
   to change a value for  Angle  in radians
      to the civil form : Sign Hour Minute Second . }

 procedure PrHourAngle(Angle : Extended;
                       Var AngleSign : ShortString;
                       Var IntHour,IntMin : integer;
                       Var AngleSec : Extended);
 Var r : Extended;
 Begin
    if  Angle < 0  then AngleSign:='-' else AngleSign:='+';
    r:=RadGra*Abs(Angle)/15; IntHour:=Trunc(r);
    r:=60*Frac(r); IntMin:=Trunc(r); AngleSec:=60*Frac(r);
    if  AngleSec > 59.999 then begin AngleSec:=0; IntMin:=IntMin+1; end;
    if  IntMin > 59 then
      begin IntMin:=IntMin-60; IntHour:=IntHour+1; end;
 End;

 { from the interesting book }

 Function  Log10 ( x   : Extended ) : Extended ;
 Begin
   Log10:=Ln(x)/Ln(10);
 End;

 Function VectorModul ( a  : TVect3 ) : Extended ;
 Begin
   VectorModul:=Sqrt(Sqr(a[1])+Sqr(a[2])+Sqr(a[3]));
 End;

 Function ScalarMult ( a , b  : TVect3 ) : Extended ;
 Begin // scalar multiplication of two vectors
   ScalarMult:=(+a[1]*b[1]+a[2]*b[2]+a[3]*b[3]);
 End;


 Function ScalarMunt ( a , b  : TVect3 ) : Extended ;
 Begin // for cos between two vectors unit scalar multiplication
   ScalarMunt:=ScalarMult(a,b)/(VectorModul(a)*VectorModul(b));
 End;

 Procedure MatrMultVector ( p       : TMatr33 ;
                            a       : TVect3 ;
                            Var  b  : TVect3 ) ;
 Var
   i,j  : Byte ;
 Begin
   For i:=1 To 3 Do
     Begin
       b[i]:=0;
       For j:=1 To 3 Do
         b[i]:=b[i]+p[i,j]*a[j];
     End;
 End;

 Procedure UMatrMultVect ( p       : TMatr33 ; // to transform matrix
                           a       : TVect3 ;
                           Var  b  : TVect3 ) ;
 Var
   i,j  : Byte ;
 Begin
   For i:=1 To 3 Do
     Begin
       b[i]:=0;
       For j:=1 To 3 Do
         b[i]:=b[i]+p[j,i]*a[j]; // to transform matrix
     End;
 End;

 Procedure MatrMultMatr ( p , q   : TMatr33 ;
                          Var  r  : TMatr33 ) ;
 Var
   i,j,k  : Byte ;
 Begin
   For i:=1 To 3 Do
     For j:=1 To 3 Do
       Begin
         r[i,j]:=0;
         For k:=1 To 3 Do
           r[i,j]:=r[i,j]+p[i,k]*q[k,j];
       End;
 End;

 { angle a in degree, m = 1 , 2 , 3 for X Y Z axis }

 Procedure SimpleRotMatr ( m  : Byte ;  a  : Extended ;
                           Var  r  : TMatr33 ) ;
 Var
   i,j  : Byte ;
   b,s,c  : Extended ;
 Begin
   for i:=1 to 3 do
     for j:=1 to 3 do
       if  i = j  then  r[i,j]:=1.0  else  r[i,j]:=0.0; // unit matrix
   b:=GraRad*a;
   s:=Sin(b);
   c:=Cos(b);
   If  m = 1
     Then
       Begin
         r[2,2]:=+c;
         r[2,3]:=+s;
         r[3,2]:=-s;
         r[3,3]:=+c;
         Exit ;
       End;
   If  m = 2
     Then
       Begin
         r[1,1]:=+c;
         r[1,3]:=-s;
         r[3,1]:=+s;
         r[3,3]:=+c;
         Exit ;
       End;
   If  m = 3
     Then
       Begin
         r[1,1]:=+c;
         r[1,2]:=+s;
         r[2,1]:=-s;
         r[2,2]:=+c;
         Exit ;
       End;
 End;

 { alpha delta of the north pole of an object in degree }

 Procedure RotMatrFromPole ( a , d  : Extended ;  Var  r  :  TMatr33 ) ;
 Var
   p,q  : TMatr33 ;
   x,z  : Extended ;
 Begin
   z:=90+a;
   SimpleRotMatr(3,z,p);
   x:=90-d;
   SimpleRotMatr(1,x,q);
   MatrMultMatr(q,p,r); { Rx(90-F)*Rz(90+L) }
 End;

 { alpha delta of the north pole of an object in degree
    w angle of the first meridian orientation in degree
    matrix  R_z(w)*R_x(90-d)*R_z(90+a)
    matrix to change from the fixed equator to the body system }

 Procedure RotoBodyMatr ( a , d , w  : Extended ;  Var  v  : TMatr33 ) ;
 Var
   x,z  : Extended ;
   p,q,r  : TMatr33 ;
 Begin
   z:=90+a; { 90 degree  plus right ascension }
   SimpleRotMatr(3,z,p); { around Z axis }
   x:=90-d; { 90 degree minus declinaton }
   SimpleRotMatr(1,x,q); { around X axis } 
   MatrMultMatr(q,p,r);  { Rx(90-F)*Rz(90+L) }
   SimpleRotMatr(3,w,p); { around Z axis by angle w R_z(w) }
   MatrMultMatr(p,r,v);  { R_z(w)*R_x(90-d)*R_z(90+a) }
 End;

function ToGetDet ( a  : TMatr33 ) : Extended ;
begin
  ToGetDet:=+a[1,1]*(a[2,2]*a[3,3]-a[3,2]*a[2,3])
            -a[1,2]*(a[2,1]*a[3,3]-a[3,1]*a[2,3])
            +a[1,3]*(a[2,1]*a[3,2]-a[3,1]*a[2,2]);
end;

procedure ToFillMatrix ( a , b , c  : TVect3 ;  var  d  : TMatr33 ) ;
var // very simple procedure
  i  : Byte ;
begin
  for i:=1 to 3 do
    begin // main matrix 3*3
      d[i,1]:=a[i];
      d[i,2]:=b[i];
      d[i,3]:=c[i];
    end;
end;

function SquareInterPol ( x1 , x0 , x2  : Extended ;
                          y1 , y0 , y2  : Extended ) : Extended ;
var // to interpolate three points by square polinom
  i  : Byte ;  // to solve three linear equation
  x,d,a,b      : Extended ; // a try to find point of maximum
  ad,aa,ab     : TMatr33 ;  // values a b c are unknown
  yy,xa,xb,xc  : TVect3 ;   // UnConTyp
begin   // y ( 1 0 2 ) = a * x^2 + b * x + c ; x ( 1 0 2 )
  yy[1]:=y1; // y1 = a * (x1-x0)^2 + b * (x1-x0) + c
  yy[2]:=y0; // y0 = a * (x0-x0)^2 + b * (x0-x0) + c  only c  x0-x0=0
  yy[3]:=y2; // y2 = a * (x2-x0)^2 + b * (x2-x0) + c
  for i:=1 to 3 do  xc[i]:=1.0; // coefficient with c equal 1
  xb[1]:=x1-x0; // coefficients with b (x1-x0)
  xb[2]:=0.0;   // the first derivation equal nullo
  xb[3]:=x2-x0; // for the maximum of square polinom if it exists
  for i:=1 to 3 do  xa[i]:=Sqr(xb[i]); // with a (x-x0)^2
  ToFillMatrix(xa,xb,xc,ad); // to solve three linear equation
  ToFillMatrix(yy,xb,xc,aa); // with respect to a b c
  ToFillMatrix(xa,yy,xc,ab); // the square polinom   a*(x-x0)^2+b*(x-x0)+c
  d:=ToGetDet(ad);   // determinant of the main 3*3 matrix
  if  Abs(d) < 1.0e-6  then  d:=1.0e16;
  a:=ToGetDet(aa)/d; // a value
  b:=ToGetDet(ab)/d; // b value
  x:=x0-b/(2*a); // to solve equation 2*a*(x-x0)+b=0
  if  ( x < x1 )  then  x:=x1; // out of range
  if  ( x > x2 )  then  x:=x2; // out of range
  SquareInterPol:=x;
end;

 END.
