
 UNIT UnForStr ; // simple operations with the strings

 INTERFACE

 Function WordToFixStr ( w  : Word ; n  : Byte ) : ShortString ;

 Function IntegerToFixStr ( w  : Integer ; n  : Byte ) : ShortString ;

 Function FloatToFixStr ( e  : Extended ;  n , k  : Byte ) : ShortString ;

 Function BlanksToStr ( s  : ShortString ; n  : Byte ) : ShortString ;

 Procedure ToEraseSomeBlanks ( Var  sn  : ShortString ) ;

 Procedure ToEraseAllBlanks ( Var  sn  : ShortString ) ;

 Procedure ToReplaceBlanks ( Var  st  : ShortString ) ;

 Function WithOutDecimalPoint ( st  : ShortString ) : ShortString ;

 IMPLEMENTATION

 Function WordToFixStr ( w  : Word ; n  : Byte ) : ShortString ;
 Var
   i  : Byte ;
   s  : ShortString ;
 Begin
   Str(w:n,s);
   For i:=1 To n Do
     If  s[i] = ' '  Then  s[i]:='0';
   WordToFixStr:=s;
 End;

 Function IntegerToFixStr ( w  : Integer ; n  : Byte ) : ShortString ;
 Var
   i  : Byte ;
   s  : ShortString ;
 Begin
   Str(w:n,s);
   For i:=1 To n Do
     If  s[i] = ' '  Then  s[i]:='0';
   IntegerToFixStr:=s;
 End;

 Function FloatToFixStr ( e  : Extended ;  n , k  : Byte ) : ShortString ;
 Var
   i  : Byte ;
   p  : Byte ;
   s  : ShortString ;
 Begin
   Str(e:n:k,s);
   p:=Pos('-',s);
   If  p > 1
     Then
       Begin
         s[p]:='0';
         s[1]:='-';
       End;
   For i:=1 To n Do
     If  s[i] = ' '  Then  s[i]:='0';
   FloatToFixStr:=s;
 End;

 Function BlanksToStr ( s : ShortString ; n  : Byte ) : ShortString ;
 Var
   a  : ShortString ;
   l  : Byte ;
 Begin
   a:=s; // our string
   l:=Length(a); // length of our sting
   If  l > n
     Then
       Delete(a,n+1,l-n) // length is greater than necessary
     Else
       While  l < n  Do // length of our string is less than necessary
         Begin // to add blanks if it is needed
           a:=' '+a; // to add one blank forward
           If  Length(a) < n  Then  a:=a+' '; // to add one blank backward
           l:=Length(a);
         End;
   BlanksToStr:=a;
 End;

 Procedure ToEraseSomeBlanks ( Var  sn  : ShortString ) ;
 Var
   i,l  : Byte ;
 Begin
   l:=Length(sn);
   For i:=l DownTo 1 Do
     If  sn[i] = ' '
       Then
         Delete(sn,i,1)
       Else
         Exit;
 End;

 Procedure ToEraseAllBlanks ( Var  sn  : ShortString ) ;
 Var
   n  : Byte ;
 Begin
   n:=Pos(' ',sn);
   While  n > 0  Do
     Begin
       Delete(sn,n,1);
       n:=Pos(' ',sn);
     End;
 End;

 Procedure ToReplaceBlanks ( Var  st  : ShortString ) ;
 Var
   i,l,n     : Byte ;
 Begin
   l:=Length(st);
   For i:=1 To l Do
     If  st[i] = ' '  Then  st[i]:='0';
   n:=Pos('+',st); // may be plus in string
   if  n > 1
     then
       begin
         st[1]:='+'; // the first character plus
         st[n]:='0'; // replace by nullo
       end;
   n:=Pos('-',st); // may be minus in string
   if  n > 1
     then
       begin
         st[1]:='-'; // the first character minus
         st[n]:='0'; // replace by nullo
       end;
 End;

 Function WithOutDecimalPoint ( st  : ShortString ) : ShortString ;
 Var
   n  : Byte ;
   s  : ShortString ;
 Begin
   s:=st;
   n:=Pos('.',s);
   While  n > 0  Do
     Begin
       Delete(s,n,1);
       n:=Pos('.',s);
     End;
   WithOutDecimalPoint:=s;
 End;

 END.
