{ to figure the Earth
  in case 'L' option to look from the satellite
  global variables PosZemelaC AngleZemeL from UnGloVar }
unit UnForZem ;
interface // these procedures are called in UnPlaceA
uses
  UnConTyp , // for types
  UnCoTVar ; // global var SatElemLook of TElemRec
{  ZemeMatrix  matrix of rotation from new pole to true equator
   SurfaRange  modul range from satellite to surface point }
var
  ZemeMatrix  : TMatr33 ;  // matrix for special purpose
  VectZemSat  : TVect3 ;   // descart true equator Earth-satellit
procedure EarthFiguScrini ; // 'L' the Earth in the field of view
procedure EarthFiguScreen ; // 'L' the Earth in the field of view
procedure NulloLimbPoint ( var  az , al  : Extended ; // 'L' shad
                           var  am , ap  : Extended ) ; // only
procedure CentreToLimbuP ( tc  : Extended ; // current moment
                           el  : TElemRec ; // current elements
                           var  az , al  : Extended ) ; // coor
implementation
uses
  Graphics , // to figure on canvas
  UnitMain , // form fmPuz with canvas to figure
  UnGloVar , // global matrix TopMatr RosMatr
  PUnCRead , // boolean global variable BrightStarsOnly
  UnitEilP , // procedure ElemX satellite position refer to Earth
  UnForCoo , // ClcSpherCoorInDegree
  UnForFun , // function ScalarMunt VectorModul
  UnPlateC , // IdealCoord...
  UnPlaceA ; // RectCoordinates
{ position of the Earth refer to the satellite in true equator }
procedure EarthToSat ( var  p : TVect3 ) ;
var
  i  : Byte ; // simple count
begin // record SatElemLook from UnCoTVar
  { satellite position refer to the centre of the Earth }
  ElemX(JulianDate,SatElemLook,p); // UnitEilP satellite pos
  { centre of the Earth refer to the satellite true equator }
  for i:=1 to 3 do  p[i]:=-p[i];
end;
{ direction to new pole is direction
  from the satellite to the centre of the Earth
  MatrNewTrue is procedure
  to obtain matrix to change from new pole to true pole
  this matrix is  w = R_z(90-alpha)*R_x(90-delta)
  modul  range   r  global var SurfaRange
  change matrix  w  global var ZemeMatrix}
procedure MatrNewTrue ( e  : TVect3 ;         // vector
                        var  r  : Extended ;  // modul range
                        var  w  : TMatr33 ) ; // our matrix
var                                           // our variables
  a,d  : Extended ; // spheric coordinates true equator
  u,v  : TMatr33 ;  // UnConTyp
begin                 // alpha delta in degree range in km
  { spheric coordinates of the Earth in true equator }
  ClcSpherCoorInDegree(e,a,d,r); // UnForCoo spheric true equator
  SimpleRotMatr(3,90.0-a,u); // UnForFun rot. matrix around Z axis
  SimpleRotMatr(1,90.0-d,v); // UnForFun rot. matrix around X axis
  MatrMultMatr(u,v,w);       // UnForFun R_z(90-a)*R_x(90-d)
end; // output r range in km w matrix to change
{ to find angle between two direction
  from satellite to the centre of the Earth
  from satellite to the point on the surface
           that perpendicular to the Earth radius }
function ToGetAngleZemeL ( x  : Extended ) : Extended ; // degree
begin
  { r is range from
    x is range from the satellite to surface point
    x/r     cosinus of the angle or zenith distance
    GeoR0/r sinus   of zenith distance const UnConTyp }
  ToGetAngleZemeL:=RadGra*DATan2(GeoR0,x); // UnForFun  in degree
end;
{ in case 'L' look option
  this procedure
  is called by proc ViewPlac from UnPlaceA
     elements of the satellite for looking sky
     are contained in record SatElemLook from UnGloVar }
procedure EarthFiguScrini ; // 'L the Earth in the field of view
var   // to prepare values PosZemelaC AngleZemeL
  r  : Extended ; // modul range from satellite to Earth's centre
  e  : TVect3 ;   // descart position Earth to sat type UnConTyp
begin             // current moment JulianDate from UnGloVar
  { position of the Earth refer to the satellite in true equator }
  EarthToSat(e); // position of the Earth refer to the satellite
  VectZemSat:=e; // to keep this value true equator descart
  { direction to new pole is direction
    from the satellite to the centre of the Earth
    MatrNewTrue is procedure
    to obtain matrix to change from new pole to true pole
    this matrix is  ZemeMatrix R_z(90-alpha)*R_x(90-delta) }
  MatrNewTrue(e,r,ZemeMatrix); // global values r modul \vec e
  { the Earth to orbital system
    TopMatr matrix to change from true equa to orbital
    PosZemelaC from UnGloVar Earth position in orbital system }
  MatrMultVector(TopMatr,e,PosZemelaC); // UnForFun var UnGloVar
  { our new pole refer
    from the satellite to the centre of the Earth
    variable SurfaRange for range
    from the satellite to the point on the surface
             that perpendicular to the Earth radius }
  SurfaRange:=Sqrt(Sqr(r)-Sqr(GeoR0)); // const UnConTyp
  { to find angle between two direction
    from satellite to the centre of the Earth
    from satellite to the point on the surface
             that perpendicular to the Earth radius }
  AngleZemeL:=ToGetAngleZemeL(SurfaRange); // in degree
end;
{ point of the surface may be on the screen }
procedure SurfacePoint ( az , al  : Extended ; // orbital param
                         clPoint  : TColor ) ; // Graphics
var  // orbital azimuth altitude descart position surface point
  x,y  : Integer ;   // screen coordinates
  ksi  : Extended ;  // plate coordinate
  eta  : Extended ;  // plate coordinate
begin                              // from spheric to plate
  IdealCoordinates(az,al,ksi,eta); // from UnPlateC
  RectCoordinates(ksi,eta,x,y);    // from UnPlaceA screen coor
  if  BooPosInRect(x,y)            // function UnPlaceA
    then                           // point among rectangle
      fmPuz.Canvas.Pixels[x,y]:=clPoint; //one point to screen
end;
{ a try to figure the Earth to screen
  x  modul range from satellite to surface point
  w  matrix of rotation from new pole to true equator }
procedure ZemeLine ( x  : Extended ;  w  : TMatr33 ) ; // the Earth
var
  a,b  : Extended ;
  c,s  : Extended ; // angle cosinus sinus
  d,r  : Extended ;
  o,q  : TVect3 ;
begin
  { altitude = 90 - zenith distance  in degree }
  d:=90.0-AngleZemeL; // our altitude for the new pole degree
  if  BrightStarsOnly // step in degree  boolean PUnCRead
    then  s:=0.10     // along new small circle on the surface
    else  s:=0.01;    // two values of step for two catalogues
  c:=-s;   // initial angle as longitude on the small circle
  while  c < 360.001  do // to find
    begin     // point by point along small surface's circle
      c:=c+s; // the next point as longitude  d  is latitude
      DescFromSpherCoor(c,d,x,o); // descart position UnForCoo
      { our surface point
        from new pole to true equator
        but refer to the satellite }
      MatrMultVector(w,o,q); // true equator position of point
      MatrMultVector(TopMatr,q,o); // to orbital system UnGloVar
      ClcTopCoorInDegree(o,a,b,r); // UnForFun orbital spheric
      SurfacePoint(a,b,clLime); // surface point may be on screen
    end;
end;
{ to figure some parallels on the surface }
procedure ZemParal ; // parallels of the Earth
var
  i  : Byte ;
  bf,bl  : Extended ; // phi lambda of the point on the surface
  zf,zl  : Extended ; // step in degree on phi and lambda
  bp,ap  : TVect3 ;   // descart position for current points
  a,b,r  : Extended ; // orbital horizontal point position
  clpar  : TColor ;   // graphics color ro figure parallel
begin
  bf:=-90.0; // initial latitude  in degree
  zf:=+10.0; // step on latitude  in degree
  zl:=0.1;   // step on longitude in degree
repeat
  bf:=bf+zf; // the next value for latitude
  bl:=-zl;   // initial value for longitude
  if  bf < 0.0
    then  clpar:=clRed   // for south hemisphere of the Earth
    else  clpar:=clWhite; // for north hemisphere of the Earth
repeat
  bl:=bl+zl; // the next value for longitude refer nullo meridian
  // the next point for parallel refer to the Earth's centre
  DescFromSpherCoor(bl,bf,GeoR0,bp); // UnForFun Earth's system
  UMatrMultVect(RosMatr,bp,ap); // UnForFun refer to true equinox
  for i:=1 to 3 do // to change from the Earth's centre true equa
    ap[i]:=ap[i]+VectZemSat[i]; // to the satellite but true equa
  MatrMultVector(TopMatr,ap,bp); // to orbital system UnGloVar
  ClcTopCoorInDegree(bp,a,b,r); // UnForFun orbital spheric
  if  r < SurfaRange // to compare our range with the largest
    then             // value  surface point may be on screen
      SurfacePoint(a,b,clpar); // surface point may be on screen
until  ( bl > 360.001 ) ; // to finish step with longitude
until  ( bf > 89.0 ) ;   // to finish step to figure parallels
end;
{ to figure some meridians on the surface }
procedure ZemMerid ; // meridians of the Earth
var
  i  : Byte ;
  bf,bl  : Extended ; // phi lambda of the point on the surface
  zf,zl  : Extended ; // step in degree on phi and lambda
  bp,ap  : TVect3 ;   // descart position for current points
  a,b,r  : Extended ; // orbital horizontal point position
  clpar  : TColor ;   // graphics color ro figure parallel
begin
  zl:=30.0; // step on longitude in degree
  zf:=0.1;  // step on latitude  in degree
  bl:=-zl;  // initial longitude  in degree
repeat
  bl:=bl+zl; // the next value for longitude refer nullo meridian
  bf:=-90.0-zf;   // initial value for latitude
repeat
  bf:=bf+zf; // the next value for latitude
  if  ( bl = 0.0 )
    then  clpar:=clLime // nullo meridian
    else
      if  ( Abs(bl-180.0) < 0.1 )
        then  clpar:=clGreen   // 180 degree meridian
        else
          if  ( bf < 0.0 )
            then  clpar:=clFuchsia   // for south hemisphere
            else  clpar:=clAqua; // for north hemisphere
  // the next point for meridian refer to the Earth's centre
  DescFromSpherCoor(bl,bf,GeoR0,bp); // UnForFun to nullo meridian
  UMatrMultVect(RosMatr,bp,ap); // UnForFun refer to true equinox
  for i:=1 to 3 do // to change from the Earth's centre true equa
    ap[i]:=ap[i]+VectZemSat[i]; // to the satellite but true equa
  MatrMultVector(TopMatr,ap,bp); // to orbital system UnGloVar
  ClcTopCoorInDegree(bp,a,b,r); // UnForFun orbital spheric
  if  r < SurfaRange // to compare our range with the largest
    then             // value  surface point may be on screen
      SurfacePoint(a,b,clpar); // surface point may be on screen
until  ( bf > 90.01 ) ; // to finish step with latitude
until  ( bl > 320.0 ) ;   // to finish step to figure meridians
end;
{ in case 'L' look option
  this procedure
  is called by proc ViewPlac from UnPlaceA
     elements of the satellite for looking sky
     are contained in record SatElemLook from UnGloVar }
procedure EarthFiguScreen ; // the Earth in the field of view
begin             // current moment JulianDate from UnGloVar
{ ZemeMatrix  matrix of rotation from new pole to true equator
  SurfaRange  modul range from satellite to surface point
  PosZemelaC from UnGloVar Earth position in orbital system
  AngleZemeL angle between two direction }
  if  ( ScalarMunt(PosZemelaC,PosHorizoC)   // cos(angle) between
         < Cos(GraRad*(AngleZemeL+RinDegC)) ) // two directions :
    then  // from satellite to Earth's and to screen's centres
      Exit; // angle between lines is too large no Earth figure
  ZemeLine(SurfaRange,ZemeMatrix); // the Earth to screen
  ZemParal ; // parallels of the Earth
  ZemMerid ; // meridians of the Earth
end;
{ orbital position of the limb point of the surface
  azimuth altitude in orbital system
  longitude latitude range in Earth's rotating system
  functions from UnForFun UnForCoo
  TopMatr matrix to change from true equator to orbital system
  RosMatr matrix to change from true equinox to greenwich meridian }
procedure NulloLimbPoint ( var  az , al  : Extended ; // 'L' shad
                           var  am , ap  : Extended ) ; // only
var  // orbital and geospheric coordinates of the surface point
  i  : Byte ;       // simple count
  a  : Extended ;   // simple temporary
  r,p,q  : TVect3 ; // vectors for the point and the satellite
begin
  az:=0.0;              // orbital azimuth  of the Earth's point
  al:=AngleZemeL-90.0;  // orbital altitude of the Earth's point
  DescFromHorizCoor(az,al,SurfaRange,p); // point's vector
  for i:=1 to 3 do  // point on the surface from the satellite
    p[i]:=p[i]-PosZemelaC[i];  // to the Earth centre
  UMatrMultVect(TopMatr,p,q);  // from orbital system to true equa
  MatrMultVector(RosMatr,q,r); // from true equinox to greenwich
  ClcSpherCoorInDegree(r,am,ap,a); // meridian  geospheric coor
end;
{ case 'L' option
  to choice the centre of the screen as limb point }
procedure CentreToLimbuP ( tc  : Extended ; // current moment
                           el  : TElemRec ; // current elements
                           var  az , al  : Extended ) ; // coor
var
  xs  : TVect3 ;   // satellite position true equator
  rs  : Extended ; // range from the centre of the Earth to the sat
  qs  : Extended ; // range from the limb point to our satellite
begin
  az:=0.0; // orbital azimuth of the Earth's limb point degree
  ElemX(tc,el,xs); // UnitEilP satellite true equator   UnForFun
  rs:=VectorModul(xs); // range from the Earth centre to the sat
  qs:=Sqrt(Sqr(rs)-Sqr(GeoR0)); // UnConTyp range from sat to limb
  al:=RadGra*DATan2(GeoR0,qs)-90.0; // orbita altitude of the limb
end;
end.