unit UnHelPuz;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Menus;

type
  TfmHelPuz = class(TForm)
    moHelp: TMemo;
    mnuHelp: TMainMenu;
    mnuHelpBefo: TMenuItem;
    mnuHelpNext: TMenuItem;
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure mnuHelpBefoClick(Sender: TObject);
    procedure mnuHelpNextClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    HelPuzF  : TextFile ;
    function ToGetFontColor : TColor ;
    procedure ForHelpFile ;
    procedure ForHelpMemo ;
  public
    { Public declarations }
    HelPuzI  : Byte ;
    HelPuzN  : Byte ;
    HelPuzS  : ShortString ;
  end;

var
  fmHelPuz: TfmHelPuz;

implementation

{$R *.DFM}

uses
  UnitMain , // fmPuz main form
  UnGloVar ; // for stPathDefault path to this folder boomaif

procedure TfmHelPuz.FormResize(Sender: TObject);
var
  rw,rh  : Integer ;
begin
  rw:=Screen.Width ;  // Forms for Screen of TScreen
  rh:=Screen.Height ; // Forms for Screen of TScreen
  if  Width > rw  then  Width:=rw; // for form fmHelPuz
  if  Width < 350  then  Width:=350;
  Height:=rh-50;
  Left:=rw-Width-10;
  if  Left < 10
    then
      begin
        Left:=10;
        Width:=rw-20;
      end;
  Top:=10;
end;

function TfmHelPuz.ToGetFontColor : TColor ; // TColor from unit Graphics
var
  i  : Byte ;
  c  : TColor;
begin
  c:=clGreen ;
  i:=Random(8);
  case  i  of
    1  : c:=clNavy;
    2  : c:=clRed;
    3  : c:=clTeal;
    4  : c:=clPurple;
    5  : c:=clFuchsia;
    6  : c:=clBlue;
    7  : c:=clOlive;
  end; // case
  ToGetFontColor:=c;
end;

procedure TfmHelPuz.ForHelpFile ;
begin
  HelPuzS:=stPathDefault+'\HelPuz'+IntToStr(HelPuzN)+'.txt';
  if  not FileExists(HelPuzS)
    then // file with the number HelPuzI always exists
      begin
        HelPuzN:=HelPuzI;
        HelPuzS:=stPathDefault+'\HelPuz'+IntToStr(HelPuzN)+'.txt';
      end;
  AssignFile(HelPuzF,HelPuzS);
end;

procedure TfmHelPuz.ForHelpMemo ;
var
  s  : ShortString ;
begin
  moHelp.Clear;
  moHelp.Visible:=False;
  moHelp.Font.Color:=ToGetFontColor ;
  ReSet(HelPuzF);
repeat
  ReadLn(HelPuzF,s);
  moHelp.Lines.Add('  '+s);
until  EOF(HelPuzF);
  CloseFile(HelPuzF);
  moHelp.Visible:=True;
end;

procedure TfmHelPuz.FormActivate(Sender: TObject);
begin
  boomaif:=False; { Form with the help is active but no main form }
  ForHelpFile ; // to assigh to find and to open current help file
  ForHelpMemo ;
end;

procedure TfmHelPuz.mnuHelpBefoClick(Sender: TObject);
begin
  if  HelPuzN > 1
    then
      HelPuzN:=HelPuzN-1;
  ForHelpFile ;
  ForHelpMemo ;
end;

procedure TfmHelPuz.mnuHelpNextClick(Sender: TObject);
begin
  HelPuzN:=HelPuzN+1;
  ForHelpFile ;
  ForHelpMemo ;
end;

procedure TfmHelPuz.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  Key = VK_LEFT   then  mnuHelpBefoClick(Sender);
  if  Key = VK_RIGHT  then  mnuHelpNextClick(Sender);
end;

end.
