
 { for the procedures 
    of the generalised two fixed centres problem }

 UNIT UnitEilP ;

 INTERFACE

 Uses
   UnConTyp , // TypeDim3
   UnCoTVar , // TElemRec
   UnitElmK ; // PosVType function KeplerEquation

 Type
   CoefType     = Array [1..50] of Extended ;

 Procedure CRONA ( Var  C  : CoefType ) ;

 Procedure ElemC ( ElemR   : TElemRec ;
                   Var  C  : CoefType ) ;

 Procedure ElemX ( TCur    : Extended ;
                   ElemR   : TElemRec ;
                   Var  X  : TypeDim3 ) ;

 Procedure EilXV ( TCur   : Extended ;
                   ElemR  : TElemRec ;
                   Var  pos , vel  : TypeDim3 ) ;

 Procedure ALEI ( Var  C   : CoefType ) ;

 Procedure XVEilR ( t  : Extended ;
                    X    : PosVType ;
                    Var  ElemR   : TElemRec ) ;  // UnCoTVar

 procedure ElemDefault ( var  el  : TElemRec ) ;


 IMPLEMENTATION

 Uses
   UnForFun ; // function DATan2

 Procedure CRONA ( Var  C  : CoefType ) ;
 Var
   FM,CJ2,SIG,A,E,S,
   O,O2,O3,O4,O5,E2,E4,
   RE,S2,RS,S4,
   P,P2,PS,P4,
   Z2,PM,R1,R2,R3,R4,
   F0,F1,F2,B0,B1,B2            : Extended ;
   A1,A2,A3,
   AB,ASZ,AC,
   AD,ADZ,AX,AG,AT,
   AG1,AG2,AN,AQ,
   AC0,AC1,AC2,AC3,AC4,
   AK1,AK2,AQ0,AQ1,AQ2,
   AZ,AP0,AP1,AP2,AF0,
   AF1,AF2,AF3,AF4,ALAM,
   AN0,OH,AMU,AKF2,AKF4,
   AKP2,AKP4                : Extended ;
 Begin
   FM:=C[1];
   CJ2:=C[3];
   SIG:=C[4];
   A:=C[8];
   E:=C[9];
   S:=C[10];
   AC:=SQRT(Abs(1.0e0-S*S));
   If  C[7] < 0.e0  Then  AC:=-AC;
   O:=1.0e0;
   O2:=2.e0;
   O3:=3.e0;
   O4:=0.25e0;
   O5:=0.5e0;
   E2:=E*E;
   RE:=O-E2;
   E4:=E2*E2;
   S2:=S*S;
   RS:=O-S2;
   S4:=S2*S2;
   P:=CJ2/(A*RE);
   P2:=P*P;
   PS:=P*SIG;
   Z2:=SIG*SIG;
   AX:=E*(O+P2*RE*(O-O2*S2+P2*(O3
           -16.e0*S2+14.e0*S4-O2*E2*RS*RS)));
   C[14]:=AX;
   AG:=-PS*(O-O2*S2-P2*(O3-12.e0*S2+10.e0*S4+E2*(O-O2*S4)));
   AT:=PS*S*(O-P2*(5.e0-6.e0*S2-E2*(O-O2*S2)));
   C[15]:=AG;
   C[16]:=AT;
   AK1:=0.125e0*P2*S2*(RE+Z2-4.e0*P2*RE*RS);
   AK2:=0.125e0*P2*E2*(S2-P2*(O-10.e0*S2+11.0e0*S4+E2*S4));
   C[26]:=AK1;
   C[27]:=AK2;
   PM:=SQRT(FM*A*RE);
   P2:=O5*P2;
   P4:=O5*P2*P2;
   AG1:=PM*(O+P2*(RS*(O3+E2)+Z2*(6.e0-7.e0*S2))
             -P4*RS*(9.e0+11.0e0*S2+E2*(6.e0+34.e0*S2)+E4*(O+O3*S2)));
   AG2:=PM*(O-P2*(O3-4.e0*S2-E2)-P4*(9.e0-72.e0*S2
             +64.e0*S4+E2*(O2-40.e0*S2+48.e0*S4)+E4));
   AN:=AG1*(O+O2*AK2+9.e0*Sqr(AK2))/(AG2*(O+O2*AK1+9.e0*Sqr(AK1)));
   C[17]:=AG1;
   C[18]:=AG2;
   C[19]:=AN;
   PS:=PS*S*AC;
   P2:=P*P;
   P4:=P2/16.0e0;
   C[20]:=O2*PS*(O-P2*(4.e0-5.e0*S2+E2*S2));
   R1:=P2*AC;
   R2:=O2*P4;
   R3:=4.e0*R2;
   R4:=O4*R1*P4;
   AC0:=-R1*(O+O5*E2+P4*(24.e0-56.e0*S2
              -4.e0*E2*(O+16.e0*S2)-E4*(O2+O3*S2)));
   C[21]:=AC0;
   C[22]:=-O2*R1*E*(O+R2*(4.e0-28.e0*S2-E2*(6.e0+7.e0*S2)));
   C[23]:=-O4*R1*E2*(O-R3*(11.0e0+E2*(O+S2)));
   C[24]:=16.e0*R4*E*E2*(O2-S2);
   C[25]:=R4*E4*(O2+S2);
   AQ0:=-O5*R1*(RE+O3*Z2-O2*P4*RE*(30.e0-35.e0*S2+E2*(O2+O3*S2)));
   C[28]:=AQ0;
   C[29]:=P2*PS*RE;
   C[30]:=6.e0*R4*S2*RE*RE;
   F2:=O-R3*RE*(4.e0-7.e0*S2)-P2*R2*RE
        *(20.e0-136.e0*S2+113.e0*S4-E2*(8.e0+24.e0*S2-47.e0*S4));
   F1:=P2*RE*(O2-O3*S2+R3*(O2-22.e0*S2+19.e0*S4
                -E2*S2*(10.e0-13.e0*S2)));
   F0:=O/(F1+F2);
   F0:=F0/SQRT(O-AX*AX);
   F0:=F0*RE*RE;
   B0:=R3*(-S2+R3*(6.e0-20.e0*S2+15.e0*S4-E2*S4));
   B1:=-P2*R3*S2*(O2-S2);
   B2:=O3*P2*R2*S4;
   AP0:=F0*(B0+B1+B2*(O+O5*AX*AX));
   C[32]:=AP0;
   C[33]:=AX*(B1+O2*B2)*F0;
   C[34]:=O4*E2*B2*F0;
   F0:=P2*F0*AG2/AG1;
   AF0:=O5*F0*S2*(O+O3*AK1);
   C[35]:=AF0;
   C[36]:=-F0*S*(O2*AG-1.5e0*S*AT);
   C[38]:=-F0*S2*AT/6.e0;
   C[37]:=-F0*S2*(O4+AK1);
   C[39]:=0.125e0*F0*S2*AK1;
   C[40]:=-AP0-AN*AF0;
   C[45]:=AN-O;
   C[42]:=C[41]/(O-C[40]);
   C[43]:=C[45]*C[42];
   C[46]:=AC0+AN*AQ0;
   C[44]:=C[42]*C[46];
   C[47]:=AK1*(O+4.e0*AK1);
   C[48]:=-0.75e0*AK1*AK1;
   C[49]:=-AN*AK2*(O+4.e0*AK2);
   C[50]:=0.75e0*AN*AK2*AK2;
   C[23]:=C[23]+AQ0*C[49];
   C[30]:=C[30]+AQ0*C[47];
   C[34]:=C[34]+AF0*C[49];
   C[37]:=C[37]+AF0*C[47];
 End ;

 Procedure ElemC ( ElemR   : TElemRec ; // type TElemRec from UnCoTVar
                   Var  C  : CoefType ) ;
 Var
   j  : Byte ;
   FM,RZ,CJ2,SIG,
   S,ASZ,AC,AD,ADZ,F0,F1,F2,FC,
   RE,PE,P2,P4,PS,D2,RD,D4,RC,RR,
   R1,F3,AB,DZ2,RDZ,DZ4,RCZ,RRZ,
   F4,F5,F6,F7,F8,F9,R3,R4,R2,
   A1,A2,A3,AN0                 : Extended ;
 Begin
   FM:= 3.98600448000e+5;
   RZ:= 6.37813700000e+3;
   CJ2:= 2.09728850857e+2;
   SIG:=-3.55889244242e-2;
   AN0:=TwoPi*ElemR.an/86400.0;
   S:=GraRad*ElemR.ai; // constants from unit UnConTyp
   ASZ:=SIN(S);
   AC:=COS(S);
   AD:=ASZ;
   ADZ:=-ASZ;
   A1:=-Exp(2.0e0/3.0e0*Ln(FM*AN0));
   F0:=-FM/A1;
   AB:=F0;
   FC:=CJ2/F0;
   RE:=1.e0-ElemR.ae*ElemR.ae;
   F1:=2.e0-RE;
   F2:=RE*RE;
   For j:=1 To 4 Do
     Begin
       PE:=CJ2/(AB*RE);
       P2:=PE*PE;
       P4:=P2*P2;
       PS:=PE*SIG;
       D2:=AD*AD;
       RD:=1.e0-D2;
       D4:=D2*D2;
       RC:=1.e0-2.e0*PS*AD-P2*D2*RE;
       RR:=1.e0+2.e0*P2*D2*F1+P4*D4*F2;
       R1:=RC/RR;
       F3:=1.e0-RD*R1;
       AB:=F0*(1.e0-P2*RE*RD*R1);
       DZ2:=ADZ*ADZ;
       RDZ:=1.e0-DZ2;
       DZ4:=DZ2*DZ2;
       RCZ:=1.e0-2.e0*PS*ADZ-P2*DZ2*RE;
       RRZ:=1.e0+2.e0*P2*DZ2*F1+P4*DZ4*F2;
       R2:=RCZ/RRZ;
       F4:=1.e0-RDZ*R2;
       F5:=F3+D2*ADZ*(FC*PE*(2.e0*AD+ADZ)+2.e0*PS);
       F6:= F4+DZ2*AD*(FC*PE*(2.e0*ADZ+AD)+2.e0*PS);
       F7:=SQRT(ABS((F5/F6)*(F4/F3)));
       F9:=R1/R2;
       F8:=2.e0*F7*(1.e0+F7)*F9*ASZ;
       ADZ:=(-1.e0+F9-F9*Sqr((1.e0+F7)*ASZ)+(1.e0-F9*F7*F7)*DZ2)/F8;
       AD:=ASZ*(1.e0+F7)+F7*ADZ;
     End;
   R3:=FM*AB*RE*RD*(1.e0+2.e0*P2*F1+P4*F2)*R1;
   R4:=FM*AB*RE*RDZ*(1.e0+2.e0*P2*F1+P4*F2)*R2;
   A3:=SQRT(ABS(R3));
   IF AC < 0.e0  Then  A3:=-A3;
   A2:=-FM*AB*RE*(1.e0+2.e0*P2*F1*RD*R1+P4*F2*RD*R1);
   C[8]:=AB;
   C[9]:=ElemR.ae;
   C[10]:=ASZ;
   C[11]:=AC;
   C[5]:=A1;
   C[6]:=A2;
   C[7]:=A3;
   C[12]:=AD;
   C[13]:=ADZ;
   C[1]:=FM;
   C[2]:=RZ;
   C[3]:=CJ2;
   C[4]:=SIG;
   C[31]:=-C[8]*C[9]*A1/FM;
   C[41]:=AN0;
   CRONA(C);
 End;

 Procedure ElemX ( TCur    : Extended ;
                   ElemR   : TElemRec ;
                   Var  X  : TypeDim3 ) ;
 Var
   j     : Byte ;
   C     : CoefType ;
   O,W,OL,
   A1,A2,A3,
   AB,AE,ASZ,AC,
   AD,ADZ,AX,AG,AT,
   AG1,AG2,AN,AQ,
   AC0,AC1,AC2,AC3,AC4,
   AK1,AK2,AQ0,AQ1,AQ2,
   AZ,AP0,AP1,AP2,AF0,
   AF1,AF2,AF3,AF4,ALAM,
   AN0,OH,AMU,AKF2,AKF4,
   AKP2,AKP4,RXX,RX,PUDL,
   SPP,CPP,SPR,RB,
   SFF,CFF,SFR,EE,RT,BT,
   SW,CW,SU,CU              : Extended ;
   X1,X2,X3,V1,V2,V3,
   ZX,U2,R1,F2,BS,
   SE,CE,EA,SP,CP,EP,DE,
   SF,CF,EF,S2P,C2P,S4P,
   S2F,C2F,S4F,AO0,BW,
   AU0,AM0,R2,R3,R4,R5,R6,
   FM,RZ,CJ2,SIG,Z2,Z0      : Extended ;
   UDL,UDG,UDH,DifT,ddl     : Extended ;
 Begin
   ElemC(ElemR,C);
   ddl:=TwoPi*0.5*ElemR.dn*Sqr(TCur-ElemR.t); // +1/2 dn/dt (t-t_0)^2 radian
   DifT:=86400.0*(TCur-ElemR.t); { in second }
   UDL:=GraRad*ElemR.am+C[42]*DifT+ddl; { in radian }
   UDG:=GraRad*ElemR.ao+C[43]*DifT+HalfPi;
   UDH:=GraRad*ElemR.au+C[44]*DifT-HalfPi;
   O:=1.0e0;
   W:=2.00000e0;
   OL:=0.0e0;
   FM:=C[1];
   RZ:=C[2];
   CJ2:=C[3];
   SIG:=C[4];
   A1:=C[5];
   A2:=C[6];
   A3:=C[7];
   AB:=C[8];
   AE:=C[9];
   ASZ:=C[10];
   AC:=C[11];
   AD:=C[12];
   ADZ:=C[13];
   AX:=C[14];
   AG:=C[15];
   AT:=C[16];
   AG1:=C[17];
   AG2:=C[18];
   AN:=C[19];
   AQ:=C[20];
   AC0:=C[21];
   AC1:=C[22];
   AC2:=C[23];
   AC3:=C[24];
   AC4:=C[25];
   AK1:=C[26];
   AK2:=C[27];
   AQ0:=C[28];
   AQ1:=C[29];
   AQ2:=C[30];
   AZ:=C[31];
   AP0:=C[32];
   AP1:=C[33];
   AP2:=C[34];
   AF0:=C[35];
   AF1:=C[36];
   AF2:=C[37];
   AF3:=C[38];
   AF4:=C[39];
   ALAM:=C[40];
   AN0:=C[41];
   OH:= C[45];
   AMU:=C[46];
   AKF2:=C[47];
   AKF4:=C[48];
   AKP2:=C[49];
   AKP4:=C[50];
   RXX:=1.e0-AX*AX;
   RX:=SQRT(RXX);
   Z2:=Sqr(CJ2);
   Z0:=CJ2*SIG;
   EA:=KeplerEquation(AZ,UDL); { eccentric anomaly in radian }
   SE:=Sin(EA);
   CE:=Cos(EA);
   RB:=O/(O-AX*CE);
   SP:=RX*RB*SE;
   CP:=(CE-AX)*RB;
   SPP:=W*SP*CP;
   CPP:=CP*CP-SP*SP;
   SPR:=W*SPP*CPP;
   EP:=EA+ArcTan((SP*CE-CP*SE)/(CP*CE+SP*SE));
   PUDL:=EP-UDL;
   EF:=EP+UDG+OH*(EP-UDL);
   SF:=Sin(EF);
   CF:=Cos(EF);
   SFF:=W*SF*CF;
   j:=0;
   DE:=1.0e0;
   While ( ( j < 15 ) AND ( DE > 1.0e-15 ) )  Do
     Begin
       j:=j+1;
       PUDL:=EP-UDL;
       SPP:=W*SP*CP;
       CPP:=CP*CP-SP*SP;
       SPR:=W*SPP*CPP;
       SFF:=W*SF*CF;
       CFF:=CF*CF-SF*SF;
       SFR:=W*SFF*CFF;
       EE:=UDL+AZ*SE+ALAM*PUDL-AP1*SP-AP2*SPP
             -AF1*SF+AF2*SFF+AF3*(SF*CFF+CF*SFF)-AF4*SFR;
       SE:=Sin(EE);
       CE:=Cos(EE);
       RB:=O/(O-AX*CE);
       SP:=RX*RB*SE;
       CP:=(CE-AX)*RB;
       EP:=EE+ArcTan((SP*CE-CP*SE)/(CP*CE+SP*SE));
       EF:=EP+UDG+OH*PUDL+AKP2*SPP+AKP4*SPR-AKF2*SFF+AKF4*SFR;
       SF:=Sin(EF);
       CF:=Cos(EF);
       DE:=Abs(EA-EE);
       EA:=EE;
     End;
   BS:=AB*(O-AE*CE);
   RT:=O/(O-AT*CF);
   BT:=RT*(-ASZ*CF+AG);
   R1:=BS*BS+Z2;
   R2:=O-BT*BT;
   R3:=SQRT(R1*R2);
   R4:=-AC*CF+AQ;
   R6:=O/(R4*R4+SF*SF);
   R5:=SQRT(R6);
   BW:=UDH+HalfPi+AMU*PUDL+AQ1*SF-AQ2*SFF;
   BW:=BW+AC1*SP+AC2*SPP+AC3*(SP*CPP+CP*SPP)+AC4*SPR;
   SW:=R4*R5;
   CW:=SF*R5;
   SU:=SIN(BW);
   CU:=COS(BW);
   X[1]:=R3*(CW*CU-SW*SU);
   X[2]:=R3*(CW*SU+SW*CU);
   X[3]:=Z0+BS*BT;
 End;

 Procedure EilXV ( TCur   : Extended ;
                   ElemR  : TElemRec ;
                   Var  pos , vel  : TypeDim3 ) ;
 Var
   j     : Byte ;
   C     : CoefType ;
   O,W,OL,
   A1,A2,A3,
   AB,AE,ASZ,AC,
   AD,ADZ,AX,AG,AT,
   AG1,AG2,AN,AQ,
   AC0,AC1,AC2,AC3,AC4,
   AK1,AK2,AQ0,AQ1,AQ2,
   AZ,AP0,AP1,AP2,AF0,
   AF1,AF2,AF3,AF4,ALAM,
   AN0,OH,AMU,AKF2,AKF4,
   AKP2,AKP4,RXX,RX,PUDL,
   SPP,CPP,SPR,RB,
   SFF,CFF,SFR,EE,RT,BT,
   SW,CW,SU,CU              : Extended ;
   X1,X2,X3,V1,V2,V3,
   ZX,U2,R1,F2,BS,
   SE,CE,EA,SP,CP,EP,DE,
   SF,CF,EF,S2P,C2P,S4P,
   S2F,C2F,S4F,AO0,BW,
   AU0,AM0,R2,R3,R4,R5,R6,
   FM,RZ,CJ2,SIG,Z2,Z0      : Extended ;
   UDL,UDG,UDH,DifT,ddl     : Extended ;
   q1,q2,q3,ri,vs,vw,vt     : Extended ;
 Begin
   ElemC(ElemR,C);
   ddl:=TwoPi*0.5*ElemR.dn*Sqr(TCur-ElemR.t); // +1/2 dn/dt (t-t_0)^2 radian
   DifT:=86400.0*(TCur-ElemR.t); { in second }
   UDL:=GraRad*ElemR.am+C[42]*DifT+ddl; { in radian }
   UDG:=GraRad*ElemR.ao+C[43]*DifT+HalfPi;
   UDH:=GraRad*ElemR.au+C[44]*DifT-HalfPi;
   O:=1.0e0;
   W:=2.00000e0;
   OL:=0.0e0;
   FM:=C[1];
   RZ:=C[2];
   CJ2:=C[3];
   SIG:=C[4];
   A1:=C[5];
   A2:=C[6];
   A3:=C[7];
   AB:=C[8];
   AE:=C[9];
   ASZ:=C[10];
   AC:=C[11];
   AD:=C[12];
   ADZ:=C[13];
   AX:=C[14];
   AG:=C[15];
   AT:=C[16];
   AG1:=C[17];
   AG2:=C[18];
   AN:=C[19];
   AQ:=C[20];
   AC0:=C[21];
   AC1:=C[22];
   AC2:=C[23];
   AC3:=C[24];
   AC4:=C[25];
   AK1:=C[26];
   AK2:=C[27];
   AQ0:=C[28];
   AQ1:=C[29];
   AQ2:=C[30];
   AZ:=C[31];
   AP0:=C[32];
   AP1:=C[33];
   AP2:=C[34];
   AF0:=C[35];
   AF1:=C[36];
   AF2:=C[37];
   AF3:=C[38];
   AF4:=C[39];
   ALAM:=C[40];
   AN0:=C[41];
   OH:= C[45];
   AMU:=C[46];
   AKF2:=C[47];
   AKF4:=C[48];
   AKP2:=C[49];
   AKP4:=C[50];
   RXX:=1.e0-AX*AX;
   RX:=SQRT(RXX);
   Z2:=Sqr(CJ2);
   Z0:=CJ2*SIG;
   EA:=KeplerEquation(AZ,UDL); { eccentric anomaly in radian }
   SE:=Sin(EA);
   CE:=Cos(EA);
   RB:=O/(O-AX*CE);
   SP:=RX*RB*SE;
   CP:=(CE-AX)*RB;
   SPP:=W*SP*CP;
   CPP:=CP*CP-SP*SP;
   SPR:=W*SPP*CPP;
   EP:=EA+ArcTan((SP*CE-CP*SE)/(CP*CE+SP*SE));
   PUDL:=EP-UDL;
   EF:=EP+UDG+OH*(EP-UDL);
   SF:=Sin(EF);
   CF:=Cos(EF);
   SFF:=W*SF*CF;
   j:=0;
   DE:=1.0e0;
   While ( ( j < 15 ) AND ( DE > 1.0e-15 ) )  Do
     Begin
       j:=j+1;
       PUDL:=EP-UDL;
       SPP:=W*SP*CP;
       CPP:=CP*CP-SP*SP;
       SPR:=W*SPP*CPP;
       SFF:=W*SF*CF;
       CFF:=CF*CF-SF*SF;
       SFR:=W*SFF*CFF;
       EE:=UDL+AZ*SE+ALAM*PUDL-AP1*SP-AP2*SPP
             -AF1*SF+AF2*SFF+AF3*(SF*CFF+CF*SFF)-AF4*SFR;
       SE:=Sin(EE);
       CE:=Cos(EE);
       RB:=O/(O-AX*CE);
       SP:=RX*RB*SE;
       CP:=(CE-AX)*RB;
       EP:=EE+ArcTan((SP*CE-CP*SE)/(CP*CE+SP*SE));
       EF:=EP+UDG+OH*PUDL+AKP2*SPP+AKP4*SPR-AKF2*SFF+AKF4*SFR;
       SF:=Sin(EF);
       CF:=Cos(EF);
       DE:=Abs(EA-EE);
       EA:=EE;
     End;
   BS:=AB*(O-AE*CE);
   RT:=O/(O-AT*CF);
   BT:=RT*(-ASZ*CF+AG);
   R1:=BS*BS+Z2;
   R2:=O-BT*BT;
   R3:=SQRT(R1*R2);
   R4:=-AC*CF+AQ;
   R6:=O/(R4*R4+SF*SF);
   R5:=SQRT(R6);
   BW:=UDH+HalfPi+AMU*PUDL+AQ1*SF-AQ2*SFF;
   BW:=BW+AC1*SP+AC2*SPP+AC3*(SP*CPP+CP*SPP)+AC4*SPR;
   SW:=R4*R5;
   CW:=SF*R5;
   SU:=SIN(BW);
   CU:=COS(BW);
   pos[1]:=R3*(CW*CU-SW*SU);
   pos[2]:=R3*(CW*SU+SW*CU);
   pos[3]:=Z0+BS*BT;
   ri:=o/(bs*bs+z2*bt*bt);
   r1:=o/r1;
   r2:=o/r2;
   q1:=Sqrt(o-8*ak2*sp*sp);
   q2:=Sqr(rx/(o+ax*cp));
   q3:=ab*ae*ag2;
   vs:=q3*ri*q2*sp*q1;
   q1:=Sqrt(o-8*ak1*cf*cf);
   q2:=(asz-ag*at)*ag1;
   vt:=q2*ri*rt*rt*sf*q1;
   vw:=a3*r1*r2;
   r4:=bs*vs*r1-bt*vt*r2;
   vel[1]:=pos[1]*r4-pos[2]*vw;
   vel[2]:=pos[2]*r4+pos[1]*vw;
   vel[3]:=bs*vt+vs*bt;
 End;

 Procedure ALEI ( Var  C   : CoefType ) ;
 Var
   j                       : Byte ;
   O,A1,A2,A3,FM,CJ2,SIG,
   AB,AE,AD,ADZ,RE,FE,PA,
   FA,RF,RT,RD,RDZ,DZ2,
   D2,PE,P1,P4,P2,RR,RC,
   RRZ,RCZ,R,FD,PS,E2      : Extended ;
 Begin
   O:=1.0e0;
   A1:=C[5];
   A2:=C[6];
   A3:=C[7];
   FM:=C[1];
   CJ2:=C[3];
   SIG:=C[4];
   AB:=-FM/A1;
   FA:=AB;
   FE:=-A2/FM;
   RE:=FE/FA;
   PA:=A3*A3;
   RD:=-PA/A2;
   RDZ:=RD;
   FD:=RD;
   PA:=PA/FM;
   For j:=1 To 5 Do
     Begin
       PE:=CJ2/(AB*RE);
       P2:=PE*PE;
       PS:=PE*SIG;
       D2:=O-RD;
       AD:=SQRT(Abs(D2));
       P1:=2.e0*P2*(2.e0-RE);
       P2:=P2*RE;
       P4:=P2*P2;
       RR:=O+P1*D2+P4*D2*D2;
       RC:=O-2.e0*PS*AD-P2*D2;
       RR:=RC/RR;
       RF:=(O+P1+P4)*RR;
       RT:=O+(RF-RR)*RD;
       AB:=FA*(O-P2*RD*RR);
       RE:=FE/(AB*RT);
       RD:=FD*RT/RF;
       DZ2:=O-RDZ;
       ADZ:=-SQRT(Abs(DZ2));
       RRZ:=O+P1*DZ2+P4*DZ2*DZ2;
       RCZ:=O-2.e0*PS*ADZ-P2*DZ2;
       RDZ:=PA*RRZ/(AB*RE*(O+P1+P4)*RCZ);
     End;
   E2:=O-RE;
   C[8]:=AB;
   C[9]:=SQRT(Abs(E2));
   D2:=O-RD;
   C[12]:=SQRT(Abs(D2));
   DZ2:=O-RDZ;
   C[13]:=-SQRT(Abs(DZ2));
   P2:=PE*PE*(3.e0-4.e0*D2+E2);
   C[10]:=C[12]+PS*RD*(O-3.e0*PS*C[12]-P2);
   C[11]:=SQRT(Abs(O-C[10]*C[10]));
   IF  A3 < 0.e0  Then  C[11]:=-C[11];
   RF:=O/FM;
   R:=-A1*A1*A1;
   C[41]:=SQRT(R)*RF;
   C[31]:=-C[8]*C[9]*A1*RF;
 End;

 Procedure XVEilR ( t  : Extended ;
                    X    : PosVType ;
                    Var  ElemR   : TElemRec ) ;  // UnCoTVar
 Var
   C  : CoefType ;
   Z4,FI,VT,VS              : Extended ;
   A1,A2,A3,
   AB,ASZ,AC,
   AD,ADZ,AX,AG,AT,
   AG1,AG2,AN,AQ,
   AC0,AC1,AC2,AC3,AC4,
   AK1,AK2,AQ0,AQ1,AQ2,
   AZ,AP0,AP1,AP2,AF0,
   AF1,AF2,AF3,AF4,ALAM,
   AN0,OH,AMU,AKF2,AKF4,
   AKP2,AKP4,PUDL           : Extended ;
   X1,X2,X3,V1,V2,V3,
   ZX,U2,R1,F2,BS,BT,
   SE,CE,EA,SP,CP,EP,
   SF,CF,EF,SPP,CPP,SPR,
   SFF,CFF,SFR,AO0,BW,
   AU0,AM0,R2,SR,CR,
   FM,RZ,CJ2,SIG,Z2,Z0      : Extended ;
   AOR,AUR,AMR              : Extended ; // in radian
   AM,AO,AU,AI,AE,ANOB      : Extended ;
 Begin
   FM:= 3.98600448000e+5;
   RZ:= 6.37813700000e+3;
   CJ2:= 2.09728850857e+2;
   SIG:=-3.55889244242e-02;
   Z2:=Sqr(CJ2);
   Z0:=CJ2*SIG;
   X1:=X[1];
   X2:=X[2];
   X3:=X[3]-Z0;
   V1:=X[4];
   V2:=X[5];
   V3:=X[6];
   ZX:=X3*X3;
   R2:=X1*X1+X2*X2+ZX;
   U2:=V1*V1+V2*V2+V3*V3;
   R1:=X1*V1+X2*V2+X3*V3;
   F2:=0.5e0*(R2-Z2+Sqrt(Sqr(R2-Z2)+4.0e0*Z2*ZX));
   BS:=SQRT(F2);
   BT:=X3/BS;
   Z4:=Z2*Sqr(BT);
   FI:=2.0e0*FM/(F2+Z4);
   VT:=BS*V3-BT*R1;
   VS:=BS*R1+Z2*BT*V3;
   A1:=U2-FI*(BS-Z0*BT);
   A3:=X1*V2-V1*X2;
   A2:=R1*R1-R2*U2+Z2*V3*V3-FI*(BS*Z4+Z0*BT*F2);
   C[1]:=FM;
   C[2]:=RZ;
   C[3]:=CJ2;
   C[4]:=SIG;
   C[5]:=A1;
   C[6]:=A2;
   C[7]:=A3;
   ALEI(C);
   CRONA(C);
   AB:=C[8];
   AE:=C[9];
   ASZ:=C[10];
   AC:=C[11];
   AD:=C[12];
   ADZ:=C[13];
   AX:=C[14];
   AG:=C[15];
   AT:=C[16];
   AG1:=C[17];
   AG2:=C[18];
   AN:=C[19];
   AQ:=C[20];
   AC0:=C[21];
   AC1:=C[22];
   AC2:=C[23];
   AC3:=C[24];
   AC4:=C[25];
   AK1:=C[26];
   AK2:=C[27];
   AQ0:=C[28];
   AQ1:=C[29];
   AQ2:=C[30];
   AZ:=C[31];
   AP0:=C[32];
   AP1:=C[33];
   AP2:=C[34];
   AF0:=C[35];
   AF1:=C[36];
   AF2:=C[37];
   AF3:=C[38];
   AF4:=C[39];
   ALAM:=C[40];
   AN0:=C[41];
   OH:= C[45];
   AMU:=C[46];
   AKF2:=C[47];
   AKF4:=C[48];
   AKP2:=C[49];
   AKP4:=C[50];
   CE:=(1.0e0-BS/AB)/AE;
   SE:=SQRT(1.0e0-CE*CE);
   IF  VS < 0.0e0  Then  SE:=-SE;
   EA:=DATAN2(SE,CE);
   CP:=(CE-AX)/(1.0e0-AX*CE);
   SP:=Sqrt(1.0e0-CP*CP);
   IF  VS < 0.e0  Then  SP:=-SP;
   EP:=DATAN2(SP,CP);
   SR:=(BT-AG)/(ASZ-BT*AT);
   CR:=Sqrt(1.0e0-SR*SR);
   IF  VT < 0.e0  Then  CR:=-CR;
   SF:=CR;
   CF:=-SR;
   EF:=DATAN2(SF,CF);
   SPP:=2.e0*SP*CP;
   CPP:=CP*CP-SP*SP;
   SPR:=2.e0*SPP*CPP;
   SFF:=2.e0*SF*CF;
   CFF:=CF*CF-SF*SF;
   SFR:=2.e0*SFF*CFF;
   AM0:=EA-AZ*SE-ALAM*EP+AP1*SP+AP2*SPP
          +AF1*SF-AF2*SFF-AF3*(SF*CFF+CF*SFF)+AF4*SFR;
   AMR:=AM0/(1-ALAM);
   PUDL:=EP-AMR;
   AO0:=EF-EP-OH*PUDL-AKP2*SPP-AKP4*SPR+AKF2*SFF-AKF4*SFR;
   AOR:=AO0-PiTwo;
   R1:=-AC*CF+AQ;
   BW:=DATAN2(X2,X1)-DATAN2(R1,SF);
   AU0:=BW-PiTwo-AMU*PUDL
          -AC1*SP-AC2*SPP-AC3*(SPP*CP+CPP*SP)
          -AC4*SPR-AQ1*SF+AQ2*SFF;
   AUR:=AU0+PiTwo;
   AM:=RadGra*AMR; // mean anomaly in degree
   If  AM < 0.0    Then  AM:=360.0+AM;
   If  AM > 360.0  Then  AM:=AM-360.0;
   AO:=RadGra*AOR; // argument of perigei in degree
   If  AO < 0.0    Then  AO:=360.0+AO;
   If  AO > 360.0  Then  AO:=AO-360.0;
   AU:=RadGra*AUR; // the ascending node in degree
   If  AU < 0.0    Then  AU:=360.0+AU;
   If  AU > 360.0  Then  AU:=AU-360.0;
   AI:=RadGra*DATAN2(ASZ,AC);
   ANOB:=(AN0/(1-ALAM))*(RADGRA/360.e0)*8.64e4; // mean motion rev. per day
   ElemR.t:=t;
   ElemR.ao:=AO;   // argument of perigei in degree
   ElemR.au:=AU;   // the ascending node in degree
   ElemR.ai:=AI;   // inclination in degree
   ElemR.ae:=AE;
   ElemR.am:=AM;   // mean anomaly in degree
   ElemR.an:=ANOB; // mean motion in revolution per day
 End;




 procedure ElemDefault ( var  el  : TElemRec ) ;
 begin // simple default elements to record el
   el.satnord:=1100001;
   el.satnuml:=1100001;
   el.satname:='unknown';
   el.stdmag:=99.0;
   el.t:=JD2000; // const UnConTyp
   el.ao:=10.0;  // argument of perigei degree
   el.au:=80.0;  // ascending node degree
   el.ai:=82.0;  // inclination degree
   el.ae:=0.01;  // eccentricity
   el.am:=1.00;  // mean anomaly degree
   el.an:=13.5;  // mean motion in revolution per day
   el.dn:=0.00;  // change of mean motion
 end;

 END.
