unit UnitFixO; // some procedures when object is choiced and fixed

interface

uses
  UnCoTVar ; // type TElemRec for global var ObjectTopHeap^[]

var
  chFixObject  : Char ;
  stFixObject  : ShortString ;

procedure InitForFixCase ;

procedure ToDefineFixObject ; // UnitFixO for ObjectTopHeap^[OBoxInform]

function ToGetCentrePos  : Boolean ; // for AzimutC AltitudeC values

procedure ToGetFixSatellites ; // if it is possible to fix called by UnitFixO

procedure ToGetRandomSat ( var  el  : TElemRec ) ; // type UnCoTVar

implementation

uses
  UnGloVar , // for BooFixObject
  UnPlaceO , // for global var OBoxInform that chosen
  PUnCRead , // for procedure ToGetStarFromHeap
  UnForSta , // for procedure CentreWithFixStar
  UnForPos , // for procedure CentreWithFixPlanet
  UnForSat , // for procedure CentreWithFixSatellite
  UnitEilP ; // for proc ElemDefault

procedure InitForFixCase ;
begin // no objectFix
  chFixObject:=' ';
  BooFixObject:=False;
  stFixObject:='';
  MapSatNumber:=0;    // UnGloVar no satellites on the map
  BooMapPoint:=False; // UnGloVar no selected points on the map
end;

procedure ToDefineFixStar ;
var
  ns  : LongInt ;
begin // stars in memory in StarAllHeap all variables unit UnCoTVar
  ns:=ObjectTopHeap^[OBoxInform].nall; // number for star in  StarAllHeap^[]
  StarOneFix:=StarAllHeap^[ns]; // inform from memory to record StarOneFix
end;

procedure ToDefineFixPlanet ;
begin  // number of planet that chosen to fix
  PlanetNumFix:=ObjectTopHeap^[OBoxInform].nall;
end;

procedure ToDefineFixSatellite ;
var
  ns  : LongInt ;
begin
  ns:=ObjectTopHeap^[OBoxInform].nall; // number of satellite in SatElemHeap^
  SatElemFix:=SatElemHeap^[ns]; // record for satellite that chosen to fix
end;

procedure ToDefineFixObject ; // UnitFixO for ObjectTopHeap^[OBoxInform]
begin // OBoxInform number in ObjectTopHeap^[] for object that choiced
  chFixObject:=ObjectTopHeap^[OBoxInform].chps;  // char chps for object
  stFixObject:=ObjectTopHeap^[OBoxInform].name;  // name for object
  case  chFixObject  of
    '*' : ToDefineFixStar ;
    'P' : ToDefineFixPlanet ;
    'S' : ToDefineFixSatellite ;
  end; // case char chps to define object
end;

function ToGetCentrePos  : Boolean ; // for AzimutC AltitudeC values
begin  // BooFixObject from UnGloVar
  ToGetCentrePos:=False;
  if  ( CharForView = 'S' ) and ( not BooFixObject )
    then // 'S' for sky option but not for 'L' look
      begin
        if  AltitudeC < RinDegC-1.0
          then
            AltitudeC:=RinDegC-1.0;
        Exit ; // no change in centre horizon position
      end;
  case  chFixObject  of
    '*' : ToGetCentrePos:=CentreWithFixStar ;      // unit UnForSta
    'P' : ToGetCentrePos:=CentreWithFixPlanet ;    // unit UnForPos
    'S' : ToGetCentrePos:=CentreWithFixSatellite ; // unit UnForSat
  end; // case char chps to define object
end;

procedure ToGetFixSatellites ; // if it is possible to fix satellites
var                            // to project on the map world
  nus  : Byte ;
  stn  : ShortString ;
  boo  : Boolean ;             // a try to use any satellites
begin
  boo:=False;
  if  BooFixObject and ( chFixObject = 'S' )
    then // there is our satellite with the elements in SatElemFix
      begin
        boo:=True;
        MapSatNumber:=1; // the satellite that fixed
        SatElemMap[MapSatNumber]:=SatElemFix; // elements record UnGloVar
        stFixObject:=SatElemFix.satname; // name of the satellite that fixed
      end
    else
      if  NumSatElemInHeap > 0
        then  // information about the satellite is in heap
          begin // OBoxInform declared in UnPlaceO
            boo:=True;
            if  NumSatElemInHeap > 47
              then // random numbers for satellites
                begin
                  MapSatNumber:=8; // UnGloVar
                  for nus:=1 To MapSatNumber do
                    begin
                      OBoxInform:=NumFirstSatHeap+Random(NumSatElemInHeap);
                      ToDefineFixObject;  // the random satellite from the list
                      SatElemMap[nus]:=SatElemFix; // elements record UnGloVar
                    end;
                end
              else
                begin
                  MapSatNumber:=8;
                  if  NumSatElemInHeap < MapSatNumber
                    then
                      MapSatNumber:=NumSatElemInHeap;
                  for nus:=1 To MapSatNumber do
                    begin
                      OBoxInform:=NumFirstSatHeap+nus-1;
                      ToDefineFixObject;  // the random satellite from the list
                      SatElemMap[nus]:=SatElemFix; // elements record UnGloVar
                    end;
                end;
          end;
  boo:= boo and ( JulianDate > 2436147.0 ) ; // 5 october 1957 year
  BooFixObject:= boo ; // yes or no objects on teh screen
  if  boo
    then
      begin
        NumStepValue:=21;
        StepWithTime:=10.0/1440.0; // 10 minute in day
      end
    else
      InitForFixCase;
  Str(MapSatNumber:2,stn);
  stFixObject:=':'+stn;
end;

procedure ToGetRandomSat ( var  el  : TElemRec ) ; // type UnCoTVar
begin
  if NumSatElemInHeap < 1
    then
      ElemDefault(el) // no satellite
    else
      begin // random number
        OBoxInform:=NumFirstSatHeap+Random(NumSatElemInHeap); // number
        el:=SatElemHeap^[ObjectTopHeap^[OBoxInform].nall]; // record
      end;
end;

end.

