unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, OleCtnrs, ExtCtrls, Mask, ExtDlgs;

type
  TfmPuz = class(TForm)
    MenuEph: TMainMenu;
    MenuDia: TMenuItem;
    MenuDiaW: TMenuItem;
    MenuDiaL: TMenuItem;
    MenuDiaR: TMenuItem;
    MenuDiaRa: TMenuItem;
    MenuDiaRe: TMenuItem;
    MenuDiaRi: TMenuItem;
    MenuDiaRo: TMenuItem;
    MenuDiaS: TMenuItem;
    MenuDiaZ: TMenuItem;
    MenuDiaX: TMenuItem;
    MenuEphM: TMenuItem;
    MenuEphElm: TMenuItem;
    MenuEphRes: TMenuItem;
    MenuEphCoo: TMenuItem;
    MenuEphCat: TMenuItem;
    MenuEphClc: TMenuItem;
    MenuEphSap: TMenuItem; // station and satellite
    MenuEphSao: TMenuItem; // satellite and object
    MenuEphSav: TMenuItem; // conditional vector
    BoxInform: TListBox;
    ImageSal: TImage;   // the satellite is lighted by the Sun
    ImageSat: TImage;   // the satellite is in shadow
    PopupMenuS: TPopupMenu;
    ppPrtPos: TMenuItem;
    ppDateNew: TMenuItem;
    ppMapView: TMenuItem;
    ppSatLook: TMenuItem;
    ppAreaView: TMenuItem;
    ppEphClc: TMenuItem;
    SaveDialog: TSaveDialog;
    SavePictureDialog: TSavePictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MenuEphElmClick(Sender: TObject);
    procedure MenuEphResClick(Sender: TObject);
    procedure MenuEphCooClick(Sender: TObject);
    procedure MenuEphCatClick(Sender: TObject);
    procedure ppEphClcClick(Sender: TObject);
    procedure ppMapViewClick(Sender: TObject);
    procedure ppDateNewClick(Sender: TObject);
    procedure ppAreaViewClick(Sender: TObject);
    procedure ppPrtPosClick(Sender: TObject);
    procedure ppSatLookClick(Sender: TObject);
    procedure MenuEphSapClick(Sender: TObject);
    procedure MenuEphSaoClick(Sender: TObject);
    procedure MenuDiaSClick(Sender: TObject);
    procedure MenuDiaXClick(Sender: TObject);
    procedure MenuDiaRaClick(Sender: TObject);
    procedure MenuDiaReClick(Sender: TObject);
    procedure MenuDiaRiClick(Sender: TObject);
    procedure MenuDiaRoClick(Sender: TObject);
    procedure MenuDiaWClick(Sender: TObject);
    procedure MenuDiaLClick(Sender: TObject);
    procedure MenuEphSavClick(Sender: TObject);
  private
    { Private declarations }
    procedure ToCreateSomeClasses ;
  public
    { Public declarations }
  end;

var
  fmPuz: TfmPuz;

implementation

uses
  UnSelFol , // form to choose folder
  UnSelFel , // form to choose file with elements
  UnSelSat , // form to choose satellite
  UnSelHol , // form to choose some points
  UnPrtPos , // form fmPrtPos
  UnSelDat , // from to change date
  UnSelEph , // for fmSelEph ShowModal by ForButtonW ephemeris
  UnSatEph , // for fmSatEph form for satellite ephemeris
  UnSatMap , // for fmSatMap form for group of satellites among the map
  UnSatMel , // for fmSatMel form to choose one satellite from the list
  UnSatMas , // for fmSatMas form for ephemeris at the map
  UnHelPuz , // for fmHelPuz form for help information
  UnButIni , // for SkyRect
  UnFigIni , // for initial variables assigned Figu Plac Info Save procedures
  UnMemIni , // to Get and Free memory
  UnFilIni , // to open and close files
  UnGetIni , // initial value for graphic
  UnFigMou , // ForMouseMove
  UnMuDraw , // ForMouseDraw procedure
  UnPlaceA , // for procedure ViewPlac
  UnForSta , // for procedure StarToMemory
  UnForSat , // for procedure SatelliteToMapWorld
  UnForBut , // procedure ForButtonChoice
  UnForPrt , // for PrtFile
  UnGloVar , // for CharForView  JulianDate
  UnitStat , // for boolean BooStatList to use in UnForBut
  UnClaMap , // class for simple map of world
  UnGraBmp , // for PuzSaveBmp
  UnSatRaf ; // class for simple satl diagram

var
  BooFormOpen   : Boolean ;
  BooFormClose  : Boolean ;

{$R *.DFM}

procedure TfmPuz.ToCreateSomeClasses ;
begin
  Application.HintPause:=10;
  fmSelEph:=TfmSelEph.Create(Application); // form for ephemeris data
  fmSatEph:=TfmSatEph.Create(Application); // form for ephemeris
  fmSatMas:=TfmSatMas.Create(Application); // form for ephemeris map
  fmSelFel:=TfmSelFel.Create(Application); // form to select some files
  fmSelHol:=TfmSelHol.Create(Application); // form to select some points
  fmSelSat:=TfmSelSat.Create(Application); // form to choose satellite
  fmHelPuz:=TfmHelPuz.Create(Application); // form for help information
  fmSatMap:=TfmSatMap.Create(Application); // form for set of satellites
  fmSatMel:=TfmSatMel.Create(Application); // form to choose one satellite
  MapW:=TMapW.Create; // to create class TMapW UnClaMap around the world
  MapW.LineToMem ; // procedure from class TMapW UnClaMap
  GraS:=TGraS.Create; // to create class TGraS UnSatRaf passage diagram
end;

procedure TfmPuz.FormCreate(Sender: TObject);
begin
  Randomize;
  if  not ForOpenFiles  // from UnFilIni to open files for stars
    then
      begin
        ShowMessage('no catalogues');
        Halt ; // no action
      end;
  fmPuz.ToCreateSomeClasses ;
  BooFormOpen:=True;
  BooFormClose:=False;
  ForCreateMem ;   // from UnMemIni
  AllBrightStars ; // from UnFilIni all bright stars just to memory
  ForIniC(0) ; // from UnGetIni  variable JulianDate
  xpMouse:=-100;   // x default for mouse UnGloVar
  ypMouse:=-100;   // y default for mouse
  HintForButtons ; // from UnButIni for buttons
  SpecForButtons ; // from UnButIni for buttons
  StarToMemory ; // NumberOfStars around AlphaC DeltaC to memory UnForSta
  FiguSize ; // from UnFigIni for current size
  stPathDefault:=GetCurrentDir;  // UnGloVar SysUtils folder with program
  stPathElem:=stPathDefault; // stPathDefault string from UngloVar
  stPathResult:=stPathDefault; // stPathDefault string from UngloVar
  stPathSite:=stPathDefault; // UnGloVar path to folder with station file
  ToAddStationList(stPathSite+'\statfirs.txt'); // UnitStat sites position
  fmHelPuz.HelPuzI:=11; // initial number for help in sky
  fmHelPuz.HelPuzN:=fmHelPuz.HelPuzI;
// PrtFileOpen ; // UnForPrt
end;

procedure TfmPuz.FormResize(Sender: TObject);
begin
  if  BooFormClose  then  Exit ;
  FiguSize ; // from UnFigIni for current size
  FiguPlac ; // from UnFigIni for top bottom and middle
  case  CharForView  of
    'S' , 'L' :
           begin
             StarToMemory ; // from unit UnPlaceA after new size of area
             ViewPlac ; // from UnPlaceA
           end;
    'W' :  begin
             BooMapPoint:=False; // no fix point at the map world UnGloVar
             fmPuz.ppEphClc.Enabled:=False; // no possible for ephemeris
             fmPuz.MenuEphClc.Enabled:=False;
             FiguViewMap ; // UnPlaceA for map world
           end;
  end; // case 'S' 'W'
end;

procedure TfmPuz.FormPaint(Sender: TObject);
begin
  if  BooFormClose  then  Exit ;
  if  BooFormOpen
    then
      begin
        BooFormOpen:=False;
        Exit ;
      end;
  case  CharForView  of
    'S' , 'L' :
           begin
             FiguPlac ; // from UnFigIni for top bottom and middle
             ViewPlac ; // from UnPlaceA
           end;
    'W' :  FiguViewMap ; // UnPlaceA
  end; // case 'S' 'W'
end;

procedure TfmPuz.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  BooFormClose:=True;
  ForCloseMem ; // from unit UnMemIni with this has been appeared error
  ForCloseFiles ; // from unit UnFilIni
  PrtFileClose ;  // unit UnForPrt
  MapW.Free;
end;

procedure TfmPuz.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if  not ( ssCtrl in Shift ) { without key Ctrl }
    then            { now fmPuz is in active }
      boomaif:=True { UnGloVar some actions only after MouseUp }
    else
      if  Button = mbLeft
        then              { only left button for draw }
          if  not boomaif { global variable from UnGloVar }
            then  { main form fmPuz may be not active }
              boomaif:=True { now fmPuz is in active }
            else { centre point to draw rect. }
              ForMouseDraw(0,Shift,X,Y); { UnMuDraw }
end;

procedure TfmPuz.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin { case if boomoud is true for draw simple rectangle }
if  ( not ( ssCtrl in Shift ) ) and ( not boomoud ) { UnMuDraw }
  then
    begin
      if  ( xpMouse <> X ) and ( ypMouse <> Y )
        then
          begin
            xpMouse:=X;     // UnGloVar
            ypMouse:=Y;
          end;
      ForMouseMove(Shift,X,Y); // from UnFigMou
    end
  else
    ForMouseDraw(1,Shift,X,Y); { UnMuDraw to draw rectangle around point }
end;

procedure TfmPuz.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin { case if boomoud is true for draw simple rectangle }
if  ( not ( ssCtrl in Shift ) ) and ( not boomoud ) { UnMuDraw }
  then
    ForMouseClick(Button,Shift,X,Y) // from unit UnFigMou
  else
    if  Button = mbLeft
      then
        ForMouseDraw(2,Shift,X,Y); { UnMuDraw to fix rectangle }
end;

procedure TfmPuz.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if  boomoud  then  Exit ; { case when rectangle draw }
  ForButtonChoice(Key); // from unit UnForBut
  if  Key  in [ '+' , '-' ]
    then
      fmPuz.FormMouseMove(Sender,[],xpMouse,ypMouse);
end;

procedure TfmPuz.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  boomoud  then  Exit ; { case when rectangle draw }
  if  Key = VK_F1  then  ForButtonChoice('H'); // UnForBut for help
  if  ( Key = Ord('S') ) and ( Shift = [ ssCtrl ] )
    then  MenuDiaSClick(Sender);                       // to save
  if  ( Key = Ord('X') ) and ( Shift = [ ssAlt ] )
    then  MenuDiaXClick(Sender);                       // to exit
end;

procedure TfmPuz.MenuEphElmClick(Sender: TObject);
begin // to use form that is in UnSelFol
  fmSelFol:=TfmSelFol.Create(Self); // form to select folder
try
  fmSelFol.StrSelFolLabelCap:=' :  ';
  fmSelFol.FileListBox.Mask:='*.tle;*.geo;*.kdr;*.irv;'
                            +'*.slr;*.txt;*.elm;*.sim';
  fmSelFol.ShowModal; // form to select path to folder
  if  fmSelFol.BooSelectFolder // unit UnSelFol
    then // var stPathElem from UnGloVar
      stPathElem:=fmSelFol.StrFolderWithPath
    else // to select folder with full path for files with elements
      stPathElem:=stPathDefault; // stPathDefault string from UngloVar
finally
  fmSelFol.Free;
end;
end;

procedure TfmPuz.MenuEphResClick(Sender: TObject);
begin // to use form that is in UnSelFol
  fmSelFol:=TfmSelFol.Create(Self); // form to select folder
try
  fmSelFol.StrSelFolLabelCap:=' :  ';
  fmSelFol.FileListBox.Mask:='*.afu;*.ahu;*.eph';
  fmSelFol.ShowModal; // form to select path to folder
  if  fmSelFol.BooSelectFolder // unit UnSelFol
    then // var stPathResult from UnGloVar
      stPathResult:=fmSelFol.StrFolderWithPath; // folder is choosed
    // to select folder with full path for files with results
finally
  fmSelFol.Free;
end;
  if  not BooPrtF  then  PrtFileOpen ;  // unit UnForPrt
  fmPuz.SaveDialog.InitialDir:=stPathResult;
end;

procedure TfmPuz.MenuEphCooClick(Sender: TObject);
begin
  fmSelFol:=TfmSelFol.Create(Self); // form to select folder
try
  fmSelFol.StrSelFolLabelCap:=' :  ';
  fmSelFol.FileListBox.Mask:='*.txt';
  fmSelFol.ShowModal; // form to select path to folder
  if  fmSelFol.BooSelectFolder // unit UnSelFol
    then // var stPathResult from UnGloVar
      stPathSite:=fmSelFol.StrFolderWithPath
    else // to select folder with full path for files with site position
      stPathSite:=stPathDefault; // stPathDefault string from UngloVar
finally
  fmSelFol.Free;
end;
end;

procedure TfmPuz.MenuEphCatClick(Sender: TObject);
begin
  fmSelFol:=TfmSelFol.Create(Self); // form to select folder
try
  fmSelFol.StrSelFolLabelCap:=' :  ';
  fmSelFol.FileListBox.Mask:='*bin.dat';
  fmSelFol.ShowModal; // form to select path to folder
  if  fmSelFol.BooSelectFolder // unit UnSelFol
    then // var stPathCat from UnGloVar
      stPathCat:=fmSelFol.StrFolderWithPath;
finally
  fmSelFol.Free;
end;
end;

procedure TfmPuz.ppEphClcClick(Sender: TObject);
begin
  CharForEphem:='P'; // 'P' for point 'O' for object
  ForButtonChoice(''''); // UnForBut for ephemeris
end;

procedure TfmPuz.ppMapViewClick(Sender: TObject); // for PopupMenus
begin
  ForButtonChoice('M'); // from unit UnForBut
end;

procedure TfmPuz.ppDateNewClick(Sender: TObject);
begin
  ForButtonChoice('1'); // from unit UnForBut
end;

procedure TfmPuz.ppAreaViewClick(Sender: TObject);
begin
case  CharForView  of // global character from UnGloVar
  'S' , 'L' : ForButtonChoice('%'); // for sky from unit UnForBut
  'W' : ForButtonChoice('A'); // for map from unit UnForBut
end;  // case CharForView
end;

procedure TfmPuz.ppPrtPosClick(Sender: TObject);
begin // for 'S' ICRS information about object
case  CharForView  of // global character from UnGloVar
  'S' : ForButtonChoice('I'); // for sky from unit UnForBut
  'W' : ForButtonChoice('V'); // for map from unit UnForBut
end;  // case CharForView  'W' to choice satellites
end;

procedure TfmPuz.ppSatLookClick(Sender: TObject);
begin
  ForButtonChoice('&'); // to look from the satellite UnForBut
end;

procedure TfmPuz.MenuEphSapClick(Sender: TObject);
begin // to view one satellite from the station
  CharForEphem:='P'; // 'P' for point 'O' for object
  ForButtonChoice(''''); // UnForBut for ephemeris
end;

procedure TfmPuz.MenuEphSaoClick(Sender: TObject);
begin // to view one object from the satellite
  CharForEphem:='O'; // 'P' for point 'O' for object
  ForButtonChoice('"'); // UnForBut for ephemeris
end;

procedure TfmPuz.MenuDiaRaClick(Sender: TObject);
begin
  VMagMax:=4.2; // to limit stars with magnitude
  fmPuz.FormResize(Sender); // to figure sky
end;

procedure TfmPuz.MenuDiaReClick(Sender: TObject);
begin
  VMagMax:=6.2; // to limit stars with magnitude
  fmPuz.FormResize(Sender); // to figure sky
end;

procedure TfmPuz.MenuDiaRiClick(Sender: TObject);
begin
  VMagMax:=9.2; // to limit stars with magnitude
  fmPuz.FormResize(Sender); // to figure sky
end;

procedure TfmPuz.MenuDiaRoClick(Sender: TObject);
begin
  VMagMax:=25.2; // to limit stars with magnitude
  fmPuz.FormResize(Sender); // to figure sky
end;

procedure TfmPuz.MenuDiaSClick(Sender: TObject); // to save
begin
with  fmPuz  do
  PuzSaveBmp(ClientWidth,ClientHeight,
             ClientWidth+8,ClientHeight+8,4,4,Canvas);
end;

procedure TfmPuz.MenuDiaXClick(Sender: TObject); // to exit
begin
  fmPuz.Close;
end;

procedure TfmPuz.MenuDiaWClick(Sender: TObject);
begin // from 'S' to 'W' option and back to 'S'
  ForButtonChoice('M'); // from unit UnForBut
end;

procedure TfmPuz.MenuDiaLClick(Sender: TObject);
begin // to 'L' option to look from the satellite
  ForButtonChoice('&'); // from unit UnForBut
end;

procedure TfmPuz.MenuEphSavClick(Sender: TObject);
begin
  CharForEphem:='V'; // 'P' 'O' 'V' for vector condition
  ForButtonChoice('V'); // UnForBut for ephemeris
end;

end.
