 UNIT UnitSelH; // to fill array of records NameValue[] with some values
               // sorry but by the hand value by value
 INTERFACE

 Procedure ToGetValueAllStepInDay ;

 Procedure ToGetValueAreaSize ;

 procedure StepValueForFixSat ; // proc is called by ForButtonC from UnForBut

 IMPLEMENTATION

 Uses
   SysUtils , // for function IntToStr
   UnConTyp , // for GraRad
   UnGloVar , // for array of records NameValue[] .strname .valname
   PUnCRead , // for boolean variable BrightStarsOnly
   UnButIni , // for record SkyParm
   UnForFun , // procedure PrDegrAngle
   UnForStr ; //  function IntegerToFixStr

 Procedure ToGetValueAllStepInDay ; // step in time to view sky
 Var
   vh,vm,vs  : Extended;
 Begin
   vh:=1.0/24.0; { one hour }
   vm:=1.0/1440.0; { one minute }
   vs:=1.0/86400.0; { one second in part of day }
   NameValue[1].strname:= '10 ';        NameValue[1].valname:= 10*365.25;
   NameValue[2].strname:= ' 5 ';        NameValue[2].valname:= 5*365.25;
   NameValue[3].strname:= ' 2 ';       NameValue[3].valname:= 2*365.25;
   NameValue[4].strname:= ' 1 ';        NameValue[4].valname:= 365.25;
   NameValue[5].strname:= ' 6 ';    NameValue[5].valname:= 183;
   NameValue[6].strname:= ' 3 ';     NameValue[6].valname:= 92;
   NameValue[7].strname:= ' 2 ';     NameValue[7].valname:= 61;
   NameValue[8].strname:= ' 1 ';      NameValue[8].valname:= 30;
   NameValue[9].strname:= '20 ';       NameValue[9].valname:=20;
   NameValue[10].strname:= '10 ';      NameValue[10].valname:=10;
   NameValue[11].strname:= ' 5 ';      NameValue[11].valname:=5;
   NameValue[12].strname:= ' 2 ';       NameValue[12].valname:=2;
   NameValue[13].strname:= ' 1 ';      NameValue[13].valname:=1;
   NameValue[14].strname:='12 ';      NameValue[14].valname:=0.5;
   NameValue[15].strname:=' 6 ';      NameValue[15].valname:=0.25;
   NameValue[16].strname:=' 3 ';       NameValue[16].valname:=3*vh;
   NameValue[17].strname:=' 2 ';       NameValue[17].valname:=2*vh;;
   NameValue[18].strname:=' 1 ';        NameValue[18].valname:=vh;
   NameValue[19].strname:='30 ';      NameValue[19].valname:=30*vm;
   NameValue[20].strname:='20 ';      NameValue[20].valname:=20*vm;
   NameValue[21].strname:='10 ';      NameValue[21].valname:=10*vm;
   NameValue[22].strname:=' 5 ';      NameValue[22].valname:=5*vm;
   NameValue[23].strname:=' 2 ';     NameValue[23].valname:=2*vm;
   NameValue[24].strname:=' 1 ';     NameValue[24].valname:=vm;
   NameValue[25].strname:='30 ';     NameValue[25].valname:=30*vs;
   NameValue[26].strname:='10 ';     NameValue[26].valname:=10*vs;
   NameValue[27].strname:=' 5 ';     NameValue[27].valname:=5*vs;
   NameValue[28].strname:=' 2 ';    NameValue[28].valname:=2*vs;
   NameValue[29].strname:=' 1 ';    NameValue[29].valname:=vs;
   NameValue[30].strname:='0.1  ';  NameValue[30].valname:=0.1*vs;
   NumNameValue:=30;
 End;

 Procedure ToGetValueAreaSize ; // only to change X Y inDegC current scale
 Var
   narea  : Byte ;
   sa,st  : ShortString ;
   id,im  : Integer ;
   xd,yd  : Extended ;
   rdegc  : Extended ;
   ddegc  : Extended ;
   x,y,s  : Extended ;
 Begin // procedures to know area in InButIni the main parameter RinDegC
   If  BrightStarsOnly // boolean from PUnCRead
     Then // for big area size 30 degree on y axes
       Begin rdegc:=15.0; ddegc:=1.25; End
     Else // for small area size 3 degree on y axes
       Begin rdegc:=1.5;  ddegc:=0.125; end;
   narea:=0;
 Repeat
   narea:=narea+1;
   yd:=rdegc; // yd in degree half size for y axes  xd for x axes
   xd:=SkyParm.dx*(yd/SkyParm.dy); // record SkyParm from UnButIni
   x:=2*GraRad*xd; // area x axes to radian const GraRad from UnConTyp
   y:=2*GraRad*yd; // area y axes to radian
   PrDegrAngle(x,st,id,im,s); // procedure PrDegrAngle
   sa:='   '+IntToStr(id)+''+IntegerToFixStr(im,2)+''''; // IntToStr SysUtils
   PrDegrAngle(y,st,id,im,s); // from unit UnForFun
   sa:=sa+'  x  '+IntToStr(id)+''+IntegerToFixStr(im,2)+''''; // UnForStr
   NameValue[narea].strname:=sa;
   NameValue[narea].valname:=rdegc; // half on y axes in degree
   rdegc:=rdegc-ddegc;
 Until  narea = 12 ;
   NumNameValue:=narea;
 End;

 procedure StepValueForFixSat ; // proc is called by ForButtonC from UnForBut
 begin // to change step only for satellite is called UnMouSky UnForBut
   NumStepValue:=26; // UnGloVar 10 second from UnitSelH
   StepWithTime:=10.0/86400.0 // UnGloVar step 10 second
 end;

 END.
