unit UnMemIni ; // to Get and to Free Memory

interface

procedure ForCreateMem ; // to get memory when FormCreate

procedure ForCloseMem ;  // to free memory when FormClose

implementation

uses
  UnCoTVar ; // for memory with pointer

procedure ForCreateMem ; // to get memory when FormCreate
begin
  { heaps for the stars in field of view }
  GetMem(StarAllHeap,SizeOf(TStarAllHeap));
  GetMem(ObjectTopHeap,SizeOf(TObjectTopHeap));
  GetMem(SatElemHeap,SizeOf(TSatElemHeap));
end;

procedure ForCloseMem ;  // to free memory when FormClose
begin
  { to free memory from heaps }
  FreeMem(SatElemHeap,SizeOf(TSatElemHeap));
  FreeMem(ObjectTopHeap,SizeOf(TObjectTopHeap));
  FreeMem(StarAllHeap,SizeOf(TStarAllHeap));
end;

end.