unit UnMouSky;

interface

uses
  Classes ,  // for TShiftState TMouseButton
  Controls , // for Cursor property
  Graphics , // for Color TextWidth
  Menus ,    // paLeft paRight PopupMenu
  Forms ;    // for bsNone of BorderStyle

procedure CursorInform ( s  : ShortString ;  a , d  : Extended ) ;

procedure CursorFigu ( x , y  : Integer ) ; // to change from of cursor

procedure MouseInSky ( x , y  : Integer ) ; // where is mouse? Sky or panel

procedure MouseRightClick ( x , y  : Integer ) ; // for PopupMenuS

procedure MouseLeftClick ( x , y  : Integer ) ; // to fix object

procedure MouseClickButton ( x , y  : Integer ) ; // for all NumButt buttons

implementation

uses
  UnitMain ,  // for fmPuz class
  UnClaMap ,  // for TMapW class
  UnButIni ,  // for rectangular SkyRect PointInRect AllBut[1..NumButt]
  UnFigIni ,  // for procedure FiguPlac
  UnConTyp ,  // type TVect3
  UnGloVar ,  // for variable AzimutC AltitudeC
  UnForSys ,  // for procedure FromTopToFixEqu
  UnPlateC ,  // for procedure SpherCoordinates
  UnPlaceA ,  // for procedure ViewPlac FiguViewMap
  UnForPos ,  // function stDayOrNight
  UnForSat ,  // function stNumSatlVis
  UnForSta ,  // for procedure StarToMemory
  UnPlaceO ,  // to place information about objects on screen ToScreenObject
  PUnCRead ,  // for boolean BrightStarsOnly
  UnForBut ,  // for procedure ForButtonChoice
  UnitSelH ,  // for procedure StepValueForFixSat
  UnitFixO ;  // for procedure ToDefineFixObject

procedure CursorInform ( s  : ShortString ;  a , d  : Extended ) ;
var
  b,c  : Extended ; //  b c alpha delta refer to fix equator
  pos  : TVect3 ;   // topocentric horizontal descart UnConTyp
begin
  fmPuz.Canvas.Font.Style:=[fsBold]; // a d azimuth altitude
  ToScreenPosButt(s,a,d); // procedure from UnButIni
  case  CharForView  of
    'S' , 'L' :
          begin // for constellation
            FromTopToFixEqu(a,d,b,c,pos); // unit UnForSys
            ToScreenCnsButt(b,c); // in degree for constellation  UnButIni
          end; //  b c alpha delta pos topocentric horizontal descart
  end; // case
end;

procedure CursorFiguS ( b  : Boolean ;  x , y  : Integer ) ; // for sky 'S'
var
  a,d  : Extended ;   // a d azimuth altitude in degree
begin
  if  b  // cursor in the sky
    then
      begin
        SpherCoordinates(x,y,a,d); // UnPlateC in degree
        CursorInform(' ',a,d) // for ToScreenPosBut from  UnButIni
      end
    else // cursor out of the sky
      CursorInform('',AzimutC,AltitudeC); // var from UnGloVar
end;
 // for look from the satellite 'L'
procedure CursorFiguL ( b  : Boolean ;  x , y  : Integer ) ;
var
  a,d  : Extended ;   // a d azimuth altitude in degree
begin
  if  b  // cursor in the sky
    then
      begin
        SpherCoordinates(x,y,a,d); // UnPlateC in degree
        CursorInform(' ',a,d) // for ToScreenPosBut from  UnButIni
      end
    else // cursor out of the sky
      CursorInform('',AzimutC,AltitudeC); // var from UnGloVar
end;

procedure CursorFiguM ( b  : Boolean ;  x , y  : Integer ) ; // for map 'M'
var
  a,d  : Extended ; // longitude latitude in degree
  bom  : Boolean ;
begin
  if  BooMapPoint  // UnGloVar
    then           // there is fixed point at the map
      begin
        MapW.PointName(MapW.PointMapF.xf,
                       MapW.PointMapF.yf); // UnClaMap station name to screen
        MapW.PointMapF.sd:=stDayOrNight(JulianDate,          // UnForPos
                                        MapW.PointMapF.vf,   // UnClaMap
                                        MapW.PointMapF.ff);  // class TMapW
        MapW.AboutDayN(MapW.PointMapF.sd); // day twilight night
        MapW.AboutSatV(stNumSatlVis(MapW.PointMapF.vf,   // UnForSat
                                    MapW.PointMapF.ff)); // UnClaMap
        CursorInform('  ',MapW.PointMapF.vf,MapW.PointMapF.ff);
        Exit;
      end;
  if  b  // cursor amongs the map
    then
      begin
        MapW.PointFila(x,y,bom,d,a); // UnClaMap in degree
        if  a < 0.0  then  a:=360+a;
        MapW.PointName(x,y); // UnClaMap station name to screen
        if  bom
          then
            CursorInform(' ',a,d) // var from UnGloVar  UnButIni
          else
            CursorInform('',a,d);  // center for map UnClaMap
      end
    else // cursor out of the map
      begin  // for the center of the map
        a:=45.0; // longitude in degree for center
        d:=0.0;  // latitude  in degree for center
        CursorInform('',a,d);  // center for map // UnClaMap
      end;
  MapW.PointMapF.sd:=stDayOrNight(JulianDate,a,d); // UnClaMap UnForPos
  MapW.AboutDayN(MapW.PointMapF.sd); // UnForPos
  MapW.AboutSatV(stNumSatlVis(a,d)); // UnForSat UnClaMap
  MapW.PointMapF.vf:=a; // longitude in degree
  MapW.PointMapF.ff:=d; // latitude  in degree
end;

procedure CursorFigu ( x , y  : Integer ) ;
var
  b  : Boolean ;
begin // cursor crCross inner Sky rectangle or crDefault in other case
  b:=PointInRect(x,y,SkyRect); // from unit UnButIni
  if  b
    then // with the form of cursor
      fmPuz.Cursor:=crCross
    else
      fmPuz.Cursor:=crDefault;
  case  CharForView  of  // UnGloVar
    'S' : CursorFiguS(b,x,y); // for sky
    'W' : CursorFiguM(b,x,y); // for map
    'L' : CursorFiguL(b,x,y); // for look
  end; // case CharForView
end; // procedure CursorFigu

procedure MouseInSky ( x , y  : Integer ) ;
begin
  if  not PointInRect(x,y,SkyRect) // from unit UnButIni
    then // mouse is out the sky rectangle
      SkyBooX:=False // var from UnButIni
    else // mouse is in the sky rectangle and may be stop at the object
      ToScreenObject(x,y); // unit UnPlaceO SkyBooX is True if screen inform
end;

procedure MouseRightClick ( x , y  : Integer ) ; // for PopupMenu
var
  xp,yp  : Integer ; // position PopupMenu on the full screen
begin
  if  x < SkyParm.xh  // half of screen for sky Client area
    then  fmPuz.PopupMenuS.Alignment:=paLeft   // paLeft  unit Menus
    else  fmPuz.PopupMenuS.Alignment:=paRight; // paRight unit Menus
  xp:=fmPuz.Left+fmPuz.Width-fmPuz.ClientWidth+x;  // x Client position
  yp:=fmPuz.Top+fmPuz.Height-fmPuz.ClientHeight+y; // y Client position
  fmPuz.PopupMenuS.Popup(xp,yp); // xp yp position in full screen
end;

procedure MouseSimpleClick ( x , y  : Integer ) ;
var  // to change centre of the sky after click by the left button
  a,d  : Extended ;
begin // SkyBooX from unit UnButIni
  if  CharForView = 'W'  Then  Exit ; // for sky look not for map
  InitForFixCase ;     // UnitFixO
  SpherCoordinates(x,y,a,d); // azimut altitude from UnPlaceA in degree
  AzimutC:=a;   // new centre azimuth  for point x y
  AltitudeC:=d; // new centre altitude for point x y
  If  CharForView = 'S'           // for sky option
    then                          // all objects
      if  AltitudeC < RinDegC-1   // may be only
        then                      // one by one
          AltitudeC:=RinDegC-1 ;  // above horizon
  FiguPlac ; // unit UnFigIni
  StarToMemory ; // unit UnForSta  all stars in selected rectangle
  ViewPlac ; // from Unit UnPlaceA
end;

procedure MouseLeftClickSky ( x , y  : Integer ) ;
var  // a try to choice and fix object after click by the left button
  a,d  : Extended ;
begin // var SkyBooX bolean is declared in unit UnButIni
  if  not SkyBoox
    then // there is not screen inform about object
      begin
        MouseSimpleClick(x,y);
        Exit ;
      end;
  BooFixObject:=True; // this object is chosen and fixed at the centre
  ToDefineFixObject ; // UnitFixO for ObjectTopHeap^[OBoxInform]
  if  chFixObject = 'S' // character is assigned in UnitFixO
    then
      StepValueForFixSat ; // UnitSelH small step only for satellite
  ToClearBoxInform ; // UnPlaceO  to clear screen information about object
  SpherCoordinates(x,y,a,d); // UnPlateC azimut altitude in degree
  AzimutC:=a;   // new centre azimuth  for point x y
  AltitudeC:=d; // new centre altitude for point x y
  If  CharForView = 'S'           // for sky option
    then                          // all objects
      if  AltitudeC < RinDegC-1   // may be only
        then                      // one by one
          AltitudeC:=RinDegC-1 ;  // above horizon
  FiguViewPlac ; // UnPlaceA with StarToMemory and others
end;

procedure MouseLeftClickMap ( x ,y  : Integer ) ;
var                // x y position of the cursor among map world
  f  : Extended ;  // map  latitude in degree
  v  : Extended ;  // map longitude in degree
  b  : Boolean ;   // corresponding to x y position of the cursor
begin
  MapW.PointFila(x,y,b,f,v); // lati longi tude may be linked cursor
  if  BooMapPoint
    then // to new fixed point
      begin
        BooMapPoint:=False;
        fmPuz.ppEphClc.Enabled:=False; // form fmPuz UnitMain
        fmPuz.MenuEphClc.Enabled:=False;
        FiguViewMap ; // UnPlaceA
      end;
  if  not b  then  Exit ;    // b False if cursor is out of map world
  BooMapPoint:=True;         // UnGloVar to fix one point on the map
  fmPuz.ppEphClc.Enabled:=True;        // form fmPuz UnitMain
  fmPuz.MenuEphClc.Enabled:=True;
  if  v < 0.0  then  v:=360.0+v; // to prevent strange case
  MapW.ToSelectP(x,y,f,v);   // to select point at the map world
end;

procedure MouseLeftClick ( x , y  : Integer ) ;
begin // a try to choice and fix object after click by the left button
  case  CharForView  of // var CharForView UnGloVar for stars 'S'
   'S' , 'L' : MouseLeftClickSky(x,y);  // planets satellites 'L'
   'W'  : MouseLeftClickMap(x,y);    // clicking in world map 'W'
  end;  // case CharForView
end;

procedure MouseClickButton ( x , y  : Integer ) ; // for all buttons
var
  kb  : Byte ;
  nb  : Byte ;
begin
  kb:=0;
  for nb:=1 to NumButt do // AllButt[1..NumButt] from unit UnButIni
    if  PointInRect(x,y,AllButt[nb].rb) // function from UnButIni
      then // rb of TRectBut x1,x2,y1,y2
        kb:=nb; // is button for reaction
  if  kb > 0 // concrete button is choiced
    then // cb of Char character for button
      ForButtonChoice(AllButt[kb].cb); // from unit UnForBut
end;

end.
