unit UnMuDraw ; { to draw simple rectangle by mouse if Ctrl is held down }
interface
uses
  Classes ; { type TShiftState }
var
  boomoud  : Boolean ; { to draw by mouse if true and Ctrl down }
  xcdraw,ycdraw  : Integer ; { point centre to draw rectangle }
  xrdraw,yrdraw  : Integer ; { current point position }
procedure ForMouseDraw ( i  : Byte ;
                         s  : TShiftState ;
                         x , y  : Integer ) ;
procedure AfterDrawSky ;  { CharForEphem = 'R' from station }
procedure AfterDrawLook ; { CharForEphem = 'Q' from satellite }
procedure AfterSkyKey ;   { if 'Y' key is pressed 'S'  sky option }
procedure AfterLooKey ;   { if 'Y' key is pressed 'L' look option }
implementation
uses
  Graphics , { for Canvas property method }
  Windows  , { for type TRect }
  UnitMain , { for fmPuz form with canvas to draw }
  UnButIni , { for record SkyParm xa xb ya yb }
  UnGloVar , { for CharForEphem }
  UnSatEph , { modal form fmSatEph graphic memo }
  UnStandP ; { for procedure SmallRecPosEqu }
{ i=0 FormMouseDown Shift=ssCtrl x,y point centre }
procedure PointCentre ( x , y  : Integer ) ;
var
  rb : TRectBut ; { type for rectangle from UnButIni }
begin
  boomoud:=False; { mouse may be out the sky rectangle }
  rb.x1:=SkyParm.xa; { UnButIni left  point in sky image }
  rb.x2:=SkyParm.xb; { UnButIni right point in sky image }
  rb.y1:=SkyParm.ya; { UnButIni top point in sky image }
  rb.y2:=SkyParm.yb; { UnButIni bottom point sky image }
  if  not PointInRect(x,y,rb)  then  Exit ; { out the Sky }
  xcdraw:=x;     { centre point x position }
  ycdraw:=y;     { centre point y position }
  xrdraw:=x;     { initial }
  yrdraw:=y;     { initial  }
  boomoud:=True; { it is possible to draw rectangle }
end;
{ to compare with SkyParm from UnButIni
  with SkyParm it is necessary
    xa < x1 < xb  xa < x2 < xb
    ya < y1 < yb  a < y2 < yb }
procedure OurBorder ( x , y  : Integer ;
                      var  x1 , x2 , y1 , y2  : Integer ) ;
begin { x y cdraw rdraw are known for this procedure }
 { border of the rectangle }
  x1:=xcdraw-Abs(x-xcdraw);
  x2:=xcdraw+Abs(x-xcdraw);
  y1:=ycdraw-Abs(y-ycdraw);
  y2:=ycdraw+Abs(y-ycdraw);
  if  x1 < SkyParm.xa  then  x1:=SkyParm.xa;
  if  x2 > SkyParm.xb  then  x2:=SkyParm.xb;
  if  y1 < SkyParm.ya  then  y1:=SkyParm.ya;
  if  y2 > SkyParm.yb  then  y2:=SkyParm.yb;
end;
{ to draw rectangle by using MoveTo and LineTo methods }
procedure ToDrawOurRect ( x , y  : Integer ;  AMode  : TPenMode ) ;
var
  x1,x2,y1,y2  : Integer ; { for current rectangle }
begin
  fmPuz.Canvas.Pen.Mode:=AMode; { to start draw }
  OurBorder(x,y,x1,x2,y1,y2); { to compare with SkyParm  UnButIni }
  with  fmPuz.Canvas  do
    begin
      MoveTo(x1,y1);
      LineTo(x2,y1);
      LineTo(x2,y2);
      LineTo(x1,y2);
      LineTo(x1,y1);
    end;
end;
{ i=1 FormMouseMove boomoud=True x,y point of rectangle }
procedure PointCurrent ( x , y  : Integer ) ;
begin
  if  not boomoud  then  Exit ; { may be this variant }
  ToDrawOurRect(xrdraw,yrdraw,pmNotXor);
  ToDrawOurRect(x,y,pmNotXor);
  xrdraw:=x;
  yrdraw:=y;
end;
{ i=2 FormMouseUp   Shift=ssCtrl x,y to fix rectangle }
procedure PointRectFix ( x , y  : Integer ) ;
var
  b  : Boolean ; { size of rectangle may be too small }
begin
  if  not boomoud  then  Exit ; { may be this variant }
  b:= ( Abs(xrdraw-xcdraw) > 15 )         // size of half
        and ( Abs(yrdraw-ycdraw) > 15 ) ; // rectangle in pixel
  if  ( CharForView in [ 'S' , 'L' ] )   { for sky and look }
        and b               { but not for map }
    then                    { rectangle is selected }
      fmSatEph.ToGetBmp;    { BitMap to bodbmp global UnPhysOp }
  ToDrawOurRect(xrdraw,yrdraw,pmNotXor);
  fmPuz.Canvas.Pen.Mode:=pmCopy; { to finish draw }
  boomoud:=False;     { rectangle may be drawed }
  case  CharForView  of  { sky or look }
    'S' : CharForEphem:='R';  { sky  UnGloVar global variable }
    'L' : CharForEphem:='Q';  { look UnGloVar global variable }
  end; // CharForView
  if  ( CharForView in [ 'S' , 'L' ] ) { for sky and look }
        and b     { but not for map rectangle is selected }
    then
      begin
        fmSatEph.PassToMemo ; { UnSatEph method }
        fmSatEph.ShowModal;   { UnSatEph modal form fmSatEph }
      end;
end;
{ to draw rectangle by mouse if Ctrl key is held down
  is called from UnitMain by proc. FormMouse Down Move Up
  i=0 FormMouseDown Shift=ssCtrl x,y point centre
  i=1 FormMouseMove boomoud=True x,y point of rectangle
  i=2 FormMouseUp   Shift=ssCtrl x,y to fix rectangle }
procedure ForMouseDraw ( i  : Byte ;
                         s  : TShiftState ;
                         x , y  : Integer ) ;
begin
  if  ( ssRight in s )  then  Exit ;
  case  i  of
    0 : PointCentre(x,y);
    1 : PointCurrent(x,y);
    2 : PointRectFix(x,y);
  end; { case i }
end;
{ proc is called by fmSatEph.PassToMemo
  when  CharForEphem = 'R' in horizon system from station }
procedure AfterDrawSky ;
var
  x1,x2,y1,y2  : Integer ; { for current rectangle }
begin
  fmSatEph.NumPoint:=1;
  OurBorder(xrdraw,yrdraw,x1,x2,y1,y2); { with SkyParm  UnButIni }
  SmallRecPosEqu(x1,x2,y1,y2); { from UnStandP procedure }
end;
{ proc is called by fmSatEph.PassToMemo
  when  CharForEphem = 'Q' in orbital system from satellite }
procedure AfterDrawLook ;
var
  x1,x2,y1,y2  : Integer ; { for current rectangle }
begin
  fmSatEph.NumPoint:=1;
  OurBorder(xrdraw,yrdraw,x1,x2,y1,y2); { with SkyParm  UnButIni }
  SmallRecPosLoo(x1,x2,y1,y2); { from UnStandP procedure }
end;
{ 'S' look option only
  to model small rectangle for information }
procedure AfterSkyKey ; // 'S' sky option if 'Y' key is pressed
begin
  xcdraw:=SkyParm.xh; // UnButIni centre of the screen x axis
  ycdraw:=SkyParm.yh; // UnButIni centre of the screen y axis
  xrdraw:=xcdraw-25;  // size of small rectangle x axis
  yrdraw:=ycdraw-25;  // size of small rectangle y axis
  ToDrawOurRect(xrdraw,yrdraw,pmNotXor); // rectangle to screen
  fmSatEph.ToGetBmp;  // BitMap to bodbmp global UnPhysOp
  ToDrawOurRect(xrdraw,yrdraw,pmNotXor); // rectangle from screen
  fmPuz.Canvas.Pen.Mode:=pmCopy; // to finish draw our rectangle
  CharForEphem:='R';    // for 'S' sky UnGloVar global variable
  fmSatEph.PassToMemo ; // UnSatEph method
  fmSatEph.ShowModal;   // UnSatEph modal form fmSatEph
end;
{ 'L' look option only
  to model small rectangle for information }
procedure AfterLooKey ; // 'L' look option if 'Y' key is pressed
begin
  xcdraw:=SkyParm.xh; // UnButIni centre of the screen x axis
  ycdraw:=SkyParm.yh; // UnButIni centre of the screen y axis
  xrdraw:=xcdraw-25;  // size of small rectangle x axis
  yrdraw:=ycdraw-25;  // size of small rectangle y axis
  ToDrawOurRect(xrdraw,yrdraw,pmNotXor); // rectangle to screen
  fmSatEph.ToGetBmp;  // BitMap to bodbmp global UnPhysOp
  ToDrawOurRect(xrdraw,yrdraw,pmNotXor); // rectangle from screen
  fmPuz.Canvas.Pen.Mode:=pmCopy; // to finish draw our rectangle
  CharForEphem:='Q';    // for 'L' look UnGloVar global variable
  fmSatEph.PassToMemo ; // UnSatEph method
  fmSatEph.ShowModal;   // UnSatEph modal form fmSatEph
end;
end.
