unit UnParamO ; // to obtain some parameters to view objects
interface
uses
  UnConTyp ; // type TVect3 TMatr33
procedure OurPlaFromHea ( nump  : Byte ; // our planet 'P'
                          var  b  : Boolean ; // true if yes
                          var  n  : LongInt ) ;  // number in array
procedure PointParametr ( np  : Byte ; // number of planet
                          var  b  : Boolean ; // yes or no
                          var  am , ap , ar , ud  : Extended ) ;
procedure ParamLimbuP ( n  : Byte ;  // NSun for the Sun but nullo
                        p , s  : TVect3 ;    // vectors
                        tm , rm  : TMatr33 ; // matrix to change
                        var  am , ap , ar , ud  : Extended ) ;
implementation
uses
  UnCoTVar , // global point array of record ObjectTopHeap^[..]
  UnGloVar , // global variable PosZemelaC
  UnForCoo , // procedure DescFromHorizCoor ClcSpherCoorInDegree
  UnForFun , // procedure MatrMultVector VectorModul
  PUnDE200 ; // const NSun for example
{ to find the planet in array }
procedure OurPlaFromHea ( nump  : Byte ; // our planet 'P'
                          var  b  : Boolean ; // true if yes
                          var  n  : LongInt ) ;  // number in array
begin { to find the planet in array }
  n:=0; // initial count value
  b:=False; // initial to find
repeat
  n:=n+1; // the next object from array
  with  ObjectTopHeap^[n]  do             // UnCoTVar
    if  ( chps = 'P') and ( nall = nump ) // it is
      then                                // the planet that find
        b:=True;  // then planet is found
until  b or ( n = NumObjectInHeap ) ;     // UnCoTVar
end;
{ orbital system
  pb vector satellite - planet
  pe vector satellite - Earth
  pv perpendicular
    from the centre of the Earth
    to the satellite - body direction }
procedure PerpendiculaV ( pb , pe  : TVect3 ;
                          var  pv  : TVect3 );
var
  i  : Byte ;
  sc,sp,cb  : Extended ;
  ze,zp,zq  : Extended ;
begin
  sc:=ScalarMult(pe,pb); // UnForFun scalar multiplication
  ze:=VectorModul(pe);   // UnForFun range satellite - Earth
  zp:=VectorModul(pb);   // UnForFun range satellite - body
  cb:=sc/(ze*zp); // cos(beta) is angle between two directions
  sp:=ze*cb; // range from satellite to perpendicular
  zq:=sp/zp; // the ratio may be less then nullo
  { where zq*pb[i]
    is vector from the satellite
    to perpendicular in orbital system }
  for i:=1 to 3 do         // vector perpendicular orbital system
    pv[i]:=zq*pb[i]-pe[i]; // refer to the Earth's centre
end;
{ angle of dissipation  is angle between two direction
    linked with special point P on the Earth's surface
    line from P to the Sun and line from P to the satellite
    all vectors in orbital system
    vector p  from satellite to the Sun
    vector e  from satellite to the Earth's centre
    vector v  from the Earth's centre to the point crossing p }
function ToGetDissipAngle ( p , e , v  : TVect3 ) : Extended ;
var
  i  : Byte ;       // simple count
  r,q  : Extended ; // simple temporary float range or ratio
  s,c  : Extended ; // sinus cosinus of our dissipation angle
  a,b  : TVect3 ;   // the Sun and sat from the surface point
begin
  ToGetDissipAngle:=-100.0; // default
  r:=VectorModul(v); // UnForFun range of perpendicular
  if  ( r < ( GeoR0-50.0 ) )  then  Exit ; // the Sun is covered
  q:=GeoR0/r; // simple ratio for point on the surface
  for i:=1 to 3 do
    begin
      b[i]:=-(e[i]+q*v[i]); // satellite from the surface point
      a[i]:=b[i]+p[i];      // the Sun   from the surface point
    end;
  c:=ScalarMunt(a,b); // cosinus of our dissipation angle
  s:=Sqrt(Abs(1-Sqr(c))); // sinus always positive
  ToGetDissipAngle:=RadGra*DATan2(s,c); // UnForFun UnConTyp
end;
{ for the perpendicular
  from the centre of the Earth
    to the satellite - body direction
  PosZemelaC global from UnGloVar
    is Earth's from the satellite orbital system
  procedure is called by AboutPointP in UnSatVaz
  output parameters
  Earth's rotating system
  am longitude
  ap latitude
  ar range from the Earth's surface  ud angle of dissipation
  angle of dissipation is angle between two direction
    linked with special point P on the Earth's surface
    line from P to the Sun and line from P to the satellite }
procedure PointParametr ( np  : Byte ; // number of planet
                          var  b  : Boolean ; // yes or no
                          var  am , ap , ar , ud  : Extended ) ;
var // meridian geospheric coordinates and dissipation angle
  n  : LongInt ; // simple count of the object
  p  : TVect3 ;  // UnConTyp the body orbital position
  v  : TVect3 ;  // our vector that perpendicular to line
  q  : TVect3 ;  // from orbital to true equator
  r  : TVect3 ;  // our vector refer to greenwich meridian
begin
  OurPlaFromHea(np,b,n);  // to find our planet
  if  not b  then  Exit ; // no our planet in list
  { body from satellite orbital position type TVect3 UnConTyp }
  with  ObjectTopHeap^[n]  do         // global UnGoTVar
    DescFromHorizCoor(azt,alt,rot,p); // UnForCoo orbital
  { PosZemelaC Earth's centre from the satellite orbital
    v vector of perpendicular ud angle of dissipation }
  PerpendiculaV(p,PosZemelaC,v); // our vector orbital system
  ud:=ToGetDissipAngle(p,PosZemelaC,v); // dissipation's angle
  { matrix to change TopMatr RosMatr UnGloVar }
  UMatrMultVect(TopMatr,v,q);  // from orbital system to true equa
  MatrMultVector(RosMatr,q,r); // from true equinox to greenwich
  ClcSpherCoorInDegree(r,am,ap,ar); // meridian  geospheric coor
  ar:=ar-GeoR0*(1-ParmA*Sqr(Sin(GraRad*ap))); // UnConTyp const
end;
{ for the perpendicular
  from the centre of the Earth
    to the satellite - body direction
  input  parameters
    n simple number is necessary only for the Sun other null
    p body position refer to the satellite in orbital system
    s centre of the Earth position to satl in orbital system
    tm matrix to change from true equator  to orbital system
    rm matrix to change from true equinox to greenwich merid
  procedure is called by some proc in UnSatVau
  output parameters
  Earth's rotating system
  am longitude
  ap latitude
  ar range from the Earth's surface  ud angle of dissipation
  angle of dissipation is angle between two direction
    linked with special point P on the Earth's surface
    line from P to the Sun and line from P to the satellite }
procedure ParamLimbuP ( n  : Byte ;  // NSun for the Sun but nullo
                        p , s  : TVect3 ;    // vectors
                        tm , rm  : TMatr33 ; // matrix to change
                        var  am , ap , ar , ud  : Extended ) ;
var // meridian geospheric coordinates and dissipation angle
  v  : TVect3 ;  // our vector that perpendicular to line
  q  : TVect3 ;  // from orbital to true equator
  r  : TVect3 ;  // our vector refer to greenwich meridian
begin
  { p body from satellite orbital position type TVect3 UnConTyp
    s Earth's centre from the satellite orbital
    v vector of perpendicular
    ud angle of dissipation only for the Sun}
  PerpendiculaV(p,s,v); // our vector orbital system
  if  n = NSun          // to define number const PUnDE200
    then                          // dissipation's angle
      ud:=ToGetDissipAngle(p,s,v) // only for the Sun
    else                          // other case
      ud:=-400.0;                 // non real value
  { matrix to change procedures from UnForFun UnForCoo }
  UMatrMultVect(tm,v,q);  // from orbital system to true equa
  MatrMultVector(rm,q,r); // from true equinox to greenwich
  ClcSpherCoorInDegree(r,am,ap,ar); // meridian  geospheric coor
  ar:=ar-GeoR0*(1-ParmA*Sqr(Sin(GraRad*ap))); // UnConTyp const
end;
end.