unit UnPhysOp ; // for physical observations the Sun the planets parameters
interface       // current moment JulianDate from UnGloVar
uses
  Graphics ; // for TBitMap TColor and other
var
  bodbmp  : TBitMap ; // to figure the Sun the Moon in UnGraAll
{ for orientation of the poles parallels meridians
  body the planets the Moon or the Sun np number of planet }
procedure RotoBody ( n  : Byte ;  a , b , r  : Integer ) ;
implementation
uses
  Windows  , // for TPoint
  UnConTyp , // type TMatr33 TVect3
  UnCoTVar , // global var ObjectTopCur
  UnGloVar , // JulianDate current moment
  PUnDE200 , // const NumberfOPlanets const RadiusPfPlanet[..]
  PUnCRead , // global var BrightStarsOnly
  UnForPos , // proc PosGeoPlanet refer to the Earth fixed equator
  UnForFun , // proc RotoBodyMatr alpha delta angle w are known in degree
  UnForCoo ; // proc DescFromSpherCoor in degree
var
  numpha  : Word ;
  bodpha  : array[1..399] of TPoint ; // type Windows .x .y
{ body pole position fixed equator
  some data from the book
  Oliver Montenbruck
  Thomas Pfleger
  Astronomy on the Personal Computer
  PITER 2002 }
procedure PoleBody ( np  : Byte ;
                     tc  : Extended ;
                     var  ym  : TMatr33 ) ;
var
  a,d,w  : Extended ;
begin
  a:=0.0;
  d:=+90.0;
  w:=+10.0;
case  np  of
  NSun : // a first try for the Sun
  begin  // const GraRad JD2000 from UnConTyp
    a:=286.13; // right ascension of the pole in degree
    d:=63.87;  // declination of the pole in degree
    w:=(84.182+14.1844*(tc-JD2000)); // the first meridian angle in degree
  end;
end; // case number of planet or the Moon the Sun
  { matrix to change from the fixed equator to the body system }
  RotoBodyMatr(a,d,w,ym); // UnForFun
end;
{ to topocentric horizontal
  y  point of the body
     refer to the centre of the body in fixed equator
  result  x  vector for the point topocentric  horizon
  value of rotation matrix  RotMatr TopMatr  are known }
procedure PointTopHor ( y  : TVect3 ;  var  x  : TVect3 ) ;
var
  b  : TVect3 ; // point position to the centre of the body  true equa
begin
  MatrMultVector(RotMatr,y,b); // UnForFun from fixed to true equator
  MatrMultVector(TopMatr,b,x); // UnForFun topocentric horizon vector
end;
{ matrix to change from horizon to screen plane
     R_x(90+altitude)*R_z(180-Azimuth+90) Azimuth left
     to figure some body point on screen
     by using ObjectTopCur.
     Azt Alt Rot change to screen plane matrix
     for this purpose it is necessary
     to direct axis OZ from the centre of the body
     to the point of observation }
procedure BodyScrM ( var  am : TMatr33 ) ;
var
  ra,rd  : Extended ; // 180-azimuth altitude radian
  sa,ca  : Extended ; // cosinus sinus 180-azimuth
  sd,cd  : Extended ; // cosinus sinus altitude
begin                 // ObjectTopCur global var UnCoTVar
  ra:=GraRad*(180.0-ObjectTopCur.Azt); // for 180-azimuth left
  rd:=GraRad*ObjectTopCur.Alt; // altitude ObjectTopCur for this body
  sa:=Sin(ra); // simple sinus 180-azimuth
  ca:=Cos(ra); // simple cosinus 180-azimuth
  sd:=Sin(rd); // simple sinus altitude
  cd:=Cos(rd); // simple cosinus altitude
  { matrix to change from horizon to screen plane
    R_x(90+altitude)*R_z(180-Azimuth+90)
    but A'=180-Azimuth
    and our matrix is
    R_x(90+altitude)*R_z(90+(180-Azimuth)) }
  am[1,1]:=-sa;     // axis OZ is now direct from the centre of the body
  am[1,2]:=+ca;     // to the point of observation
  am[1,3]:=0;       // if coordinate z <=0
  am[2,1]:=+sd*ca;  // then point on the body is not visible
  am[2,2]:=+sd*sa;
  am[2,3]:=+cd;
  am[3,1]:=+cd*ca;
  am[3,2]:=+cd*sa;
  am[3,3]:=-sd;
end;
{ to BitMap.Canvas one point
  a b  BitMap plane position of body  r  BitMap radius
  x    topocentric horizontal vector of the point
  z    matrix to change from horizontal to screen plane }
procedure PointToBitM ( a , b , r  : Integer ;
                        x  : TVect3 ;
                        z  : TMatr33 ;
                        l  : TColor ) ;
var
  i  : Byte ;
  s  : Extended ; // range
  y  : TVect3 ;   // vector in plane after changing
  u  : Extended ; // screen x offset from the centre a b
  v  : Extended ; // screen y offset from the centre a b
  c  : Integer ;  // screen x position
  d  : Integer ;  // screen y position
begin
  MatrMultVector(z,x,y); // to rotate to screen plane UnForFun
  if  y[3] <= 0.0  then  Exit ; // body point is not visible
  s:=VectorModul(y); // UnForFun range for unit vector
  for i:=1 to 3 do  y[i]:=y[i]/s; // to unit vector
  u:=r*y[1]; // r is the radius of the image on the screen
  v:=r*y[2]; // offset from the centre point a b
  c:=a+Round(u); // to screen with centre point a b
  d:=b-Round(v); // to screen with centre point a b
  bodbmp.Canvas.Pixels[c,d]:=l; // to put one pixel to the point
end;
{ to figure the first nullo meridian
  to bodbmp TBitMap
  nb body number
  a b  BitMap plane position of body  r  BitMap radius
  xb body position fixed equator refer to the Earth
  yb matrix to change to body pole meridian
  zb matrix to change to screen plane }
procedure BodyNulM ( nb  : Byte ;
                     a , b , r  : Integer ;
                     yb , zb  : TMatr33 ) ;
var
  ap  : Extended ; // point latitude  body system
  al  : Extended ; // point longitude body system
  ar  : Extended ; // point range body system
  zp  : TVect3 ;   // body point position in body rotating system
  yp  : TVect3 ;   // body point position fixed equator to use yb
  xp  : TVect3 ;   // body point position topocentric horizontal
  cl  : TColor ;   // from Graphics
begin
  ar:=RadiusOfPlanet[nb]; // const in km from PUnDE200
  al:=0.0;   // longitude the first (nullo) meridian in degree
  ap:=-90.0; // from the south pole of the body with small step in degree
repeat       // point by point along nullo meridian
  if  ap < 0.0        // different colors
    then  cl:=clRed     // for south hemisphere
    else  cl:=clNavy;   // for north hemisphere
  DescFromSpherCoor(al,ap,ar,zp); // UnForCoo point system descart position
  UMatrMultVect(yb,zp,yp); // UnForFun change point position to fixed equa
  PointTopHor(yp,xp); // to topocentric horizontal RotMatr TopMatr known
  PointToBitM(a,b,r,xp,zb,cl); // to BitMap.Canvas one point
  ap:=ap+1.0;      // small step for latitude in degree on nullo meridian
until  ap > 90.0 ; // to the north pole all angles in degree range km
end;
{ to figure the parallels
  to bodbmp TBitMap
  nb body number
  a b  BitMap plane position of body  r  BitMap radius
  xb body position fixed equator refer to the Earth
  yb matrix to change to body pole meridian
  zb matrix to change to screen plane }
procedure BodySomP ( nb  : Byte ;
                     a , b , r  : Integer ;
                     yb , zb  : TMatr33 ) ;
var
  ap  : Extended ; // point latitude  body system
  al  : Extended ; // point longitude body system
  ar  : Extended ; // point range body system
  zp  : TVect3 ;   // body point position in body rotating system
  yp  : TVect3 ;   // body point position fixed equator to use yb
  xp  : TVect3 ;   // body point position topocentric horizontal
  cl  : TColor ;   // from Graphics
begin
  ar:=RadiusOfPlanet[nb]; // const in km from PUnDE200
  ap:=-60.0; // latitude for parallel in degree
repeat       // for some value of parallels
  al:=0.0; // from the first meridian of the body in degree
repeat     // point by point along this parallel with small step
  if  ap < 0.0        // different colors
    then  cl:=clRed     // for south hemisphere
    else  cl:=clNavy;   // for north hemisphere
  DescFromSpherCoor(al,ap,ar,zp); // UnForCoo point system descart position
  UMatrMultVect(yb,zp,yp); // UnForFun change point position to fixed equa
  PointTopHor(yp,xp); // to topocentric horizontal RotMatr TopMatr known
  PointToBitM(a,b,r,xp,zb,cl); // to BitMap.Canvas one point
  al:=al+1.0; // small step for longitude in degree on this parallel
until  al > 360.0 ; // to the nullo meridian angles in degree range km
  ap:=ap+30.0;      // big step for other paralles
until  ap > 80.0 ;  // from south pole to north pole
end;
{ to figure meridians parallels }
procedure BodyMerP ( np  : Byte ;       // body number
                     a , b , r  : Integer ; // screen coordinates
                     tc  : Extended ;   // current moment
                     zm  : TMatr33 ) ;  // matrix for scr plane
var
  ym  : TMatr33 ;  // matrix to change to body pole meridian
begin
  PoleBody(np,tc,ym); // matrix to change fixed equator to body system
  BodyNulM(np,a,b,r,ym,zm); // to figure some points nullo meridian
  BodySomP(np,a,b,r,ym,zm); // to figure some points for parallels
end;
{ to obtain matrix
  to change from the direction to the Sun to North pole }
procedure DirMatS ( s  : TVect3 ;  var  u  : TMatr33 ) ;
var
  i  : Byte ;      // count
  a  : Extended ; // right ascension
  d  : Extended ; // declination
  r  : Extended ; // range for unit vector
  v  : TVect3 ;   // unit vector direct to the Sun
  p  : TMatr33 ;  // around x angle 90-declination
  q  : TMatr33 ;  // around z angle 90-right ascension
begin
  r:=VectorModul(s); // UnForFun range for unit vector to the Sun
  for i:=1 to 3 do  v[i]:=s[i]/r; // unit direct to the Sun
  ClcSpherCoorInDegree(v,a,d,r); // UnForCoo to spheric coordinates
  d:=90-d; // the first  rotation in degree angle (90 - decl_Sun)
  SimpleRotMatr(1,d,p); // UnForFun to rotate around x axis
  a:=90-a; // the second rotation in degree angle (90 - r.a._Sun)
  SimpleRotMatr(3,a,q); // UnForFun to rotate around z axis
  MatrMultMatr(q,p,u);  // UnForFun to multiply matrixes
end;
{ longitude on nullo parallel
  special system when axis OZ direct to the Sun
  u z matrix of tranformations
  result value point position Z in screen plane }
function ValonP ( g  : Extended ;  u , z  : TMatr33 ) : Extended ;
var
  p  : TVect3 ;   // simple vector
  q  : TVect3 ;   // simple vector
begin
  p[1]:=Cos(GraRad*g); // along nullo parallel unit vector
  p[2]:=Sin(GraRad*g); // for any longitude value
  p[3]:=0.0; // Z axis direct to the Sun very special system
  MatrMultVector(u,p,q); // UnForFun to the fixed equator
  PointTopHor(q,p); // to topocentric horizontal RotMatr TopMatr known
  MatrMultVector(z,p,q); // to rotate to screen plane UnForFun
  ValonP:=q[3]; // if q[3] < 0 then point is not visible
end;
{ to find start and finish longitude value for screen
  u matrix to change from the direction to the Sun to the north
  z matrix to change to the screen plane
  g value of longitude when point is not visible  }
procedure ToFindP ( u , z  : TMatr33 ;
                    var  c , d  : Extended ) ; // start finish
var
  g  : Extended ; // for value longitude by longitude
  h  : Extended ; // the same for temporary
  s  : Extended ; // step in degree to find two values
  x  : Extended ; // z position on screen
  y  : Extended ; // the same for interpolation
begin
  c:=0.0; // default start  value
  d:=9.0; // default finish value
  s:=1.0; // step in degree to find start and finish
  g:=0.0; // initial longitude along nullo parallel
  while  ( g < 360.0 )  // full circle to find the middle val
          and ( ValonP(g,u,z) < 0.0 )  do  g:=g+30.0;
  if  ValonP(g,u,z) < 0.0  then  Exit ; // no success
  h:=g;
  { now for longitude g our point is visible
    our purpose to find two longitude
    c start d finish  c < g < d }
  g:=h; // backward from this moment minus step
  while  ValonP(g,u,z) > 0.0  do  g:=g-s; // to start moment
  x:=ValonP(g,u,z);   // longitude  g  when x < 0
  y:=ValonP(g+s,u,z); // longitude g+s when y > 0
  c:=g-x*s/(y-x); // interpolation for start longitude
  { it is start but it is necessary to find finish }
  g:=h; // forward from this moment plus step
  while  ValonP(g,u,z) > 0.0  do  g:=g+s; // to start moment
  x:=ValonP(g,u,z);   // longitude  g  when x < 0
  y:=ValonP(g-s,u,z); // longitude g-s when y > 0
  d:=g-x*s/(x-y); // interpolation for finish longitude
end;
{ point for phase }
procedure PointPhaseB ( a , b , r  : Integer ; // screen parm
                        x  : TVect3 ;          // unit vector
                        z  : TMatr33 ) ;       // change matr
var
  y  : TVect3 ;   // vector in plane after changing
  u  : Extended ; // screen x offset from the centre a b
  v  : Extended ; // screen y offset from the centre a b
  c  : Integer ;  // screen x position
  d  : Integer ;  // screen y position
begin
  MatrMultVector(z,x,y); // to rotate to screen plane UnForFun
  if  y[3] <= 0.0  then  Exit ; // body point is not visible
  u:=r*y[1]; // r is the radius of the image on the screen
  v:=r*y[2]; // offset from the centre point a b
  c:=a+Round(u); // to screen with centre point a b
  d:=b-Round(v); // to screen with centre point a b
  numpha:=numpha+1; // the next our screen point
  bodpha[numpha].x:=c; // screen x pixel
  bodpha[numpha].y:=d; // screen y pixel
end;
{ points in circle to bodpha for phase }
procedure OtherPoints ( a , b , r  : Integer ) ;
var
  n  : Word ; // count
  c,s  : Extended ; // co sinus
  u,v  : Extended ;   // angle
begin
  n:=numpha; // on circle
  s:=bodpha[n].y-b;
  c:=bodpha[n].x-a;
  u:=DATan2(s,c);
  v:=u;
repeat
  numpha:=numpha+1;
  bodpha[numpha].x:=Round(r*Cos(v))+a;
  bodpha[numpha].y:=Round(r*Sin(v))+b;
  v:=v-Pi/180.0;
until  v < u-Pi;
end;
{ vector s in fixed equator direct to the Sun }
procedure DirectS ( s  : TVect3 ; // unit vector direct to the Sun
                    a , b , r  : Integer ; // screen coordinates
                    z  : TMatr33 ) ;  // matrix for scr plane
var
  g  : Extended ; // variable to change with longitude in degree
  c  : Extended ; // from this value of longitude in degree
  d  : Extended ; //   to this value of longitude in degree
  x  : Extended ; // step for longitude in degree
  p  : TVect3 ;  // vector nullo when Z axis direct to the Sun
  q  : TVect3 ;  // the same vector but in fixed equator
  u  : TMatr33 ; // matrix to change from the direction to the Sun
begin
  DirMatS(s,u); // auxiliary matrix to the north pole direction
  ToFindP(u,z,c,d); // start finish longitude along nullo parallel
  x:=(d-c)/180.0; // number of step = 180
  numpha:=0; // count for point
  g:=c;   // longitude from start value
repeat    // when Z axis direct to the Sun
  p[1]:=Cos(GraRad*g); // along nullo parallel unit vector
  p[2]:=Sin(GraRad*g); // for any longitude value
  p[3]:=0.0; // Z axis direct to the Sun very special system
  MatrMultVector(u,p,q); // UnForFun to the fixed equator
  PointTopHor(q,p); // to topocentric horizontal RotMatr TopMatr known
  PointPhaseB(a,b,r,p,z); // to bodpha[..] one point numpha
  g:=g+x;  // the next value of longitude x step in degree
until  g > d ;  // finish value for longitude
  OtherPoints(a,b,r); // points in circle to bodpha for phase
end;
{ by using numpha points in bodpha array of TPoint }
procedure GraPhas ;
var
  c  : TColor ; // tpe from Graphics
begin
  c:=clWhite; // default for the Moon
  case  ObjectTopCur.nall  of  // NMoon NVenus NMercury
    NVenus   : c:=clAqua;
    NMercury : c:=clOlive;
  end; // case for color
with  bodbmp.Canvas  do
  begin // for the Moon or the planet phase
    case  ObjectTopCur.IndexShadow  of  // for shadow UnCoTVar
      0 : begin // no shadow
            bodbmp.Canvas.Pen.Color:=c; // that part of the bopdy
            bodbmp.Canvas.Brush.Color:=c; // is lit by the Sun
          end;
      1 : begin  // semishadow
            bodbmp.Canvas.Pen.Color:=clRed;   // that is lit
            bodbmp.Canvas.Brush.Color:=clRed; // by half Sun
          end;
      2 : begin  // full shadow
            bodbmp.Canvas.Pen.Color:=clMaroon;   // that is
            bodbmp.Canvas.Brush.Color:=clMaroon; // full shadow
          end;
      end; // case for shadow it is important for the Moon
  bodbmp.Canvas.Polygon(Slice(bodpha,numpha)); // this part
  end;  // with Canvas
end;
{ how body is lit by the Sun
  np number body tc current moment }
procedure BodySunL ( np  : Byte ;
                     a , b , r  : Integer ; // screen coordinates
                     tc  : Extended ;   // current moment
                     zm  : TMatr33 ) ;  // matrix for scr plane
var
  i  : Byte ;
  re,rs,rb,vv  : TVect3 ; // vectors for body position fixed equa
begin
  ClcPosVel(np,tc,rb,vv); // PUnDE200 body fixed equator
  if  np = NMoon // but all planets refer to the barycentre
    then // because the Moon refer to the centre of the Earth
      begin     // the Earth refer to barycentre
        ClcEphEarth(tc,re,vv); // PUnDE200
        for i:=1 to 3 do      // fixed equator
          rb[i]:=re[i]+rb[i]; // the Moon refer to barycentre
      end;
  ClcPosVel(NSun,tc,rs,vv); // the Sun refer to barycentre
  for i:=1 to 3 do          // fixed equator
    rs[i]:=rs[i]-rb[i]; // the Sun refer to body or the Moon
  DirectS(rs,a,b,r,zm); // with vector direct to the Sun
  GraPhas ; // by using numpha points in bodpha array of TPoint
end;
{ for orientation of the poles parallels meridians
  body the planets the Moon or the Sun
  a b  BitMap plane position of body  r  BitMap radius }
procedure RotoBody ( n  : Byte ;  a , b , r  : Integer ) ;
var                // number of body
  t  : Extended ; // current moment
  z  : TMatr33 ;  // matrix to change to screen plane
begin
  if  not n in [ NSun , NMoon ]  then  Exit ; // only for those
  t:=JulianDate; // UnGloVar current
  BodyScrM(z); // by using ObjectTopCur. Azt Alt Rot to screen plane matr
case  n  of
  NSun  : BodyMerP(n,a,b,r,t,z); // to figure meridians parallels
  NMoon : BodySunL(n,a,b,r,t,z); // how body is lit for phase
  NVenus : BodySunL(n,a,b,r,t,z); // how body is lit for phase
  NMercury : BodySunL(n,a,b,r,t,z); // how body is lit for phase
end; // case np
end;
end.