unit UnPlaceO; // for screen information about objects

interface

var
  OBoxInform  : LongInt ; // current number of object in ObectTopHeap

procedure ToBoxInform ( k , n  : LongInt ;  c  : Char ;  x , y  : Integer ) ;

procedure ToClearBoxInform ;

procedure ToScreenObject ( x , y  : Integer ) ;

implementation

uses
  SysUtils , // for function IntToStr
  Forms    , // for bsNone BorderStyle
  Graphics , // for TColor type
  UnitMain , // for fmPuz BoxInform and others
  UnConTyp , // for constant GraRad AstrUnit
  UnCotVar , // for pointer variales StarTopHeap^[..]  SatElemHeap^[]
  UnGloVar , // for variable NumStarsInHeap
  UnButIni , // for variables Sky CurX CurY BooX
  PUnCRead , // for procedure ToGetStarFromHeap boolean BrightStarsOnly
  UnForFun , // for PrHourAngle PrDegrAngle
  UnForStr , // for function IntegerToFixStr ToEraseForWardBlanks
  UW_cnst  ; // for record RusStarName MaxProperName

procedure StarNumberToBox ;
var
  s  : ShortString ;
begin
  if  StarOneCur.TycNumber > 0 // record StarOneCur from UnCoTVar
    then // record StarOneCur is assigned in PUnCRead
      begin // string StrNameTychoCat TRC1 or TYC2 from UnCoTVar   UnFilIni
        fmPuz.BoxInform.Items.Add('     TYC2'); // Tycho2 catalogue
        Str(StarOneCur.TycNumber:9,s);
        fmPuz.BoxInform.Items.Add(s);
      end;
  if  StarOneCur.TrcNumber > 0 // record StarOneCur from UnCoTVar
    then // record StarOneCur is assigned in PUnCRead
      begin // string StrNameTychoCat TRC1 or TYC2 from UnCoTVar   UnFilIni
        fmPuz.BoxInform.Items.Add('     TRC1'); // initial TRC1
        Str(StarOneCur.TrcNumber:9,s);
        fmPuz.BoxInform.Items.Add(s);
      end;
  if  StarOneCur.HipNumber > 0
    then
      begin
        fmPuz.BoxInform.Items.Add(' ');
        Str(StarOneCur.HipNumber:9,s);
        fmPuz.BoxInform.Items.Add(s);
      end;
  If  StarOneCur.FK5Number > 0
    then
      begin
        Str(StarOneCur.FK5Number:4,s);
        fmPuz.BoxInform.Items.Add(' 5 '+s);
      end;
end;

procedure StarEquCooToBox ;
var
  s  : ShortString ;
  h  : Integer ;
  m  : Integer ;
  p  : Extended ;
begin
  PrHourAngle(GraRad*StarOneCur.Alpha,s,h,m,p);
  fmPuz.BoxInform.Items.Add('  '+s+IntegerToFixStr(h,2)+'h'
                                 +IntegerToFixStr(m,2)+'m');
  PrDegrAngle(GraRad*StarOneCur.Delta,s,h,m,p);
  fmPuz.BoxInform.Items.Add('  '+s+IntegerToFixStr(h,2)+''
                                 +IntegerToFixStr(m,2)+'''');
end;

procedure StarMagToBox ;
begin
  if  ( StarOneCur.TycNumber > 0 ) or ( StarOneCur.TrcNumber > 0 )
        or ( StarOneCur.HipNumber > 0 )
    then
      fmPuz.BoxInform.Items.Add(' B '+FloatToFixStr(StarOneCur.Bt,6,3));
  fmPuz.BoxInform.Items.Add(' V '+FloatToFixStr(StarOneCur.Vt,6,3));
end;

procedure StarNameToBox ; // if there is name for this star
var
  n  : Word ;
begin
  if  StarOneCur.FK5Number > 0
    then
      For n:=1 To MaxProperName Do
        if  StarOneCur.FK5Number = RusStarName[n].FK5Number // unit UW_cnst
          then
            fmPuz.BoxInform.Items.Add(RusStarName[n].ProperName);
end;

procedure StarInformToBox ( n  : LongInt ) ; // information
begin // about star or object
  ToGetStarFromHeap(n); // procedure from unit PUnCRead to StarOneCur
  StarNumberToBox;
  StarEquCooToBox; // for alpha delta in J2000.0
  StarMagToBox;
  StarNameToBox; // if there is name for this star
end;

procedure PlanetInformToBox ( n  : LongInt );
var
  np  : Integer ;
  dr  : Extended ;
  st  : ShortString ;
begin
  ObjectTopCur:=ObjectTopHeap^[n]; // unit UnCotVar
  np:=ObjectTopCur.nall; // number of object
  fmPuz.BoxInform.Items.Add(' '+ObjectTopCur.name);
  dr:=ObjectTopCur.Rot;  // distance in km
  if  dr < 1.0e6 // 1000000 km
    then
      begin
        Str(dr:12:3,st);
        ToEraseAllBlanks(st); // procedure from unit UnForStr
        fmPuz.BoxInform.Items.Add('  '+st+' ');
      end
    else
      begin
        dr:=dr/AstrUnit; // const AstrUnit from UnConTyp
        Str(dr:12:5,st); // in AU astronomical unit
        ToEraseAllBlanks(st); // procedure from unit UnForStr
        fmPuz.BoxInform.Items.Add('  '+st+' AU');
      end;
  Str(ObjectTopCur.phase:7:3,st);
  ToEraseAllBlanks(st);
  case  ObjectTopCur.IndexShadow  of
    1 : st:=st+'  ';
    2 : st:=st+'   ';
  end; // case IndexShadow
  if  np <> 11  then  fmPuz.BoxInform.Items.Add('  '+st);
  st:='   '+FloatToFixStr(ObjectTopCur.Mag,6,3)+'m';
  if  np < 10 // in this case .chps = 'P'
    then // for planets without the Earth the Moon the Sun
      fmPuz.BoxInform.Items.Add(st);
end;

procedure SatelliteInformToBox ( n  : LongInt );
var
  nsat  : LongInt ;
  stro  : ShortString;
begin
  ObjectTopCur:=ObjectTopHeap^[n]; // unit UnCotVar
  fmPuz.BoxInform.Items.Add(' '+ObjectTopCur.name);
  Str(ObjectTopCur.Rot:12:3,stro);
  ToEraseAllBlanks(stro); // procedure from unit UnForStr
  fmPuz.BoxInform.Items.Add('  '+stro+' ');
  Str(ObjectTopCur.phase:7:3,stro);
  ToEraseAllBlanks(stro);
  case  ObjectTopCur.IndexShadow  of
    1 : stro:=stro+'  ';
    2 : stro:=stro+'   ';
  end; // case IndexShadow
  fmPuz.BoxInform.Items.Add('  '+stro);
  if  ObjectTopCur.Mag < 25.0
    then
      begin
        Str(ObjectTopCur.Mag:7:3,stro);
        ToEraseAllBlanks(stro);
        fmPuz.BoxInform.Items.Add('   '+stro+'m');
      end;
  nsat:=ObjectTopCur.nall; // number of satellite in SatElemHeap
  Str(SatElemHeap^[nsat].an:12:6,stro);
  ToEraseAllBlanks(stro); // procedure from unit UnForStr
  fmPuz.BoxInform.Items.Add(' n '+stro+' ./');
  Str(SatElemHeap^[nsat].ae:12:6,stro);
  ToEraseAllBlanks(stro); // procedure from unit UnForStr
  fmPuz.BoxInform.Items.Add(' e '+stro);
  Str(SatElemHeap^[nsat].ai:12:4,stro);
  ToEraseAllBlanks(stro); // procedure from unit UnForStr
  fmPuz.BoxInform.Items.Add(' i '+stro+' ');
end;

procedure PlaceForBox ( h , w  : Integer ;  Var  a , b  : Integer ) ;
begin
  if  ( a+h > SkyRect.y2-5 )
    then
      begin
        while ( a+h > SkyRect.y2-5 )  do  a:=a-5;
        if  ( b+w > SkyRect.x2-5 )
          then
            b:=b-w-20;
      end
    else
      if  ( b+w > SkyRect.x2-5 )
        then
          b:=b-w-10;
end;

procedure SizePlaceBoxInform ( x ,y  : Integer ) ;
var
  a,b,h,w,n,c,d  : Integer ;
begin
  with  fmPuz.BoxInform  do
    begin
      a:=y+10;
      b:=x+10;
      c:=Canvas.TextHeight('W');
      h:=(Items.Count+1)*c+c div 2;
      c:=0;
      for n:=0 to Items.Count-1 do
        begin
          d:=Length(Items[n]);
          if  c < d  then  c:=d;
        end;
      w:=(c+1)*Canvas.TextWidth('w');
      PlaceForBox(h,w,a,b);
      Top:=a;
      Left:=b;
      Height:=h;
      Width:=w;
    end;
end;

procedure ToBoxInform ( k , n  : LongInt ;  c  : Char ;  x , y  : Integer ) ;
begin
  fmPuz.BoxInform.Clear;
  fmPuz.BoxInform.BorderStyle:=bsSingle; // bs None from unit Forms
  fmPuz.BoxInform.Color:=clLime;
  fmPuz.BoxInform.Font.Name:='Courier New';
  fmPuz.BoxInform.Font.Style:=[fsBold];
  case  c  of
    '*' : StarInformToBox(n);
    'P' : PlanetInformToBox(k); // from record ObjectTopHeap^
    'S' : SatelliteInformToBox(k);
  end;
  SizePlaceBoxInform(x,y);
  fmPuz.BoxInform.Enabled:=True;
  fmPuz.BoxInform.Visible:=True;
  SkyBooX:=True; // var from UnButIni Box is in SkyRect
  OBoxInform:=k; // current number of screen inform object in ObjectTopHeap
end;

procedure ToClearBoxInform ;
begin
  fmPuz.BoxInform.Enabled:=False;
  fmPuz.BoxInform.Visible:=False;
  fmPuz.BoxInform.Clear;
  SkyBooX:=False ; // var from UnButIni Box is not in SkyRect
  if  CharForView in [ 'S' , 'L' ]  then  OBoxInform:=0;   // no object
end;

procedure BoxSatMapInform ( ns  : Byte ) ;
var
  xpos  : Integer ;
  ypos  : Integer ;
  stro  : ShortString ;
begin // information from record SatElemFix
  SatElemFix:=SatElemMap[ns]; // global SatElemMap MapSat X Y UnGloVar
  xpos:=MapSatX[ns]; // x position ImageSat number ns
  ypos:=MapSatY[ns]; // y position ImageSat number ns
  fmPuz.BoxInform.Clear;
  fmPuz.BoxInform.BorderStyle:=bsSingle; // bs Single None from unit Forms
  fmPuz.BoxInform.Color:=clLime;
  fmPuz.BoxInform.Font.Name:='Courier New';
  fmPuz.BoxInform.Font.Style:=[fsBold];
  fmPuz.BoxInform.Items.Add(' '+SatElemFix.satname);
  case  MapSatShadow[ns]  of
    1  : stro:=' ';
    2  : stro:='  ';
  end; // case MapSatShadow
  if  MapSatShadow[ns] > 0
    then
      fmPuz.BoxInform.Items.Add(stro);
  Str(RangeSatMap[ns]:12:3,stro); // height above the Earth from UnGraAll
  ToEraseAllBlanks(stro); // procedure from unit UnForStr
  fmPuz.BoxInform.Items.Add('  '+stro+' ');
  Str(SatElemFix.an:12:6,stro); // mean motion in revolution per day
  ToEraseAllBlanks(stro); // procedure from unit UnForStr
  fmPuz.BoxInform.Items.Add(' n '+stro+' ./');
  Str(SatElemFix.ae:12:6,stro); // eccentricity
  ToEraseAllBlanks(stro); // procedure from unit UnForStr
  fmPuz.BoxInform.Items.Add(' e '+stro);
  Str(SatElemFix.ai:12:4,stro); // inclination in degree
  ToEraseAllBlanks(stro); // procedure from unit UnForStr
  fmPuz.BoxInform.Items.Add(' i '+stro+' ');
  SizePlaceBoxInform(xpos,ypos);
  fmPuz.BoxInform.Enabled:=True;
  fmPuz.BoxInform.Visible:=True;
  SkyBooX:=True; // var from UnButIni Box is in SkyRect
end;

procedure BoxSunMapInform ( ns  : Byte ) ;
var
  xpos  : Integer ;
  ypos  : Integer ;
  strp  : ShortString ;
begin // information about the planet projection
  if  ns = MapSatNumber+1
    then // for the Sun
      strp:='   '
    else
      strp:='   ';
  xpos:=MapSatX[ns]; // x position projection
  ypos:=MapSatY[ns]; // y position projection
  fmPuz.BoxInform.Clear; // to clear boxinform
  fmPuz.BoxInform.BorderStyle:=bsSingle; // bs Single None from unit Forms
  fmPuz.BoxInform.Color:=clLime; // color lightgreen
  fmPuz.BoxInform.Font.Name:='Courier New';
  fmPuz.BoxInform.Font.Style:=[fsBold];
  fmPuz.BoxInform.Items.Add(strp);
  SizePlaceBoxInform(xpos,ypos);
  fmPuz.BoxInform.Enabled:=True;
  fmPuz.BoxInform.Visible:=True;
  SkyBooX:=True; // var from UnButIni Box is in SkyRect
end;

procedure ToScreenObjectInMap ( x , y  : Integer ) ;
var
  ns  : Byte ;
  dx  : Integer ;
  dy  : Integer ;
  bo  : Boolean ;
begin // MapSatX MapSatY position of the image on the screen
  ns:=0; // only for ImageSat amongs world map
repeat
  ns:=ns+1;
  dx:=Abs(x-MapSatX[ns]); // MapSatX and MapSatY is declared in UnGloVar
  dy:=Abs(y-MapSatY[ns]); // and is assigned in UnGraAll when CharForView='S'
  bo:=( ( dx < 4 ) and ( dy < 4 ) );
  if  bo
    then
      if  ns > MapSatNumber
        then
          BoxSunMapInform(ns) // only for Sun projection
        else
          BoxSatMapInform(ns); // information from record SatElemMap[]
until  bo  or ( ns = MapSatNumber+2 ) ; // global var MapSatNumber UnGloVar
  if  ( not bo ) and SkyBooX
    then // small box with information is in SkyRect
      begin
        ToClearBoxInform ; // to delete this box
        for ns:=1 to MapSatNumber+1 do
          begin
            MapSatX[ns]:=-100; // out of screen
            MapSatY[ns]:=-100; // out of screen
          end;
      end;
end;

procedure ToScreenObjectInSky ( x , y  : Integer ) ; // called from UnMouSky
var
  n  : LongInt ;
  b  : Boolean ;
  dx,dy  : Integer ;
begin
  OBoxInform:=0; // initial no number for object with screen information
  n:=0;
repeat
  if  n < NumObjectInHeap  then  n:=n+1;
  while ( not ObjectTopHeap^[n].booscreen )
          and ( n < NumObjectInHeap )
    do  n:=n+1;
  dx:=Abs(x-ObjectTopHeap^[n].xpos); // pointer var from UnCotVar
  dy:=Abs(y-ObjectTopHeap^[n].ypos);
  b:=( ( dx < 2 ) and ( dy < 2 ) );
  if  b
    then
      with  ObjectTopHeap^[n]  do
        ToBoxInform(n,nall,chps,xpos,ypos);
until  b  or ( n = NumObjectInHeap ) ;
  if  ( not b ) and SkyBooX
    then // information is in SkyRect
      ToClearBoxInform ;
end;

procedure ToScreenObject ( x , y  : Integer ) ; // called from UnMouSky
begin
  case  CharForView  of
    'S' , 'L' : ToScreenObjectInSky(x,y);
    'W' : ToScreenObjectInMap(x,y);
  end; // case
end;

end.
