unit UnSatMap; // when 'W' map option form fmSatMap
               // for key 'A' information
interface      // for key 'V' choise of the satellites

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  UnCoTVar ; // for TElemRec

type
  TfmSatMap = class(TForm)
    mmSatMap: TMemo;
    GroupBox: TGroupBox;
    edSatM1: TEdit;
    edSatM2: TEdit;
    edSatM3: TEdit;
    edSatM4: TEdit;
    edSatM5: TEdit;
    edSatM6: TEdit;
    edSatM7: TEdit;
    edSatM8: TEdit;
    ButEsc: TButton;
    ButSel: TButton;
    GroupBop: TGroupBox;
    edPoint: TEdit;
    cbSatM1: TCheckBox;
    cbSatM2: TCheckBox;
    cbSatM3: TCheckBox;
    cbSatM4: TCheckBox;
    cbSatM5: TCheckBox;
    cbSatM6: TCheckBox;
    cbSatM7: TCheckBox;
    cbSatM8: TCheckBox;
    lbLon: TLabel;
    lbLat: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure ButEscClick(Sender: TObject);
    procedure ButSelClick(Sender: TObject);
    procedure mmSatMapKeyPress(Sender: TObject; var Key: Char);
    procedure cbSatM1Click(Sender: TObject);
    procedure cbSatM2Click(Sender: TObject);
    procedure cbSatM3Click(Sender: TObject);
    procedure cbSatM4Click(Sender: TObject);
    procedure cbSatM5Click(Sender: TObject);
    procedure cbSatM6Click(Sender: TObject);
    procedure cbSatM7Click(Sender: TObject);
    procedure cbSatM8Click(Sender: TObject);
    procedure edSatM1Click(Sender: TObject);
    procedure edSatM2Click(Sender: TObject);
    procedure edSatM3Click(Sender: TObject);
    procedure edSatM4Click(Sender: TObject);
    procedure edSatM5Click(Sender: TObject);
    procedure edSatM6Click(Sender: TObject);
    procedure edSatM7Click(Sender: TObject);
    procedure edSatM8Click(Sender: TObject);
    procedure GroupBoxClick(Sender: TObject);
  private
    { Private declarations }
    function stAboutVis : ShortString ;
    procedure AllVisCase ;
    procedure AboutVisToMemo ;
    procedure AboutPoinToBox ;
    procedure SatlBoxInit ;
    procedure AboutSatlToBox ;
    procedure SatMapCaseA ;
    procedure SatMapCaseV ;
    procedure SatMapCaseN ;
    function AfterSatMap : Byte ;
    procedure AnotherFolder ;
  public
    { Public declarations }
    SatMel   : TElemRec ;  // type from UnCoTVar
    SatMapC  : Char ; // 'A' 'V' 'N' for different case
    SatMapN  : ShortString ;  // may be new name of the point
    function BooChangeSatl : Boolean ;
  end;

var
  fmSatMap: TfmSatMap;

implementation

{$R *.DFM}

uses
  UnClaMap , // for variables from class TMapW
  UnConTyp , // for const DifEpoch
  UnGloVar , // for global variables MapSatNumber ... Altitude[..] ...
  UnSelFel , // for class fmSelFel methods
  UnSatMel , // for class fmSatMel methods
  UnForStr , // for function FloatToFixStr
  UnForDat , // for function StringFromDate
  UnFilElm , // for ToGetElemFormat function
  UnFilesO , // proc ToSelect OneCatalogue OneSetOfElem
  UnGraBmp , // for procedure PuzSaveBmp
  UnrfNord , // for proc ToReadNoradFormat
  UnrfIrvs , // for proc ToWorkWithIRVSfmt
  UnrfKodr ; // for proc ToWorkWithKodrfmt

function TfmSatMap.stAboutVis : ShortString ;
var
  nm  : Byte ; // count for satellites
  nv  : Byte ; // count for visibility
begin
  nv:=0; // default no visibility
  for nm:=1 to MapSatNumber do  // var from UnGloVar
    if  MapSatAltitude[nm] > 0.0
      then
        nv:=nv+1; // the satellite above horizon
  if  nv = 0
    then
      stAboutVis:='     '
    else
      stAboutVis:='  '+IntToStr(nv)+' -    ';
end;

procedure TfmSatMap.AllVisCase ;
var
  n  : Byte ; // count for satellites
  s  : ShortString ;
begin
for n:=1 to MapSatNumber do  // var from UnGloVar
  if  MapSatAltitude[n] > 0.0
    then  // the satellite above horizon
      begin
        mmSatMap.Lines.Add('  '+IntegerToFixStr(SatElemMap[n].satnuml,7)
                           +'   '+SatElemMap[n].satname);
        case  MapSatShadow[n]  of
          0 : s:='   ';
          1 : s:='  ';
          2 : s:='   ';
        end; // case
        mmSatMap.Lines.Add(s);
        mmSatMap.Lines.Add('  '+FloatToFixStr(MapSatAltitude[n],7,3)
                           +'     ');
        mmSatMap.Lines.Add('  '+FloatToFixStr(RangeSatMap[n],10,3)
                           +'    ');
        mmSatMap.Lines.Add('  '+FloatToFixStr(SatElemMap[n].an,9,6)
                           +'   ');
        mmSatMap.Lines.Add('  '+FloatToFixStr(SatElemMap[n].ae,9,7)
                           +'  ');
        mmSatMap.Lines.Add('  '+FloatToFixStr(SatElemMap[n].ai,9,5)
                           +'   ');
        mmSatMap.Lines.Add('  ');
      end;
end;

procedure TfmSatMap.AboutVisToMemo ;
begin
with  mmSatMap  do
  begin
    Clear;
    Lines.Add(' '+MapW.PointMapF.sf); // name of point if exists
    Lines.Add('  '+FloatToFixStr(MapW.PointMapF.vf,6,2)+'   longitude');
    Lines.Add('  '+FloatToFixStr(MapW.PointMapF.ff,6,2)+'    latitude');
    Lines.Add('  '+MapW.PointMapF.sd);
    Lines.Add('  ');
    Lines.Add('  ');
    Lines.Add(StringFromDate(JulianDate)); // function UnForDat var UnGloVar
    Lines.Add('  ');
    Lines.Add(stAboutVis);
    Lines.Add('  ');
    AllVisCase ;
    Lines.Insert(0,'  ');
  end; // with  mmSatMap
end;

procedure TfmSatMap.AboutPoinToBox ;
begin
  edPoint.Text:=MapW.PointMapF.sf       // name of point if exists
                +' '+MapW.PointMapF.sd; // day twilight or night
  lbLon.Caption:='  '+FloatToFixStr(MapW.PointMapF.vf,6,2)+' ';
  lbLat.Caption:='   '+FloatToFixStr(MapW.PointMapF.ff,6,2)+' ';
end;

procedure TfmSatMap.SatlBoxInit ;
begin
  cbSatM1.Checked:=False;
  cbSatM2.Checked:=False;
  cbSatM3.Checked:=False;
  cbSatM4.Checked:=False;
  cbSatM5.Checked:=False;
  cbSatM6.Checked:=False;
  cbSatM7.Checked:=False;
  cbSatM8.Checked:=False;
  edSatM1.Text:=' ';
  edSatM2.Text:=' ';
  edSatM3.Text:=' ';
  edSatM4.Text:=' ';
  edSatM5.Text:=' ';
  edSatM6.Text:=' ';
  edSatM7.Text:=' ';
  edSatM8.Text:=' ';
end;

procedure TfmSatMap.AboutSatlToBox ;
begin
  SatlBoxInit ;
  if  MapSatNumber = 0  then  Exit ;
  edSatM1.Text:=SatElemMap[1].satname;
  cbSatM1.Checked:=True;
  if  MapSatNumber = 1  then  Exit ;
  edSatM2.Text:=SatElemMap[2].satname;
  cbSatM2.Checked:=True;
  if  MapSatNumber = 2  then  Exit ;
  edSatM3.Text:=SatElemMap[3].satname;
  cbSatM3.Checked:=True;
  if  MapSatNumber = 3  then  Exit ;
  edSatM4.Text:=SatElemMap[4].satname;
  cbSatM4.Checked:=True;
  if  MapSatNumber = 4  then  Exit ;
  edSatM5.Text:=SatElemMap[5].satname;
  cbSatM5.Checked:=True;
  if  MapSatNumber = 5  then  Exit ;
  edSatM6.Text:=SatElemMap[6].satname;
  cbSatM6.Checked:=True;
  if  MapSatNumber = 6  then  Exit ;
  edSatM7.Text:=SatElemMap[7].satname;
  cbSatM7.Checked:=True;
  if  MapSatNumber = 7  then  Exit ;
  edSatM8.Text:=SatElemMap[8].satname;
  cbSatM8.Checked:=True;
end;

procedure TfmSatMap.SatMapCaseA ;
begin
  GroupBox.Enabled:=False;
  GroupBox.Visible:=False;
  GroupBop.Enabled:=False;
  GroupBop.Visible:=False;
  ButSel.Enabled:=False;
  ButSel.Visible:=False;
  ButEsc.Enabled:=False;
  ButEsc.Visible:=False;
  AboutVisToMemo ; // information about point and satellites
  mmSatMap.Align:=alClient;
  mmSatMap.Enabled:=True;
  mmSatMap.Visible:=True;
  mmSatMap.SetFocus;
end;

procedure TfmSatMap.SatMapCaseV ;
begin
  mmSatMap.Enabled:=False;
  mmSatMap.Visible:=False;
  GroupBox.Enabled:=True;
  GroupBox.Visible:=True;
  GroupBop.Enabled:=True;
  GroupBop.Visible:=True;
  ButSel.Enabled:=True;
  ButSel.Visible:=True;
  ButEsc.Enabled:=True;
  ButEsc.Visible:=True;
  edPoint.ReadOnly:=True;
  edPoint.Hint:='';        // no changing in the field of point name
  AboutPoinToBox ;
  AboutSatlToBox ;
end;

procedure TfmSatMap.SatMapCaseN ;
begin
  mmSatMap.Enabled:=False;
  mmSatMap.Visible:=False;
  GroupBox.Enabled:=True;
  GroupBox.Visible:=True;
  GroupBop.Enabled:=True;
  GroupBop.Visible:=True;
  ButSel.Enabled:=True;
  ButSel.Visible:=True;
  ButEsc.Enabled:=True;
  ButEsc.Visible:=True;
  edPoint.ReadOnly:=False; // it is possible to name point at the map
  edPoint.Hint:='  ';
  AboutPoinToBox ;
  AboutSatlToBox ;
  edPoint.SetFocus;
  edPoint.SelectAll;
end;

procedure TfmSatMap.FormActivate(Sender: TObject);
begin
  SatMapN:=MapW.PointMapF.sf;
case  SatMapC  of
  'A' : SatMapCaseA ; // information about point and visibility satellites
  'V' : SatMapCaseV ; // a possibility to select another satellite
  'N' : SatMapCaseN ; // a possibility to name point at the map world
end; // case
end;

procedure TfmSatMap.ButEscClick(Sender: TObject);
begin
  Close;
end;

function TfmSatMap.AfterSatMap : Byte ;
var
  n  : Byte ; // to analyse cbSatM?.Checked
  m  : Byte ; // and to change array SatElemMap
  b  : Array[1..8] of Boolean ;
begin
  b[1]:=cbSatM1.Checked;
  b[2]:=cbSatM2.Checked;
  b[3]:=cbSatM3.Checked;
  b[4]:=cbSatM4.Checked;
  b[5]:=cbSatM5.Checked;
  b[6]:=cbSatM6.Checked;
  b[7]:=cbSatM7.Checked;
  b[8]:=cbSatM8.Checked;
  m:=0;
  for n:=1 to 8 do
    if  b[n]
      then
        begin
          m:=m+1;
          SatElemMap[m]:=SatElemMap[n];
        end;
  AfterSatMap:=m;
end;

procedure TfmSatMap.ButSelClick(Sender: TObject);
begin
  MapSatNumber:=AfterSatMap;
  if  SatMapC = 'N'  then  SatMapN:=edPoint.Text; // to name point
  Close ;
end;

procedure TfmSatMap.mmSatMapKeyPress(Sender: TObject; var Key: Char);
begin
  if  Key = #27  then  ButEscClick(Sender); // exit key Esc
  if  Key = #13  then  ButSelClick(Sender); // key Enter
end;

procedure TfmSatMap.cbSatM1Click(Sender: TObject);
begin
with  cbSatM1  do
  begin
    if  Pos(' ',edSatM1.Text) > 0  then  Checked:=False;
    if  Checked
      then  Caption:=''
      else
        begin
          Caption:='';
          edSatM1.Text:=' ';
        end;
  end;
end;

procedure TfmSatMap.cbSatM2Click(Sender: TObject);
begin
with  cbSatM2  do
  begin
    if  Pos(' ',edSatM2.Text) > 0  then  Checked:=False;
    if  Checked
      then  Caption:=''
      else
        begin
          Caption:='';
          edSatM2.Text:=' ';
        end;
  end;
end;

procedure TfmSatMap.cbSatM3Click(Sender: TObject);
begin
with  cbSatM3  do
  begin
    if  Pos(' ',edSatM3.Text) > 0  then  Checked:=False;
    if  Checked
      then  Caption:=''
      else
        begin
          Caption:='';
          edSatM3.Text:=' ';
        end;
  end;
end;

procedure TfmSatMap.cbSatM4Click(Sender: TObject);
begin
with  cbSatM4  do
  begin
    if  Pos(' ',edSatM4.Text) > 0  then  Checked:=False;
    if  Checked
      then  Caption:=''
      else
        begin
          Caption:='';
          edSatM4.Text:=' ';
        end;
  end;
end;

procedure TfmSatMap.cbSatM5Click(Sender: TObject);
begin
with  cbSatM5  do
  begin
    if  Pos(' ',edSatM5.Text) > 0  then  Checked:=False;
    if  Checked
      then  Caption:=''
      else
        begin
          Caption:='';
          edSatM5.Text:=' ';
        end;
  end;
end;

procedure TfmSatMap.cbSatM6Click(Sender: TObject);
begin
with  cbSatM6  do
  begin
    if  Pos(' ',edSatM6.Text) > 0  then  Checked:=False;
    if  Checked
      then  Caption:=''
      else
        begin
          Caption:='';
          edSatM6.Text:=' ';
        end;
  end;
end;

procedure TfmSatMap.cbSatM7Click(Sender: TObject);
begin
with  cbSatM7  do
  begin
    if  Pos(' ',edSatM7.Text) > 0  then  Checked:=False;
    if  Checked
      then  Caption:=''
      else
        begin
          Caption:='';
          edSatM7.Text:=' ';
        end;
  end;
end;

procedure TfmSatMap.cbSatM8Click(Sender: TObject);
begin
with  cbSatM8  do
  begin
    if  Pos(' ',edSatM8.Text) > 0  then  Checked:=False;
    if  Checked
      then  Caption:=''
      else
        begin
          Caption:='';
          edSatM8.Text:=' ';
        end;
  end;
end;

procedure TfmSatMap.AnotherFolder;
begin // stElementFile is declared in UnGloVar
  stElementFile:=fmSelFel.StrSelFel; // name of file with elements
  case  ToGetElemFormat(stElementFile)  of  // function from UnFilElm
    'N' : ToReadNoradFormat(stElementFile); // UnrfNord
    'I' : ToWorkWithIRVSfmt(stElementFile); // UnrfIrvs
    'K' : ToWorkWithKodrfmt(stElementFile); // UnrfKodr
    'Z' : ShowMessage(stElementFile+'   ');
  end;
end;

function TfmSatMap.BooChangeSatl : Boolean ;
begin
repeat
  BooChangeSatl:=False;
  fmSatMel.ShowModal ;
  if  fmSatMel.BooSat
    then // new satellite is choosen
      begin
        SatMel:=SatElemHeap^[fmSatMel.NumElm]; // record UnCoTVar
        BooChangeSatl:=True;                   // there is our satellite
        Exit;
      end;
  if  fmSatMel.BooFol
    then  // a try to find another folder with the elements
      begin
        ToSelectOneSetOfElem ; // UnFilesO
        if  fmSelFel.BooSelFel // from UnSelFel
          then
            AnotherFolder
          else
            fmSatMel.BooFol:=False;
      end;
until  not fmSatMel.BooFol ;
end;

procedure TfmSatMap.edSatM1Click(Sender: TObject);
begin
  if  BooChangeSatl
    then
      begin
        SatElemMap[1]:=SatMel;
        edSatM1.Text:=SatMel.satname;
        cbSatM1.Checked:=True;
        cbSatM1.Caption:='';
      end;
end;

procedure TfmSatMap.edSatM2Click(Sender: TObject);
begin
  if  BooChangeSatl
    then
      begin
        SatElemMap[2]:=SatMel;
        edSatM2.Text:=SatMel.satname;
        cbSatM2.Checked:=True;
        cbSatM2.Caption:='';
      end;
end;

procedure TfmSatMap.edSatM3Click(Sender: TObject);
begin
  if  BooChangeSatl
    then
      begin
        SatElemMap[3]:=SatMel;
        edSatM3.Text:=SatMel.satname;
        cbSatM3.Checked:=True;
        cbSatM3.Caption:='';
      end;
end;

procedure TfmSatMap.edSatM4Click(Sender: TObject);
begin
  if  BooChangeSatl
    then
      begin
        SatElemMap[4]:=SatMel;
        edSatM4.Text:=SatMel.satname;
        cbSatM4.Checked:=True;
        cbSatM4.Caption:='';
      end;
end;

procedure TfmSatMap.edSatM5Click(Sender: TObject);
begin
  if  BooChangeSatl
    then
      begin
        SatElemMap[5]:=SatMel;
        edSatM5.Text:=SatMel.satname;
        cbSatM5.Checked:=True;
        cbSatM5.Caption:='';
      end;
end;

procedure TfmSatMap.edSatM6Click(Sender: TObject);
begin
  if  BooChangeSatl
    then
      begin
        SatElemMap[6]:=SatMel;
        edSatM6.Text:=SatMel.satname;
        cbSatM6.Checked:=True;
        cbSatM6.Caption:='';
      end;
end;

procedure TfmSatMap.edSatM7Click(Sender: TObject);
begin
  if  BooChangeSatl
    then
      begin
        SatElemMap[7]:=SatMel;
        edSatM7.Text:=SatMel.satname;
        cbSatM7.Checked:=True;
        cbSatM7.Caption:='';
      end;
end;

procedure TfmSatMap.edSatM8Click(Sender: TObject);
begin
  if  BooChangeSatl
    then
      begin
        SatElemMap[8]:=SatMel;
        edSatM8.Text:=SatMel.satname;
        cbSatM8.Checked:=True;
        cbSatM8.Caption:='';
      end;
end;

procedure TfmSatMap.GroupBoxClick(Sender: TObject);
begin
  with  fmSatMap  do  // procedure from UnGraBmp
    PuzSaveBmp(ClientWidth,ClientHeight,
               Width,Height,3,3,Canvas);
end;

end.
