unit UnSatMel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfmSatMel = class(TForm)
    ListSat: TListBox;
    ButEsc: TButton;
    ButSel: TButton;
    ButFol: TButton;
    MemoElm: TMemo;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButEscClick(Sender: TObject);
    procedure ButSelClick(Sender: TObject);
    procedure ListSatKeyPress(Sender: TObject; var Key: Char);
    procedure ListSatClick(Sender: TObject);
    procedure ListSatDblClick(Sender: TObject);
    procedure ButFolClick(Sender: TObject);
    procedure ListSatKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MemoElmKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    NumSat  : LongInt ;
    NumAll  : LongInt ;
    StrSat  : ShortString ;
    procedure PutMemoInform ;
    procedure ToFillListSat ;
  public
    { Public declarations }
    BooSat  : Boolean ; // to choose satellite
    BooFol  : Boolean ; // to another folder if true
    NumElm  : LongInt ;
  end;

var
  fmSatMel: TfmSatMel;

implementation

{$R *.DFM}

uses
  UnCoTVar , // for types
  UnGloVar , // for variables
  UnGraBmp , // for PuzSaveBmp
  UnitSort ; // for proc ToGet ToFree MemForOrder

procedure TfmSatMel.ToFillListSat ;
var
  i  : LongInt ;
  s  : ShortString ;
begin
  NumAll:=NumSatElemInHeap; // var UnCoTVar
  ListSat.Clear;
  for i:=1 To NumAll do
    begin
      s:='   '+SatElemHeap^[i].satname;
      ListSat.Items.Add(s);
      ObjectSort^[i]:=i; // heap ObjectSort^[..] from UnCoTVar
    end;
end;

procedure TfmSatMel.PutMemoInform ;
var
  s  : ShortString ;
begin
  MemoElm.Clear;
  s:=' '+IntToStr(NumSat)
              +'  '+IntToStr(NumAll)+' ';
  MemoElm.Lines.Add(s);
  MemoElm.Lines.Add('  '+StrSat);
  Str(SatElemHeap^[NumSat].an:10:6,s);
  MemoElm.Lines.Add('   n ='+s);
  Str(SatElemHeap^[NumSat].ae:10:6,s);
  MemoElm.Lines.Add('    e ='+s);
  Str(SatElemHeap^[NumSat].ai:10:4,s);
  MemoElm.Lines.Add('    i ='+s);
  MemoElm.Lines.Insert(0,'    ');
end;

procedure TfmSatMel.FormActivate(Sender: TObject);
begin
  BooSat:=False; // no satellite that choosed
  BooFol:=False; // no another folder
  ListSat.Visible:=False;
  ToGetMemForOrder ; // UnitSort for ObjectSort^[..]
  ToFillListSat ;
  ShellMethodSatName ; // UnitSort to order with alphabet by using SatlemHeap
  ToFillListSat ;
  NumSat:=ListSat.ItemIndex+1;
  if  NumSat < 1  then  NumSat:=1;
  ListSat.ItemIndex:=NumSat-1;
  StrSat:=ListSat.Items[NumSat-1];
  PutMemoInform ;
  ListSat.Visible:=True;
  ListSat.SetFocus ;
end;

procedure TfmSatMel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ToFreeMemForOrder ; // UnitSort
end;

procedure TfmSatMel.ButEscClick(Sender: TObject);
begin
  BooSat:=False;
  NumElm:=-1;
  Close;
end;

procedure TfmSatMel.ButSelClick(Sender: TObject);
begin
  BooSat:=True;
  NumElm:=NumSat;
  Close;
end;

procedure TfmSatMel.ListSatKeyPress(Sender: TObject; var Key: Char);
begin
  if  Key = #27  then  ButEscClick(Sender); // quit
  if  Key = #13  then  ButSelClick(Sender); // enter
end;

procedure TfmSatMel.ListSatClick(Sender: TObject);
begin
  NumSat:=ListSat.ItemIndex+1;
  StrSat:=ListSat.Items[NumSat-1];
  PutMemoInform;
end;

procedure TfmSatMel.ListSatDblClick(Sender: TObject);
begin
  NumSat:=ListSat.ItemIndex+1;
  ButSelClick(Sender);
end;

procedure TfmSatMel.ButFolClick(Sender: TObject);
begin
  BooFol:=True; //  a try to find new folder with th elements
  ButEscClick(Sender);
end;

procedure TfmSatMel.ListSatKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  ( Key = Ord('S') ) and ( Shift = [ ssCtrl ] )
    then // to save
      with  fmSatMel  do
        PuzSaveBmp(ClientWidth,ClientHeight,
                   Width,Height,3,3,Canvas);
end;

procedure TfmSatMel.MemoElmKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  ( Key = Ord('S') ) and ( Shift = [ ssCtrl ] )
    then // to save
      with  fmSatMel  do
        PuzSaveBmp(ClientWidth,ClientHeight,
                   Width,Height,3,3,Canvas);
end;

end.
