unit UnSatVaz ; // information 'L' look option to fmSatEph.MemoEph
interface
uses
  UnCoTVar ; // for type TElemRec
procedure MoreAboutSat ( te  : Extended ;  el  : TElemRec ) ;
implementation
uses
  UnSatEph , // fmSatEph.MemoEph
  UnConTyp , // type TVect3 const VelOfRot for Earth rotation
  UnGloVar , // global variable RosMatr RotMatr matrix array
  UnButIni , // for string HintButt[21] about shadow for satellite
  UnForDat , // function ToGetStrForDate
  UnForCoo , // for ClcTrueRotMatr procedure
  UnitEilP , // for EilXV procedure
  PUnDE200 , // for the const NSun
  UnForZem , // procedure NulloLimbPoint
  UnParamO , // procedure AboutPointP
  UnForStr , // function FloatToFixStr
  UnForFun ; // proc MatrMultVector
{ to put some information to MemoEph }
procedure AboutSatMom ( t  : Extended ) ; // moment julian date
begin
  fmSatEph.MemoEph.Lines.Add('  ');       // UnEphSat
  fmSatEph.MemoEph.Lines.Add('    ');
  fmSatEph.MemoEph.Lines.Add('  '+HintButt[21]);  // UnButIni
  fmSatEph.MemoEph.Lines.Add(ToGetStrForDate(t)); // UnForDat
end;
{ to put some information to MemoEph }
procedure AboutSatPos ( s  : ShortString ;  x ,v  : TVect3 ) ;
begin
  with  fmSatEph.MemoEph.Lines  do  // MemoEph for UnSatEph
    begin    // function FloatToFixStr from UnForStr
      Add(s);
      Add('  '+FloatToFixStr(x[1],11,3)+
          '  '+FloatToFixStr(x[2],11,3)+
          '  '+FloatToFixStr(x[3],11,3)+'  ');
      Add('    '+FloatToFixStr(v[1],9,6)+
          '    '+FloatToFixStr(v[2],9,6)+
          '    '+FloatToFixStr(v[3],9,6)+'  /');
    end;
end;
{ to put some information to MemoEph }
procedure AboutSatGes ( a , b , r  : Extended ) ;
begin
  with  fmSatEph.MemoEph.Lines  do
    begin
      Add('    ');
      Add('  '+FloatToFixStr(a,10,6)+'   ');
      Add('  '+FloatToFixStr(b,10,6)+'    ');
      Add('  '+FloatToFixStr(r,10,3)+'   ');
    end;
end;
{ in ObjectTopRec^ there is information about the Sun and planets }
procedure AboutPlaOrb ( nump  : Byte ) ;
var
  n  : LongInt ;       { simple count of the object }
  b  : Boolean ;       { to find the planet in array }
begin
  OurPlaFromHea(nump,b,n); // UnParamO to find planet in list
  if  b      // for the planet information
    then
      with  ObjectTopHeap^[n]  do
        begin
          fmSatEph.MemoEph.Lines.Add('  ');
          fmSatEph.MemoEph.Lines.Add('    , '+name);
          fmSatEph.MemoEph.Lines.Add
            ('  '+FloatToFixStr(azt,7,3)+'  ');
          fmSatEph.MemoEph.Lines.Add
            ('  '+FloatToFixStr((90.0-alt),7,3)+'   ');
        end;
end;
{ geographical position
  of the point from the Earth's centre
  that perpendicular to line from satellite to the planet
  angle of dissipation is angle between two direction
    linked with special point P on the Earth's surface
    line from P to the Sun and line from P to the satellite }
procedure AboutPointP ( np  : Byte ) ; // to UnParamO
var
  b  : Boolean ;
  am,ap,ar,ud  : Extended ; // geo longitude latitude range angle d
begin // in PointP... longitude latitude range angle of dissipation
  PointParametr(np,b,am,ap,ar,ud); // UnParamO for planet
  if  not b  then  Exit ;
  fmSatEph.MemoEph.Lines.Add('  ');
  fmSatEph.MemoEph.Lines.Add
  ('      '+PlanetNameR[np]);
  fmSatEph.MemoEph.Lines.Add
  ('   ()  ');
  fmSatEph.MemoEph.Lines.Add
  ('     '+FloatToFixStr(am,7,3)+'    ');
  fmSatEph.MemoEph.Lines.Add
  ('     '+FloatToFixStr(ap,7,3)+'     ');
  fmSatEph.MemoEph.Lines.Add
  ('  '+FloatToFixStr(ar,10,3)
       +'      ');
  if  ( np = NSun ) and ( ud > -90.0 ) // for this condition
    then                          // angle of dissipation exists
      fmSatEph.MemoEph.Lines.Add
      ('     '+FloatToFixStr(ud,7,3)+'     ');
end;
{ fmSatEph from UnSatEph
  position of the limb point only for shadow case }
procedure AboutLimbPoint ;   // position of the limb point
var // orbital and geospheric coordinates of the surface point
  az,al,am,ap  : Extended ;
begin
  fmSatEph.MemoEph.Lines.Add('  ');
  fmSatEph.MemoEph.Lines.Add
  ('    ,    ');
  NulloLimbPoint(az,al,am,ap); // UnForZem
  fmSatEph.MemoEph.Lines.Add
  ('  '+FloatToFixStr(az,7,3)+'   ');
  fmSatEph.MemoEph.Lines.Add
  ('  '+FloatToFixStr((90.0-al),7,3)
       +'    ');
  fmSatEph.MemoEph.Lines.Add('  ');
  fmSatEph.MemoEph.Lines.Add
  ('    ,    ');
  fmSatEph.MemoEph.Lines.Add
  ('  '+FloatToFixStr(am,7,3)+'    ');
  fmSatEph.MemoEph.Lines.Add
  ('  '+FloatToFixStr(ap,7,3)+'    ');
end;
{ called from fmSatEph
  te current date  el current record elements
  matrix to change between coordinates system
  RotMatr[..][..] RosMatr[..][..] TopMatr[..][..]
  are declared in UnGloVar as global variable arrays
  are assigned by procedure ClcThreeRotMatr FiguViewPlac UnPlaceA }
procedure MoreAboutSat ( te  : Extended ;  el  : TElemRec ) ;
var
  qx,qv  : TVect3 ;   // type UnConTyp  true eqiunox
  rx,rv  : TVect3 ;   // type UnConTyp  greenwich meridian
  a,b,r  : Extended ; // geographic position of the satellite
begin
  AboutSatMom(te);
  { position velosity of the satellite
   refer to the centre of the Earth in true equator system }
  EilXV(te,el,qx,qv); // UnitEilP
  AboutSatPos('    ,   ',qx,qv);
  { position to Earth's rotating system
    RosMatr UnGloVar to change
    from true equinox to greenwich meridian rotating system }
  MatrMultVector(RosMatr,qx,rx); // UnForFun
  { part of velosity in Earth's rotating system
    without velosity of the rotation of the Earth }
  MatrMultVector(RosMatr,qv,rv); // UnForFun only part for velosity
  { the next part for velosity in rotating system only for x y }
  rv[1]:=rv[1]+VelOfRot*rx[2]; // to take rotation into account
  rv[2]:=rv[2]-VelOfRot*rx[1]; // to take rotation into account
  AboutSatPos('    ,   ',rx,rv);
  ClcSpherCoorInDegree(rx,a,b,r); // UnForCoo geographic spheric
  AboutSatGes(a,b,r); // satellite geographic coordinates
  { in ObjectTopRec^ there is information about th Sun  PUnDE200 }
  AboutPlaOrb(NSun); // position of the Sun in orbital system
  AboutPointP(NSun); // to UnParamO
  AboutLimbPoint ;   // position of the limb point
end;
end.