unit UnSelDat;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask;

type
  TfmSelDat = class(TForm)
    ButSel: TButton;
    ButEsc: TButton;
    GroupDate: TGroupBox;
    rbOne: TRadioButton;
    rbTwo: TRadioButton;
    rbTre: TRadioButton;
    meOne: TMaskEdit;
    meTwo: TMaskEdit;
    meTre: TMaskEdit;
    procedure FormActivate(Sender: TObject);
    procedure AfterGroupClick ;
    procedure rbOneClick(Sender: TObject);
    procedure rbTwoClick(Sender: TObject);
    procedure rbTreClick(Sender: TObject);
    procedure meOneClick(Sender: TObject);
    procedure meTwoClick(Sender: TObject);
    procedure meTreClick(Sender: TObject);
    procedure ButEscClick(Sender: TObject);
    procedure ButSelClick(Sender: TObject);
    procedure GroupDateClick(Sender: TObject);
  private
    { Private declarations }
    BooSelBut  : Boolean ;
    procedure ToFillStrings ; // for value JulianDate
    procedure ToFindStrings ;
    procedure ToCheckNewDate ( dt  : Extended ) ;
    procedure OneSelDate ;
    procedure TwoSelDate ;
    procedure TreSelDate ;
  public
    { Public declarations }
    BooSelDat  : Boolean ;
    JulSelDat  : Extended ;
  end;

var
  fmSelDat: TfmSelDat;

implementation

uses
  UnGloVar , // global var JulianDate
  PUnDE200 , // for global var TinitEph TlastEph
  UnForDat , // for proc TransJDtoDate FromSecPartToHourMinSec
  UnForStr , // for proc IntegerToFixStr
  UnGraBmp ; // for proc PuzSaveBmp

{$R *.DFM}

procedure TfmSelDat.ToFillStrings ; // for value JulianDate
var
  nd,nm,ny,kh,km  : Integer ;
  da,db,dc,dd  : Extended ;
  st  : ShortString ;
begin
  da:=fmSelDat.JulSelDat;
  TransJDtoDate(da,nd,nm,ny,db); // UnForDat day month year part of day
  FromSecPartToHourMinSec(db,kh,km,dc);  // UnForDat part of day hour min sec
  dd:=1.0*nd+db/86400.0; // day with part of day
  st:=IntegerToFixStr(ny,4)+IntegerToFixStr(nm,2)+IntegerToFixStr(nd,2);
  st:=st+IntegerToFixStr(kh,2)+IntegerToFixStr(km,2)+FloatToFixStr(dc,6,3);
  fmSelDat.meOne.Text:=WithOutDecimalPoint(st); // UnForStr
  st:=IntegerToFixStr(ny,4)+IntegerToFixStr(nm,2)+FloatToFixStr(dd,11,8);
  fmSelDat.meTwo.Text:=WithOutDecimalPoint(st); // UnForStr
  st:=FloatToFixStr(da,16,8); // UnForStr with special mask
  fmSelDat.meTre.Text:=WithOutDecimalPoint(st); // UnForStr
end;

procedure TfmSelDat.ToFindStrings ;
begin
  fmSelDat.ToFillStrings ;
  if  fmSelDat.rbOne.Checked
    then
      fmSelDat.meOne.SetFocus;
  if  fmSelDat.rbTwo.Checked
    then
      fmSelDat.meTwo.SetFocus;
  if  fmSelDat.rbTre.Checked
    then
      fmSelDat.meTre.SetFocus;
end;

procedure TfmSelDat.ToCheckNewDate ( dt  : Extended ) ;
begin
  if  ( ( TinitEph+1.0 ) < dt ) and ( dt < ( TlastEph-1.0 ) )
    then  // global limit for time from PUnDE200
      begin
        fmSelDat.BooSelDat:=True;
        fmSelDat.JulSelDat:=dt;
        fmSelDat.BooSelBut:=True;
        fmSelDat.ToFindStrings ;
      end;
end;

procedure TfmSelDat.OneSelDate ;
var
  st,sa  : ShortString ;
  nd,nm,ny  : Integer ;
  kh,km  : Integer ;
  dt,sc  : Extended ;
  er  : Integer ;
begin
  st:=fmSelDat.meOne.Text;
  sa:=Copy(st,1,4); // year
  Val(sa,ny,er);
  sa:=Copy(st,5,2); // month
  Val(sa,nm,er);
  sa:=Copy(st,7,2); // day
  Val(sa,nd,er);
  sa:=Copy(st,9,2); // hour
  Val(sa,kh,er);
  sa:=Copy(st,11,2);  // minute
  Val(sa,km,er);
  sa:=Copy(st,13,6);  // second
  Insert('.',sa,3);
  Val(sa,sc,er);
  TransDateToJD(nd,nm,ny,dt); // julian date
  dt:=dt+(kh+(km+sc/60.0)/60.0)/24.0; // with the part of day
  fmSelDat.ToCheckNewDate(dt);
end;

procedure TfmSelDat.TwoSelDate ;
var
  st,sa  : ShortString ;
  nm,ny  : Integer ;
  dt,dd  : Extended ;
  er  : Integer ;
begin
  st:=fmSelDat.meTwo.Text;
  sa:=Copy(st,1,4); // year
  Val(sa,ny,er);
  sa:=Copy(st,5,2); // month
  Val(sa,nm,er);
  sa:=Copy(st,7,10); // day with the part of day
  Insert('.',sa,3);
  Val(sa,dd,er);
  TransDateToJD(0,nm,ny,dt); // julian date
  dt:=dt+dd; // with the part of day
  fmSelDat.ToCheckNewDate(dt);
end;

procedure TfmSelDat.TreSelDate ;
var
  st  : ShortString ;
  dt  : Extended ;
  er  : Integer ;
begin
  st:=fmSelDat.meTre.Text;
  Insert('.',st,8);
  Val(st,dt,er);
  fmSelDat.ToCheckNewDate(dt);
end;

procedure TfmSelDat.FormActivate(Sender: TObject);
begin
  fmSelDat.BooSelBut:=False;
  fmSelDat.BooSelDat:=False;
  fmSelDat.JulSelDat:=JulianDate;
  fmSelDat.rbOne.Checked:=True;
  fmSelDat.rbTwo.Checked:=False;
  fmSelDat.rbTre.Checked:=False;
  fmSelDat.meOne.Color:=clYellow;
  fmSelDat.meTwo.Color:=clYellow;
  fmSelDat.meTre.Color:=clYellow;
  fmSelDat.ToFindStrings ;
end;

procedure TfmSelDat.AfterGroupClick ;
begin
  fmSelDat.meOne.Color:=clYellow;
  fmSelDat.meTwo.Color:=clYellow;
  fmSelDat.meTre.Color:=clYellow;
  fmSelDat.BooSelBut:=False;
  fmSelDat.ToFindStrings ;
end;

procedure TfmSelDat.rbOneClick(Sender: TObject);
begin
  AfterGroupClick ;
end;

procedure TfmSelDat.rbTwoClick(Sender: TObject);
begin
  AfterGroupClick ;
end;

procedure TfmSelDat.rbTreClick(Sender: TObject);
begin
  AfterGroupClick ;
end;

procedure TfmSelDat.meOneClick(Sender: TObject);
begin
  fmSelDat.rbOne.Checked:=True;
  AfterGroupClick ;
end;

procedure TfmSelDat.meTwoClick(Sender: TObject);
begin
  fmSelDat.rbTwo.Checked:=True;
  AfterGroupClick ;
end;

procedure TfmSelDat.meTreClick(Sender: TObject);
begin
  fmSelDat.rbTre.Checked:=True;
  AfterGroupClick ;
end;

procedure TfmSelDat.ButEscClick(Sender: TObject);
begin
  fmSelDat.BooSelBut:=False;
  if  fmSelDat.BooSelDat
    then
      fmSelDat.FormActivate(Sender)
    else
      begin
        fmSelDat.BooSelDat:=False;
        Close;
      end;
end;

procedure TfmSelDat.ButSelClick(Sender: TObject);
begin
  if  not BooSelBut
    then
      begin
        if  fmSelDat.rbOne.Checked  then  fmSelDat.OneSelDate;
        if  fmSelDat.rbTwo.Checked  then  fmSelDat.TwoSelDate;
        if  fmSelDat.rbTre.Checked  then  fmSelDat.TreSelDate;
        if  not fmSelDat.BooSelDat
          then  fmSelDat.FormActivate(Sender)
          else
            begin
              fmSelDat.meOne.Color:=clLime;
              fmSelDat.meTwo.Color:=clLime;
              fmSelDat.meTre.Color:=clLime;
              fmSelDat.ButSel.SetFocus;
            end
      end
    else
      if  fmSelDat.BooSelDat
        then
          Close // date is selected
        else
          fmSelDat.FormActivate(Sender); // again to select date
end;

procedure TfmSelDat.GroupDateClick(Sender: TObject);
begin
  with  fmSelDat  do  // procedure from UnGraBmp
    PuzSaveBmp(ClientWidth,ClientHeight,
               Width,Height,3,3,Canvas);
end;

end.
