unit UnSelEph;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask,  ComCtrls ,
  UnCoTVar , // for type TElemRec var record SatElemFix ObjectTopHeap^[]
  UnGloVar ; // for type TPlaceCooRec JulianDate

type
  TfmSelEph = class(TForm)
    GroupBox: TGroupBox;
    edSite: TEdit;
    lbSite: TLabel;
    ButSite: TButton;
    ButSatl: TButton;
    edSatl: TEdit;
    lbSatl: TLabel;
    rbDetail: TRadioButton;
    rbVisibl: TRadioButton;
    meStart: TMaskEdit;
    meFinish: TMaskEdit;
    lbStart: TLabel;
    lbFinish: TLabel;
    ButSel: TButton;
    ButEsc: TButton;
    GroupAdd: TGroupBox;
    lbStep: TLabel;
    edStep: TEdit;
    udStep: TUpDown;
    lbSec: TLabel;
    lbLatm: TLabel;
    udLatm: TUpDown;
    lbDegr: TLabel;
    edLatm: TEdit;
    rbNight: TRadioButton;
    rbDayn: TRadioButton;
    procedure FormActivate(Sender: TObject);
    procedure rbDetailClick(Sender: TObject);
    procedure rbVisiblClick(Sender: TObject);
    procedure ButSelClick(Sender: TObject);
    procedure ButEscClick(Sender: TObject);
    procedure ButSiteClick(Sender: TObject);
    procedure ButSatlClick(Sender: TObject);
    procedure udStepClick(Sender: TObject; Button: TUDBtnType);
    procedure udLatmClick(Sender: TObject; Button: TUDBtnType);
    procedure GroupBoxClick(Sender: TObject);
  private
    { Private declarations }
    procedure StartFinishDate ;
    function TextForDate ( tt  : Extended ) : ShortString ;
    function ForDifDay : Extended ;
    function ToGetDate ( st  : ShortString ) : Extended ;
    function ToGetStepPosition : SmallInt ; // to find step with mean motion
    function ToGetStepPrint ( n  : SmallInt ) : SmallInt ;
    function ToGetLatmVal ( n  : SmallInt ) : SmallInt ;
  public
    { Public declarations }
    BooSelEph   : Boolean ;  // boolean true if ephemeris is selected
    SatPeriod   : Extended ; // period of satellite revolution in day
    StartDate   : Extended ; // julian date to start
    FinishDate  : Extended ; // julian date to finish
    StepPrint   : Extended ; // step to output information
    LatMinVal   : Extended ; // minimum value for latitude in degree
    BooDayEph   : Boolean ;  // true if day and night
    BooVisEph   : Boolean ;  // true if visibility false if detail
    SatElemEph  : TElemRec ;   // type from UnCoTVar satellite elements
    SaoElemEph  : TElemRec ;   // type from UnCoTVar satellite elements
    SiteCooEph  : TPlaceCooRec ; // type from UnGloVar station position
    procedure BeforeShow ; // CharForEphem 'P' and 'O' char
  end;

var
  fmSelEph: TfmSelEph;

implementation

uses
  UnSelHol , // fmSelHol to select station
  UnSelSat , // fmSelSat to select object
  UnitFixO , // for chFixObject proc ToGetRandomSat
  UnitStat , // for proc ToSelectOneStation StationList
  PUnDE200 , // for NSun PlanetNameR[..]
  UnGraBmp , // for PuzSaveBmp procedure
  UnForDat , // for proc TransJDtoDate FromSecPartToHourMinSec
  UnForStr ; // for proc IntegerToFixStr

{$R *.DFM}

procedure TfmSelEph.BeforeShow ; // 'P' or 'E'
begin                            // CharForEphem from UnGloVar
  fmSelEph.BooSelEph:=False; // boolean to select initial condition
  fmSelEph.BooVisEph:=False; // boolean false for visibility
case  CharForEphem  of
  'P' : begin
          fmSelEph.Caption:=':  ';
          fmSelEph.lbSite.Caption:=' ';
          fmSelEph.lbSatl.Caption:='';
          fmSelEph.ButSite.Enabled:=True;
          fmSelEph.ButSatl.Enabled:=True;
          fmSelEph.ButSite.Hint:='   ';
          fmSelEph.SiteCooEph:=PlaceCoor; // station UnGloVar
          fmSelEph.edSite.Text:=fmSelEph.SiteCooEph.name; // station indentification
          fmSelEph.lbLatm.Caption:='';
          fmSelEph.rbDetail.Enabled:=True;
          fmSelEph.rbDetail.Visible:=True;
          fmSelEph.rbVisibl.Enabled:=True;
          fmSelEph.rbVisibl.Visible:=True;
          fmSelEph.lbStart.Enabled:=True;
          fmSelEph.lbStart.Visible:=True;
          fmSelEph.lbFinish.Enabled:=True;
          fmSelEph.lbFinish.Visible:=True;
          fmSelEph.meStart.Enabled:=True;
          fmSelEph.meStart.Visible:=True;
          fmSelEph.meFinish.Enabled:=True;
          fmSelEph.meFinish.Visible:=True;
          fmSelEph.rbNight.Enabled:=True;
          fmSelEph.rbDayn.Enabled:=True;
          fmSelEph.rbNight.Visible:=True;
          fmSelEph.rbDayn.Visible:=True;
        end;
  'O' : begin
          fmSelEph.Caption:=':   ';
          fmSelEph.lbSite.Caption:=' ';
          fmSelEph.lbSatl.Caption:='';
          fmSelEph.ButSite.Enabled:=True;
          fmSelEph.ButSatl.Enabled:=True;
          fmSelEph.ButSite.Hint:='   ';
          CharBodEph:='P';  // a view to the Sun UnGloVar
          NumberBody:=NSun; // the Sun default   UnGloVar
          fmSelEph.edSite.Text:=PlanetNameR[NumberBody];
          fmSelEph.SiteCooEph.name:=PlanetNameR[NumberBody];
          fmSelEph.lbLatm.Caption:='';
          fmSelEph.rbDetail.Enabled:=True;
          fmSelEph.rbDetail.Visible:=True;
          fmSelEph.rbVisibl.Enabled:=True;
          fmSelEph.rbVisibl.Visible:=True;
          fmSelEph.lbStart.Enabled:=True;
          fmSelEph.lbStart.Visible:=True;
          fmSelEph.lbFinish.Enabled:=True;
          fmSelEph.lbFinish.Visible:=True;
          fmSelEph.meStart.Enabled:=True;
          fmSelEph.meStart.Visible:=True;
          fmSelEph.meFinish.Enabled:=True;
          fmSelEph.meFinish.Visible:=True;
          fmSelEph.rbNight.Enabled:=False;
          fmSelEph.rbDayn.Enabled:=False;
          fmSelEph.rbNight.Visible:=False;
          fmSelEph.rbDayn.Visible:=False;
        end;
  'L' : begin
          fmSelEph.Caption:=':   ';
          fmSelEph.lbSite.Caption:=' ';
          fmSelEph.lbSatl.Caption:='';
          fmSelEph.ButSite.Enabled:=False;
          fmSelEph.ButSatl.Enabled:=False;
          CharBodEph:='L';  // a view to the limb UnGloVar
          NumberBody:=0;    // a limb default   UnGloVar
          fmSelEph.edSite.Text:='';
          fmSelEph.SiteCooEph.name:='';
          fmSelEph.lbLatm.Caption:=' ';
          fmSelEph.rbDetail.Enabled:=False;
          fmSelEph.rbDetail.Visible:=False;
          fmSelEph.rbVisibl.Enabled:=False;
          fmSelEph.rbVisibl.Visible:=False;
          fmSelEph.lbStart.Enabled:=False;
          fmSelEph.lbStart.Visible:=False;
          fmSelEph.lbFinish.Enabled:=False;
          fmSelEph.lbFinish.Visible:=False;
          fmSelEph.meStart.Enabled:=False;
          fmSelEph.meStart.Visible:=False;
          fmSelEph.meFinish.Enabled:=False;
          fmSelEph.meFinish.Visible:=False;
          fmSelEph.rbNight.Enabled:=False;
          fmSelEph.rbDayn.Enabled:=False;
          fmSelEph.rbNight.Visible:=False;
          fmSelEph.rbDayn.Visible:=False;
        end;
end; // case ch character 'P' or 'O' or 'L'
end;

function TfmSelEph.TextForDate ( tt  : Extended ) : ShortString ;
var
  nd  : Integer ;
  nm  : Integer ;
  ny  : Integer ;
  dt  : Extended ;
  st  : ShortString ;
begin
  TransJDtoDate(tt,nd,nm,ny,dt); // UnForDat day month year part of day
  st:=IntegerToFixStr(nd,2)+IntegerToFixStr(nm,2)+IntegerToFixStr(ny,4);
  TextForDate:=st;
end;

function TfmSelEph.ForDifDay : Extended ;
var
  dt  : Extended ;
begin
  if  CharForEphem = 'L'  // only for limb
    then  dt:=1.0         // only for limb one day
    else  dt:=5.0;        // other case five days
  if  fmSelEph.rbVisibl.Checked  then  dt:=35.0;
  ForDifDay:=dt;
end;

procedure TfmSelEph.StartFinishDate ;
begin // StartDate must be known
  fmSelEph.meStart.Text:=TextForDate(fmSelEph.StartDate);
  fmSelEph.FinishDate:=fmSelEph.StartDate+ForDifDay;
  fmSelEph.meFinish.Text:=TextForDate(fmSelEph.FinishDate);
end;

function TfmSelEph.ToGetDate ( st  : ShortString ) : Extended ;
var
  nd,nm,ny,er  : Integer ;
  da  : Extended ;
  sa  : ShortString ;
begin
  sa:=Copy(st,1,2); // day
  Val(sa,nd,er);    // day
  sa:=Copy(st,3,2); // month
  Val(sa,nm,er);    // month
  sa:=Copy(st,5,4); // year
  Val(sa,ny,er);    // year
  TransDateToJD(nd,nm,ny,da); // UnForDat
  ToGetDate:=da;
end;

function TfmSelEph.ToGetStepPrint ( n  : SmallInt ) : SmallInt ;
const
  p  : array [1..16] of SmallInt =
     (   1 ,   2 ,   5 ,   10 ,   15 ,   30 ,   60 , 120 ,
       180 , 300 , 600 , 900 , 1200 , 1800 , 2400 , 3600 ) ;
begin
  ToGetStepPrint:=p[n];
end;

function TfmSelEph.ToGetStepPosition : SmallInt ;
var // with the use mean motion
  i  : SmallInt ;
  b  : Extended ;
  s  : LongInt ;
  n  : SmallInt ;                  // SatElemEph.an mean motion
begin                               // SatElemEph.an in revolution per day
  b:=1440.0/fmSelEph.SatElemEph.an; // period of revolution in minute
  b:=0.01*b;                        // 0.01 part of period in minute
  s:=Round(60*b); // integer value for step to print in second
  n:=6; // 30 second default
  for i:=1 to 16 do
    if  s > fmSelEph.ToGetStepPrint(i)  then  n:=i;
  case  CharForEphem  of
    'P' : if ( fmSelEph.SatElemEph.an > 14.1 )
            then  n:=5; // 15 second small step for printing
    'O' : n:=1;         // only one second step for printing
    'L' : n:=6;         // 30 seconds step for printing
  end; // CharForEphem 'P' or 'O'
  ToGetStepPosition:=n;
end;

function TfmSelEph.ToGetLatmVal ( n  : SmallInt ) : SmallInt ;
const
  p  : array [1..7] of SmallInt =
     (  0 , 5 , 10 , 15 , 20 , 25 , 30 ) ;
  o  : array [1..7] of SmallInt =
     (  2 , 5 , 10 , 20 , 50 , 100 , 200 ) ;
begin
  ToGetLatmVal:=10;
  if  ( n < 1 ) or ( n > 7 )  then  Exit ; // no action
case  CharForEphem  of
  'P' : ToGetLatmVal:=p[n];  // to view satellite from point
  'O' : ToGetLatmVal:=o[n];  // to look object from satellite
  'L' : ToGetLatmVal:=Round(RinDegC/3.0)+1; // to look limb sat
end; // CharForEphem 'P' or 'O'
end;

procedure TfmSelEph.FormActivate(Sender: TObject);
begin
  fmSelEph.rbDetail.Checked:=True; // default for detail ephemeris
  if  CharForView = 'L'  // for look form the satellite option
    then
      fmSelEph.SatElemEph:=SatElemLook
    else
      if  BooFixObject and ( chFixObject = 'S' )
        then // satellite is selected on the screen
          fmSelEph.SatElemEph:=SatElemFix
        else
          ToGetRandomSat(fmSelEph.SatElemEph); // proc from UnitFixO
  fmSelEph.edSatl.Text:=fmSelEph.SatElemEph.satname; // satl. identification
  fmSelEph.SatPeriod:=1.0/fmSelEph.SatElemEph.an; // satellite period in day
  fmSelEph.StartDate:=JulianDate;
  fmSelEph.StartFinishDate; // JulianDate from UnGloVar
  fmSelEph.udStep.Position:=fmSelEph.ToGetStepPosition; // to find step
  fmSelEph.edStep.Text:=IntToStr(ToGetStepPrint(fmSelEph.udStep.Position));
  case  CharForEphem  of
    'P' :  // satellite from the station 'S' option
    begin
      fmSelEph.lbLatm.Hint:='   ';
      fmSelEph.lbDegr.Caption:='';
      fmSelEph.udLatm.Enabled:=True;
      fmSelEph.udLatm.Visible:=True;
      fmSelEph.udLatm.Position:=3; // minimum altitude 10 degree
    end;
    'O' :  // object from the satellite  'S' 'L' options
    begin
      fmSelEph.lbLatm.Hint:='   ';
      fmSelEph.lbDegr.Caption:='';
      fmSelEph.udLatm.Enabled:=True; // for the altitide
      fmSelEph.udLatm.Visible:=True;
      fmSelEph.udLatm.Position:=7; // minimum height 200 km
    end;
    'L' :  // limb from the satellite  CharForView = 'L' option
    begin
      fmSelEph.lbLatm.Hint:='   ';
      fmSelEph.lbDegr.Caption:='';
      fmSelEph.udLatm.Enabled:=False;  // only one value
      fmSelEph.udLatm.Visible:=False;  // only one value
      fmSelEph.udLatm.Position:=1; //
    end;
  end; // CharForEphem 'P' 'O' 'L'
  fmSelEph.edLatm.Text:=IntToStr(ToGetLatmVal(fmSelEph.udLatm.Position));
  fmSelEph.rbNight.Checked:=True;
  fmSelEph.BooDayEph:=not fmSelEph.rbNight.Checked; // the night only
end;

procedure TfmSelEph.rbDetailClick(Sender: TObject);
begin
  fmSelEph.BooVisEph:=False; // boolean false for visibility true for detail
  fmSelEph.StartFinishDate; // here above
end;

procedure TfmSelEph.rbVisiblClick(Sender: TObject);
begin
  fmSelEph.BooVisEph:=True; // boolean true for visibility false for detail
  fmSelEph.StartFinishDate; // here above
end;

procedure TfmSelEph.ButSelClick(Sender: TObject); // to select ephemeris
var
  tk,tn  : Extended ;
begin
  tn:=fmSelEph.ToGetDate(fmSelEph.meStart.Text);
  tk:=fmSelEph.ToGetDate(fmSelEph.meFinish.Text);
  if  tk < tn
    then  // strange interval
      begin
        ShowMessage(' ');
        fmSelEph.meStart.Text:=TextForDate(fmSelEph.StartDate);
        fmSelEph.meFinish.Text:=TextForDate(fmSelEph.FinishDate);
        Exit ;
      end
    else
      begin
        fmSelEph.StartDate:=tn;
        fmSelEph.FinishDate:=tk;
        fmSelEph.BooSelEph:=True; // ephemeris StepPrint from second to day
        fmSelEph.StepPrint:=StrToInt(fmSelEph.edStep.Text)/86400.0;
        fmSelEph.LatMinVal:=StrToInt(fmSelEph.edLatm.Text);
        fmSelEph.BooDayEph:=not fmSelEph.rbNight.Checked;
        Close;
      end;
end;

procedure TfmSelEph.ButEscClick(Sender: TObject); // to quit without ephem.
begin
  BooSelEph:=False;
  Close;
end;

procedure TfmSelEph.ButSiteClick(Sender: TObject); // to new station
var
  nt,ns  : LongInt ; // numbers in ObjectTopHeap^[] SatElemHeap^[] UnCoTVar
begin
  case  CharForEphem  of         // UnGloVar
    'P' :
     begin                  // satellite from station
       ToSelectOneStation ; // proc from UnitStat
       if  fmSelHol.BooSelHol // boolean var from UnSelHol fmSelHol
         then // the new station is selected  StationList from UnitStat
           fmSelEph.SiteCooEph:=StationList[fmSelHol.NumSelHol]; // to new station
       fmSelEph.edSite.Text:=fmSelEph.SiteCooEph.name; // station indentification
     end; // 'P'
    'O' :
     begin
       fmSelSat.CapSelSat:=' .'; // UnSelSat
       fmSelSat.ShowModal; // UnSelSat
       if  fmSelSat.BooSelSat // boolean var from UnSelSat
         then // object is selected from the list
           begin // but may be planet or satellite
             nt:=fmSelSat.NumSelTop;  // number in ObjectTopHeap^[]
             CharBodEph:=ObjectTopHeap^[nt].chps; // body
             case  CharBodEph  of // UnGloVar
               'S' :  // 'S' for the satellite
               begin
                 ns:=ObjectTopHeap^[nt].nall; // number of satellite in SatElemHeap^[]
                 if  SatElemHeap^[ns].satname
                        = fmSelEph.SatElemEph.satname
                   then  Exit ; // the same satellite
                 fmSelEph.SaoElemEph:=SatElemHeap^[ns]; // satellite elements
                 fmSelEph.edSite.Text:=SaoElemEph.satname; // satellite identification
                 fmSelEph.SiteCooEph.name:=fmSelEph.edSite.Text;
               end;
               'P' :  // 'P' for the planet
               begin
                 ns:=ObjectTopHeap^[nt].nall; // planet number
                 if  ns = NEarth  then  Exit; // without Earth
                 NumberBody:=ns;              // planet name
                 fmSelEph.edSite.Text:=ObjectTopHeap^[nt].name;
                 fmSelEph.SiteCooEph.name:=fmSelEph.edSite.Text;
               end;
             end; // case CharBodEph
           end;
     end; // 'O'
  end; { case CharForEphem }
end;

procedure TfmSelEph.ButSatlClick(Sender: TObject); // to new satellite
var
  nt,ns  : LongInt ; // numbers in ObjectTopHeap^[] SatElemHeap^[] UnCoTVar
begin // to change satellite
  fmSelSat.CapSelSat:=' .'; // UnSelSat
  fmSelSat.ShowModal; // UnSelSat
  if  fmSelSat.BooSelSat // boolean var from UnSelSat
    then // object is selected from the list
      begin // but may be planet
        nt:=fmSelSat.NumSelTop;  // number in ObjectTopHeap^[]
        if  ObjectTopHeap^[nt].chps <> 'S'  then  Exit ; // no satellite
        ns:=ObjectTopHeap^[nt].nall; // number of satellite in SatElemHeap^[]
        if  SatElemHeap^[ns].satname
            = fmSelEph.SaoElemEph.satname
           then  Exit ; // the same satellite
        fmSelEph.SatElemEph:=SatElemHeap^[ns]; // satellite elements
        fmSelEph.edSatl.Text:=SatElemEph.satname; // satellite identification
      end;
end;

procedure TfmSelEph.udStepClick(Sender: TObject; Button: TUDBtnType);
begin // control to select value for step to output information
  if  fmSelEph.udStep.Position > 16
    then
      fmSelEph.udStep.Position:=1
    else
      if  fmSelEph.udStep.Position < 1
        then
          fmSelEph.udStep.Position:=16;
  fmSelEph.edStep.Text:=IntToStr(ToGetStepPrint(fmSelEph.udStep.Position));
end;

procedure TfmSelEph.udLatmClick(Sender: TObject; Button: TUDBtnType);
begin // control to select value for minimum latitude in degree
  if  fmSelEph.udLatm.Position > 7
    then
      fmSelEph.udLatm.Position:=1
    else
      if  fmSelEph.udLatm.Position < 1
        then
          fmSelEph.udLatm.Position:=7;
  fmSelEph.edLatm.Text:=IntToStr(ToGetLatmVal(fmSelEph.udLatm.Position));
end;


procedure TfmSelEph.GroupBoxClick(Sender: TObject);
begin
  with  fmSelEph  do  // procedure from UnGraBmp
     PuzSaveBmp(ClientWidth,ClientHeight,
                Width,Height,3,3,Canvas);
end;

end.
