unit UnSelFel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl;

type
  TfmSelFel = class(TForm)
    FileElemBox: TFileListBox;
    MemoFile: TMemo;
    ButtonSel: TButton;
    ButtonEsc: TButton;
    ListBoxText: TListBox;
    ButtonFol: TButton;
    procedure FormActivate(Sender: TObject);
    procedure FileElemBoxChange(Sender: TObject);
    procedure FileElemBoxKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonSelClick(Sender: TObject);
    procedure ButtonEscClick(Sender: TObject);
    procedure FileElemBoxClick(Sender: TObject);
    procedure ListBoxTextClick(Sender: TObject);
    procedure ListBoxTextKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonFolClick(Sender: TObject);
    procedure FileElemBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    procedure FileTextToList ;
  public
    { Public declarations }
    stPathFel  : ShortString ; // path to folder with files that needed
    BooSelFel  : Boolean ;     // yes or no for choosing
    BofSelFel  : Boolean ;     // yes if button folders is clicked
    BinSelFel  : Boolean ;     // file to select may be binary
    StrSelFel  : ShortString ; // for name of file with elements or stations
    SenderFel  : TObject ;
  end;

var
  fmSelFel: TfmSelFel;

implementation

{$R *.DFM}

uses
  UnGloVar , // for stPathElem
  UnGraBmp ; // for PuzSaveBmp procedure

procedure TfmSelFel.FormActivate(Sender: TObject);
begin
  BooSelFel:=False; // no choice file
  BofSelfel:=False; // no click button folders
  StrSelFel:='';
  fmSelFel.FileElemBox.ApplyFilePath(fmSelFel.stPathFel);
  if  fmSelFel.FileElemBox.Items.Count > 0
    then
      begin
        fmSelFel.FileElemBox.ItemIndex:=0;
        fmSelFel.FileElemBoxChange(Sender);
      end;
end;

procedure TfmSelFel.FileTextToList ;
begin
  if  fmSelFel.BinSelFel  then  Exit ;
  fmSelFel.ListBoxText.Items.Clear;
  fmSelFel.ListBoxText.Items.LoadFromFile(fmSelFel.FileElemBox.FileName);
end;

procedure TfmSelFel.FileElemBoxChange(Sender: TObject);
begin
  fmSelFel.MemoFile.Lines[0]:=fmSelFel.FileElemBox.FileName;
  fmSelFel.ListBoxText.Clear;
  fmSelFel.ListBoxText.Items.Add('  '+fmSelFel.FileElemBox.FileName);
  if  not fmSelFel.BinSelFel
    then
      fmSelFel.ListBoxText.Items.Add('     ');
end;

procedure TfmSelFel.FileElemBoxKeyPress(Sender: TObject; var Key: Char);
var
  ch  : Char ;
begin
  ch:=UpCase(Key);
  if  ch in [ 'Q' , #27 ]  then  fmSelFel.ButtonEscClick(Sender); // exit
  if  ch = #13  then  fmSelFel.ButtonSelClick(Sender); // enter
end;

procedure TfmSelFel.ButtonFolClick(Sender: TObject);
begin
  BofSelFel:=True;
  SenderFel:=Sender;
  Close ; // for form UnSelFel
end;

procedure TfmSelFel.ButtonSelClick(Sender: TObject);
begin
  BooSelFel:=True; // file is selected
  StrSelFel:=fmSelFel.FileElemBox.FileName;
  Close ; // for form UnSelFel
end;

procedure TfmSelFel.ButtonEscClick(Sender: TObject);
begin
  BooSelFel:=False;
  Close ; // for form UnSelFel
end;

procedure TfmSelFel.FileElemBoxClick(Sender: TObject);
begin
  if  fmSelFel.BinSelFel  then  Exit ; // no text for binary file
  fmSelFel.FileTextToList ;
end;

procedure TfmSelFel.ListBoxTextClick(Sender: TObject);
begin
  if  fmSelFel.BinSelFel  then  Exit ;
  fmSelFel.FileElemBoxClick(Sender);
end;

procedure TfmSelFel.ListBoxTextKeyPress(Sender: TObject; var Key: Char);
var
  ch  : Char ;
begin
  ch:=UpCase(Key);
  if  ch in [ 'Q' , #27 ]  then  fmSelFel.ButtonEscClick(Sender); // exit
  if  ch = #13  then  fmSelFel.ButtonSelClick(Sender); // enter
end;

procedure TfmSelFel.FileElemBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  ( Key = Ord('S') ) and ( Shift = [ ssCtrl ] )
    then // to save
      with  fmSelFel  do  // procedure from UnGraBmp
        PuzSaveBmp(ClientWidth,ClientHeight,
                   Width,Height,3,3,Canvas);
end;

end.
