unit UnSelFol;

interface

uses
  Windows, Messages, SysUtils, FileCtrl, Classes,
  Controls, Graphics, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TfmSelFol = class(TForm)
    DriveComboBox: TDriveComboBox;
    DirListBox: TDirectoryListBox;
    BitBtnSel: TBitBtn;
    BitBtnEsc: TBitBtn;
    MemoPath: TMemo;
    FileListBox: TFileListBox;
    procedure DirListBoxChange(Sender: TObject);
    procedure BitBtnSelClick(Sender: TObject);
    procedure BitBtnEscClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure DirListBoxKeyPress(Sender: TObject; var Key: Char);
    procedure DirListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    StrSelFolText  : ShortString ;
  public
    { Public declarations }
    BooSelectFolder  : Boolean ;
    StrSelFolLabelCap  : ShortString ;
    StrFolderWithPath  : ShortString ;
  end;

var
  fmSelFol: TfmSelFol;

implementation

uses
  UnGraBmp ; // for procedure PuzSaveBmp

{$R *.DFM}

procedure TfmSelFol.DirListBoxChange(Sender: TObject);
begin
  fmSelFol.MemoPath.Lines[0]:=StrSelFolText
                             +fmSelFol.DirListBox.Directory+'\''';
end;

function ToSelectFolder  : Boolean ;
begin
  ToSelectFolder:=fmSelFol.BooSelectFolder;
end;

procedure TfmSelFol.BitBtnSelClick(Sender: TObject);
begin
  fmSelFol.BooSelectFolder:=True;
  fmSelFol.StrFolderWithPath:=fmSelFol.DirListBox.Directory;
  Close;
end;

procedure TfmSelFol.BitBtnEscClick(Sender: TObject);
begin
  fmSelFol.BooSelectFolder:=False;
  fmSelFol.StrFolderWithPath:='';
  Close;
end;

procedure TfmSelFol.FormPaint(Sender: TObject);
begin
  fmSelFol.Caption:=fmSelFol.StrSelFolLabelCap;
  StrSelFolText:=' : ''';
  fmSelFol.MemoPath.Lines[0]:=StrSelFolText
                             +fmSelFol.DirListBox.Directory+'\''';
  BooSelectFolder:=False;
  StrFolderWithPath:='';
  fmSelFol.DirListBox.SetFocus;
end;

procedure TfmSelFol.DirListBoxKeyPress(Sender: TObject; var Key: Char);
var
  ch  : Char ;
begin
  ch:=UpCase(Key);
  if  ch in [ 'Q' , #27 ]  then  fmSelFol.BitBtnEscClick(Sender); // exit
  if  ch = #13  then  fmSelFol.BitBtnSelClick(Sender); // enter
end;

procedure TfmSelFol.DirListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  ( Key = Ord('S') ) and ( Shift = [ ssCtrl ] )
    then // to save
      with  fmSelFol  do  // procedure from UnGraBmp
        PuzSaveBmp(ClientWidth,ClientHeight,
                   Width,Height,3,3,Canvas);
end;

end.
