unit UnSelHol;

interface

uses
  Windows, Messages, SysUtils, FileCtrl, Classes,
  Controls, Graphics, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TfmSelHol = class(TForm)
    BitSel: TBitBtn;
    BitEsc: TBitBtn;
    Memo: TMemo;
    ListBox: TListBox;
    ButtonAdd: TButton;
    procedure BitSelClick(Sender: TObject);
    procedure BitEscClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure ListBoxKeyPress(Sender: TObject; var Key: Char);
    procedure ListBoxDblClick(Sender: TObject);
    procedure ButtonAddClick(Sender: TObject);
    procedure ListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    AllSelHol  : LongInt ;
    StrSelHol  : ShortString ;
    procedure ToAddStrings ;  // to add string to memolist
  public
    { Public declarations }
    CapSelHol  : ShortString ;
    BooSelHol  : Boolean ;
    BoaSelHol  : Boolean ; // true if ButtonAdd is clicked
    NumSelHol  : LongInt ;
    AddSelHol  : Byte ;
    SenderHol  : TObject ;
  end;

var
  fmSelHol: TfmSelHol;

implementation

{$R *.DFM}

uses
  UnitStat , // for record StationList[] of TPlaceCoor
  UnGraBmp ; // for procedure PuzSaveBmp

procedure TfmSelHol.BitSelClick(Sender: TObject);
begin
  fmSelHol.BooSelHol:=True;
  Close;
end;

procedure TfmSelHol.BitEscClick(Sender: TObject);
begin
  fmSelHol.BooSelHol:=False;
  Close;
end;

procedure TfmSelHol.ToAddStrings ;  // to add string to memolist
var
  n  : LongInt ;
  s  : ShortString ;
begin
  case  fmSelHol.AddSelHol  of
    0  : begin
           fmSelHol.Memo.Lines.Insert(0,'    ');
           fmSelHol.Memo.Lines.Add(fmSelHol.CapSelHol);
           fmSelHol.Memo.Lines.Add(fmSelHol.StrSelHol);
         end;
    1  : begin // for station position
           fmSelHol.Memo.Lines.Add(fmSelHol.StrSelHol); // simple name
           n:=fmSelHol.NumSelHol; // number of string in list
           Str(StationList[n].f:10:3,s); // latitude in degree
           fmSelHol.Memo.Lines.Add('  '+s+' ');
           Str(StationList[n].l:10:3,s); // longitude in degree
           fmSelHol.Memo.Lines.Add(' '+s+' ');
           Str(StationList[n].h:10:1,s); // height in metre
           fmSelHol.Memo.Lines.Add('  '+s+' ');
         end;
  end; // case to add string to memolist
end;

procedure TfmSelHol.FormPaint(Sender: TObject);
var
  n  : LongInt ;
begin
  fmSelHol.Color:=clGreen;
  fmSelHol.Caption:=' . '+fmSelHol.CapSelHol;
  fmSelHol.ListBox.Color:=clYellow;
  fmSelHol.BooSelHol:=False;
  fmSelHol.BoaSelHol:=False;
  n:=fmSelHol.ListBox.ItemIndex+1;
  if  n < 1
    then
      n:=1;
  fmSelHol.NumSelHol:=n;
  fmSelHol.StrSelHol:=fmSelHol.ListBox.Items[n-1];
  fmSelHol.Memo.Visible:=True;
  fmSelHol.Memo.Color:=clLime;
  fmSelHol.Memo.Clear;
  fmSelHol.Memo.Lines.Add('  '+IntToStr(NumSelHol)+
                          '.   '+IntToStr(AllSelHol)+' ');
  fmSelHol.ToAddStrings;
end;

procedure TfmSelHol.FormActivate(Sender: TObject);
begin
  fmSelHol.ListBox.Visible:=True;
  fmSelHol.ListBox.Visible:=True;
  fmSelHol.AllSelHol:=fmSelHol.ListBox.Items.Count;
  fmSelHol.BitSel.Visible:=True;
  fmSelHol.BitEsc.Visible:=True;
end;

procedure TfmSelHol.ListBoxClick(Sender: TObject);
begin
  fmSelHol.NumSelHol:=fmSelHol.ListBox.ItemIndex+1;
  fmSelHol.StrSelHol:=fmSelHol.ListBox.Items[fmSelHol.ListBox.ItemIndex];
  fmSelHol.Memo.Clear;
  fmSelHol.Memo.Lines.Add('  '+IntToStr(NumSelHol)+
                          '.   '+IntToStr(AllSelHol)+' ');
  fmSelHol.ToAddStrings ;
end;

procedure TfmSelHol.ListBoxKeyPress(Sender: TObject; var Key: Char);
var
  ch  : Char ;
begin
  ch:=UpCase(Key);
  if  ch in [ #27 , 'Q' ]  then  fmSelHol.BitEscClick(Sender); // to exit
  if  ch =  #13  then  fmSelHol.BitSelClick(Sender); // to select
end;

procedure TfmSelHol.ListBoxDblClick(Sender: TObject);
begin
  fmSelHol.BitSelClick(Sender);
end;

procedure TfmSelHol.ButtonAddClick(Sender: TObject);
begin
  fmSelHol.BoaSelHol:=True;
  fmSelHol.SenderHol:=Sender;
  Close;
end;

procedure TfmSelHol.ListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  ( Key = Ord('S') ) and ( Shift = [ ssCtrl ] )
    then // to save
      with  fmSelHol  do  // procedure from UnGraBmp
        PuzSaveBmp(ClientWidth,ClientHeight,
                   Width,Height,3,3,Canvas);
end;

end.
