unit UnSelSat;

interface

uses
  Windows, Messages, SysUtils, FileCtrl, Classes,
  Controls, Graphics, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TfmSelSat = class(TForm)
    BitSel: TBitBtn;
    BitEsc: TBitBtn;
    MemoSat: TMemo;
    ListSat: TListBox;
    Panel: TPanel;
    CheckBoxVis: TCheckBox;
    rbAlph: TRadioButton;
    rbMot: TRadioButton;
    rbEcc: TRadioButton;
    rbIncl: TRadioButton;
    rbRange: TRadioButton;
    rbAltit: TRadioButton;
    LabelCap: TLabel;
    procedure BitSelClick(Sender: TObject);
    procedure BitEscClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ListSatClick(Sender: TObject);
    procedure ListSatKeyPress(Sender: TObject; var Key: Char);
    procedure ListSatDblClick(Sender: TObject);
    procedure CheckBoxVisClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure rbAlphClick(Sender: TObject);
    procedure rbMotClick(Sender: TObject);
    procedure rbEccClick(Sender: TObject);
    procedure rbInclClick(Sender: TObject);
    procedure rbRangeClick(Sender: TObject);
    procedure rbAltitClick(Sender: TObject);
    procedure ListSatKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    NumSelSat  : LongInt ;
    AllSelSat  : LongInt ;
    procedure PutMemoSatInf( k  : LongInt );
    procedure PutMemoInform;
    procedure ListSatForVis;
    procedure ToFillListSat;
    procedure ToListSatInit;
    procedure RadButChecked;
  public
    { Public declarations }
    CapSelSat  : ShortString ;
    BooSelSat  : Boolean ;
    StrSelSat  : ShortString ;
    NumSelTop  : LongInt ;
  end;

var
  fmSelSat: TfmSelSat;

implementation

{$R *.DFM}

uses
  UnCoTVar , // for ObjectTopHeap^ SatElemHeap^ ObjectSort^
  UnitSort , // for proc ShellMethodForSatName ToGet ToFree MemForOrder
  UnGraBmp ; // for PuzSaveBmp procedure

procedure TfmSelSat.BitSelClick(Sender: TObject);
var
  k  : LongInt ;
begin
  fmSelSat.BooSelSat:=True;
  k:=ObjectSort^[fmSelSat.NumSelSat]; // number in ObjectTopHeap^[]
  fmSelSat.NumSelTop:=k; // number in ObjectTopHeap^[]
  Close;
end;

procedure TfmSelSat.BitEscClick(Sender: TObject);
begin
  fmSelSat.BooSelSat:=False;
  fmSelSat.NumSelTop:=-1;
  Close;
end;

procedure TfmSelSat.PutMemoSatInf( k  : LongInt );
var
  n  : LongInt ;
  s  : ShortString ;
begin
  if  ObjectTopHeap^[k].chps = 'S'
    then // only for Earth artificial satellite
      begin // ObjectTopHeap SatElemheap from UnCotVar
        n:=ObjectTopHeap^[k].nall; // number of satellite in SatElemHeap
        Str(SatElemHeap^[n].an:10:6,s);
        fmSelSat.MemoSat.Lines.Add('   n ='+s);
        Str(SatElemHeap^[n].ae:10:6,s);
        fmSelSat.MemoSat.Lines.Add('    e ='+s);
        Str(SatElemHeap^[n].ai:10:4,s);
        fmSelSat.MemoSat.Lines.Add('    i ='+s);
      end;
end;

procedure TfmSelSat.PutMemoInform;
var
  k  : LongInt ;
  h  : ShortString ;
  s  : ShortString ;
begin
  s:=' '+IntToStr(fmSelSat.NumSelSat)
              +'  '+IntToStr(AllSelSat)+' ';
  fmSelSat.MemoSat.Lines.Add(s);
  s:=fmSelSat.StrSelSat; // name of satellite
  k:=ObjectSort^[fmSelSat.NumSelSat]; // number in ObjectTopHeap^[]
  Str(ObjectTopHeap^[k].alt:7:1,h);
  s:=s+'  '+h+'';
  if ObjectTopHeap^[k].boovis
    then
      begin
        fmSelSat.MemoSat.Color:=clAqua;
        fmSelSat.MemoSat.Lines.Add(s+'   ')
      end
    else
      begin
        fmSelSat.MemoSat.Color:=clLime;
        fmSelSat.MemoSat.Lines.Add(s+'   ');
      end;
  fmSelSat.PutMemoSatInf(k);
end;

procedure TfmSelSat.ListSatForVis ;
var
  i  : LongInt ;
  n  : LongInt ;
  s  : ShortString ;
begin
  fmSelSat.ListSat.Clear;
  n:=0;
  for i:=1 to NumObjectInHeap do // the first for visibility
    if  ( ObjectTopHeap^[i].chps <> '*' ) and  ObjectTopHeap^[i].boovis
      then // only for visibility
        begin
          s:='     '+ObjectTopHeap^[i].name;
          fmSelSat.ListSat.Items.Add(s);
          n:=n+1;
          ObjectSort^[n]:=i; // heap ObjectSort^[] from UnCoTVar
        end;
  for i:=1 to NumObjectInHeap do // the second if not visibility
    if  ( ObjectTopHeap^[i].chps <> '*' ) and ( not ObjectTopHeap^[i].boovis )
      then // only for not visibility
        begin
          s:='     '+ObjectTopHeap^[i].name;
          fmSelSat.ListSat.Items.Add(s);
          n:=n+1;
          ObjectSort^[n]:=i; // heap ObjectSort^[] from UnCoTVar
        end;
end;

procedure TfmSelSat.ToFillListSat ;
var
  i  : LongInt ;
  n  : LongInt ;
  s  : ShortString ;
begin
  fmSelSat.ListSat.Clear;
  n:=0; // var NumFirstSatHeap is assigned in UnForSat by SatelliteToHeap
  for i:=1 to NumObjectInHeap do
    if  ObjectTopHeap^[i].chps <> '*'
      then
        begin
          s:='     '+ObjectTopHeap^[i].name;
          fmSelSat.ListSat.Items.Add(s);
          n:=n+1;
          ObjectSort^[n]:=i; // heap ObjectSort^[] from UnCoTVar
        end;
end;

procedure TfmSelSat.RadButChecked; // some action of one of rb is checked
begin // procedures from UnitSort
  if   rbAlph.Checked  then  ShellMethodForSatName(NumFirstSatHeap);
  if    rbMot.Checked  then  ShellMethodForElem('n',NumFirstSatHeap);
  if    rbEcc.Checked  then  ShellMethodForElem('e',NumFirstSatHeap);
  if   rbIncl.Checked  then  ShellMethodForElem('i',NumFirstSatHeap);
  if  rbRange.Checked  then  ShellMethodForParm('r',NumFirstSatHeap);
  if  rbAltit.Checked  then  ShellMethodForParm('h',NumFirstSatHeap);
end;

procedure TfmSelSat.ToListSatInit; // after event FormPaint
begin
  fmSelSat.ListSat.Sorted:=False;
  fmSelSat.ListSat.Columns:=4;
  fmSelSat.Color:=clGreen;
  fmSelSat.Caption:=' . '+CapSelSat;
  fmSelSat.ListSat.Color:=clYellow;
  case  fmSelSat.CheckBoxVis.State  of
    cbChecked    : fmSelSat.ListSatForVis ;
    cbUnChecked  : fmSelSat.ToFillListSat ;
  end; // case CheckBox
  fmSelSat.AllSelSat:=fmSelSat.ListSat.Items.Count;
  fmSelSat.ListSat.Visible:=True;
  fmSelSat.ListSat.Visible:=True;
  fmSelSat.BooSelSat:=False;
end;

procedure TfmSelSat.FormPaint(Sender: TObject);
var
  n  : LongInt ;
begin
  fmSelSat.ToListSatInit;
  fmSelSat.MemoSat.Visible:=True;
  n:=fmSelSat.ListSat.ItemIndex+1;
  if  n < 1  then  n:=1;
  fmSelSat.NumSelSat:=n;
  fmSelSat.ListSat.ItemIndex:=n-1;
  fmSelSat.StrSelSat:=fmSelSat.ListSat.Items[n-1];
  fmSelSat.MemoSat.Clear;
  fmSelSat.PutMemoInform;
  fmSelSat.BitSel.Visible:=True;
  fmSelSat.BitEsc.Visible:=True;
  fmSelSat.ListSat.SetFocus;
end;

procedure TfmSelSat.ListSatClick(Sender: TObject);
begin
  fmSelSat.NumSelSat:=fmSelSat.ListSat.ItemIndex+1;
  fmSelSat.StrSelSat:=fmSelSat.ListSat.Items[fmSelSat.ListSat.ItemIndex];
  fmSelSat.MemoSat.Clear;
  fmSelSat.PutMemoInform;
end;

procedure TfmSelSat.ListSatKeyPress(Sender: TObject; var Key: Char);
var
  ch  : Char ;
begin
  ch:=UpCase(Key);
  if  ch in [ 'Q' , #27 ]  then  fmSelSat.BitEscClick(Sender);
  if  ch = #13  then  fmSelSat.BitSelClick(Sender);
end;

procedure TfmSelSat.ListSatDblClick(Sender: TObject);
begin
  fmSelSat.BitSelClick(Sender);
end;

procedure TfmSelSat.CheckBoxVisClick(Sender: TObject);
begin
  fmSelSat.RadButChecked;
  fmSelSat.MemoSat.Clear;
  case  fmSelSat.CheckBoxVis.State  of
    cbChecked    : fmSelSat.ListSatForVis ;
    cbUnChecked  : fmSelSat.ToFillListSat ;
  end; // case CheckBox
  fmSelSat.ListSat.ItemIndex:=0;
  fmSelSat.ListSatClick(Sender);
  fmSelSat.ListSat.SetFocus;
end;

procedure TfmSelSat.FormActivate(Sender: TObject);
begin
  ToGetMemForOrder ; // UnitSort  for ObjectSOrt^[] IntDimForOrder^[]
  fmSelSat.CheckBoxVis.State:=cbUnChecked;
  fmSelSat.rbAlph.Checked:=True;
  fmSelSat.RadButChecked;
end;

procedure TfmSelSat.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ToFreeMemForOrder ; // UnitSort  for ObjectSort^[] IntDimForOrder^[]
end;

procedure TfmSelSat.rbAlphClick(Sender: TObject);
begin
  fmSelSat.CheckBoxVisClick(Sender);
end;

procedure TfmSelSat.rbMotClick(Sender: TObject);
begin
  fmSelSat.CheckBoxVisClick(Sender);
end;

procedure TfmSelSat.rbEccClick(Sender: TObject);
begin
  fmSelSat.CheckBoxVisClick(Sender);
end;

procedure TfmSelSat.rbInclClick(Sender: TObject);
begin
  fmSelSat.CheckBoxVisClick(Sender);
end;

procedure TfmSelSat.rbRangeClick(Sender: TObject);
begin
  fmSelSat.CheckBoxVisClick(Sender);
end;

procedure TfmSelSat.rbAltitClick(Sender: TObject);
begin
  fmSelSat.CheckBoxVisClick(Sender);
end;

procedure TfmSelSat.ListSatKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  ( Key = Ord('S') ) and ( Shift = [ ssCtrl ] )
    then // to save
      with  fmSelSat  do  // procedure from UnGraBmp
        PuzSaveBmp(ClientWidth,ClientHeight,
                   Width,Height,3,3,Canvas);
end;

end.
